/*
 * QEMU model of the DDRC ddrc
 *
 * Copyright (c) 2015 Xilinx Inc.
 *
 * Autogenerated by xregqemu.py 2015-09-16.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#include "qemu/osdep.h"
#include "hw/sysbus.h"
#include "hw/register-dep.h"
#include "qemu/bitops.h"
#include "qemu/log.h"

#ifndef XILINX_DDRC_ERR_DEBUG
#define XILINX_DDRC_ERR_DEBUG 0
#endif

#define TYPE_XILINX_DDRC "xlnx.zynqmp-ddrc"

#define XILINX_DDRC(obj) \
     OBJECT_CHECK(DDRC, (obj), TYPE_XILINX_DDRC)

DEP_REG32(MSTR, 0x0)
    DEP_FIELD(MSTR, DEVICE_CONFIG, 2, 30)
    DEP_FIELD(MSTR, FREQUENCY_MODE, 1, 29)
    DEP_FIELD(MSTR, ACTIVE_RANKS, 2, 24)
    DEP_FIELD(MSTR, BURST_RDWR, 4, 16)
    DEP_FIELD(MSTR, DLL_OFF_MODE, 1, 15)
    DEP_FIELD(MSTR, DATA_BUS_WIDTH, 2, 12)
    DEP_FIELD(MSTR, GEARDOWN_MODE, 1, 11)
    DEP_FIELD(MSTR, EN_2T_TIMING_MODE, 1, 10)
    DEP_FIELD(MSTR, BURSTCHOP, 1, 9)
    DEP_FIELD(MSTR, LPDDR4, 1, 5)
    DEP_FIELD(MSTR, DDR4, 1, 4)
    DEP_FIELD(MSTR, LPDDR3, 1, 3)
    DEP_FIELD(MSTR, LPDDR2, 1, 2)
    DEP_FIELD(MSTR, DDR3, 1, 0)
DEP_REG32(STAT, 0x4)
    DEP_FIELD(STAT, SELFREF_STATE, 2, 8)
    DEP_FIELD(STAT, SELFREF_TYPE, 2, 4)
    DEP_FIELD(STAT, OPERATING_MODE, 3, 0)
DEP_REG32(MRCTRL0, 0x10)
    DEP_FIELD(MRCTRL0, MR_WR, 1, 31)
    DEP_FIELD(MRCTRL0, MR_ADDR, 4, 12)
    DEP_FIELD(MRCTRL0, MR_RANK, 2, 4)
    DEP_FIELD(MRCTRL0, SW_INIT_INT, 1, 3)
    DEP_FIELD(MRCTRL0, PDA_EN, 1, 2)
    DEP_FIELD(MRCTRL0, MPR_EN, 1, 1)
    DEP_FIELD(MRCTRL0, MR_TYPE, 1, 0)
DEP_REG32(MRCTRL1, 0x14)
    DEP_FIELD(MRCTRL1, MR_DATA, 18, 0)
DEP_REG32(MRSTAT, 0x18)
    DEP_FIELD(MRSTAT, PDA_DONE, 1, 8)
    DEP_FIELD(MRSTAT, MR_WR_BUSY, 1, 0)
DEP_REG32(MRCTRL2, 0x1c)
DEP_REG32(DERATEEN, 0x20)
    DEP_FIELD(DERATEEN, RC_DERATE_VALUE, 2, 8)
    DEP_FIELD(DERATEEN, DERATE_BYTE, 4, 4)
    DEP_FIELD(DERATEEN, DERATE_VALUE, 1, 1)
    DEP_FIELD(DERATEEN, DERATE_ENABLE, 1, 0)
DEP_REG32(DERATEINT, 0x24)
DEP_REG32(PWRCTL, 0x30)
    DEP_FIELD(PWRCTL, STAY_IN_SELFREF, 1, 6)
    DEP_FIELD(PWRCTL, SELFREF_SW, 1, 5)
    DEP_FIELD(PWRCTL, MPSM_EN, 1, 4)
    DEP_FIELD(PWRCTL, EN_DFI_DRAM_CLK_DISABLE, 1, 3)
    DEP_FIELD(PWRCTL, DEEPPOWERDOWN_EN, 1, 2)
    DEP_FIELD(PWRCTL, POWERDOWN_EN, 1, 1)
    DEP_FIELD(PWRCTL, SELFREF_EN, 1, 0)
DEP_REG32(PWRTMG, 0x34)
    DEP_FIELD(PWRTMG, SELFREF_TO_X32, 8, 16)
    DEP_FIELD(PWRTMG, T_DPD_X4096, 8, 8)
    DEP_FIELD(PWRTMG, POWERDOWN_TO_X32, 5, 0)
DEP_REG32(HWLPCTL, 0x38)
    DEP_FIELD(HWLPCTL, HW_LP_IDLE_X32, 12, 16)
    DEP_FIELD(HWLPCTL, HW_LP_EXIT_IDLE_EN, 1, 1)
    DEP_FIELD(HWLPCTL, HW_LP_EN, 1, 0)
DEP_REG32(RFSHCTL0, 0x50)
    DEP_FIELD(RFSHCTL0, REFRESH_MARGIN, 4, 20)
    DEP_FIELD(RFSHCTL0, REFRESH_TO_X32, 5, 12)
    DEP_FIELD(RFSHCTL0, REFRESH_BURST, 5, 4)
    DEP_FIELD(RFSHCTL0, PER_BANK_REFRESH, 1, 2)
DEP_REG32(RFSHCTL1, 0x54)
    DEP_FIELD(RFSHCTL1, REFRESH_TIMER1_START_VALUE_X32, 12, 16)
    DEP_FIELD(RFSHCTL1, REFRESH_TIMER0_START_VALUE_X32, 12, 0)
DEP_REG32(RFSHCTL3, 0x60)
    DEP_FIELD(RFSHCTL3, REFRESH_MODE, 3, 4)
    DEP_FIELD(RFSHCTL3, REFRESH_UPDATE_LEVEL, 1, 1)
    DEP_FIELD(RFSHCTL3, DIS_AUTO_REFRESH, 1, 0)
DEP_REG32(RFSHTMG, 0x64)
    DEP_FIELD(RFSHTMG, T_RFC_NOM_X32, 12, 16)
    DEP_FIELD(RFSHTMG, LPDDR3_TREFBW_EN, 1, 15)
    DEP_FIELD(RFSHTMG, T_RFC_MIN, 10, 0)
DEP_REG32(ECCCFG0, 0x70)
    DEP_FIELD(ECCCFG0, DIS_SCRUB, 1, 4)
    DEP_FIELD(ECCCFG0, ECC_MODE, 3, 0)
DEP_REG32(ECCCFG1, 0x74)
    DEP_FIELD(ECCCFG1, DATA_POISON_BIT, 1, 1)
    DEP_FIELD(ECCCFG1, DATA_POISON_EN, 1, 0)
DEP_REG32(ECCSTAT, 0x78)
    DEP_FIELD(ECCSTAT, ECC_UNCORRECTED_ERR, 4, 16)
    DEP_FIELD(ECCSTAT, ECC_CORRECTED_ERR, 4, 8)
    DEP_FIELD(ECCSTAT, ECC_CORRECTED_BIT_NUM, 7, 0)
DEP_REG32(ECCCLR, 0x7c)
    DEP_FIELD(ECCCLR, ECC_CLR_UNCORR_ERR_CNT, 1, 3)
    DEP_FIELD(ECCCLR, ECC_CLR_CORR_ERR_CNT, 1, 2)
    DEP_FIELD(ECCCLR, ECC_CLR_UNCORR_ERR, 1, 1)
    DEP_FIELD(ECCCLR, ECC_CLR_CORR_ERR, 1, 0)
DEP_REG32(ECCERRCNT, 0x80)
    DEP_FIELD(ECCERRCNT, ECC_UNCORR_ERR_CNT, 16, 16)
    DEP_FIELD(ECCERRCNT, ECC_CORR_ERR_CNT, 16, 0)
DEP_REG32(ECCCADDR0, 0x84)
    DEP_FIELD(ECCCADDR0, ECC_CORR_RANK, 1, 24)
    DEP_FIELD(ECCCADDR0, ECC_CORR_ROW, 18, 0)
DEP_REG32(ECCCADDR1, 0x88)
    DEP_FIELD(ECCCADDR1, ECC_CORR_BG, 2, 24)
    DEP_FIELD(ECCCADDR1, ECC_CORR_BANK, 3, 16)
    DEP_FIELD(ECCCADDR1, ECC_CORR_COL, 12, 0)
DEP_REG32(ECCCSYN0, 0x8c)
DEP_REG32(ECCCSYN1, 0x90)
DEP_REG32(ECCCSYN2, 0x94)
    DEP_FIELD(ECCCSYN2, ECC_CORR_SYNDROMES_71_64, 8, 0)
DEP_REG32(ECCBITMASK0, 0x98)
DEP_REG32(ECCBITMASK1, 0x9c)
DEP_REG32(ECCBITMASK2, 0xa0)
    DEP_FIELD(ECCBITMASK2, ECC_CORR_BIT_MASK_71_64, 8, 0)
DEP_REG32(ECCUADDR0, 0xa4)
    DEP_FIELD(ECCUADDR0, ECC_UNCORR_RANK, 1, 24)
    DEP_FIELD(ECCUADDR0, ECC_UNCORR_ROW, 18, 0)
DEP_REG32(ECCUADDR1, 0xa8)
    DEP_FIELD(ECCUADDR1, ECC_UNCORR_BG, 2, 24)
    DEP_FIELD(ECCUADDR1, ECC_UNCORR_BANK, 3, 16)
    DEP_FIELD(ECCUADDR1, ECC_UNCORR_COL, 12, 0)
DEP_REG32(ECCUSYN0, 0xac)
DEP_REG32(ECCUSYN1, 0xb0)
DEP_REG32(ECCUSYN2, 0xb4)
    DEP_FIELD(ECCUSYN2, ECC_UNCORR_SYNDROMES_71_64, 8, 0)
DEP_REG32(ECCPOISONADDR0, 0xb8)
    DEP_FIELD(ECCPOISONADDR0, ECC_POISON_RANK, 1, 24)
    DEP_FIELD(ECCPOISONADDR0, ECC_POISON_COL, 12, 0)
DEP_REG32(ECCPOISONADDR1, 0xbc)
    DEP_FIELD(ECCPOISONADDR1, ECC_POISON_BG, 2, 28)
    DEP_FIELD(ECCPOISONADDR1, ECC_POISON_BANK, 3, 24)
    DEP_FIELD(ECCPOISONADDR1, ECC_POISON_ROW, 18, 0)
DEP_REG32(CRCPARCTL0, 0xc0)
    DEP_FIELD(CRCPARCTL0, RETRY_CTRLUPD_ENABLE, 1, 15)
    DEP_FIELD(CRCPARCTL0, DFI_ALERT_ERR_MAX_REACHED_INT_CLR, 1, 8)
    DEP_FIELD(CRCPARCTL0, DFI_ALERT_ERR_FATL_INT_CLR, 1, 4)
    DEP_FIELD(CRCPARCTL0, DFI_ALERT_ERR_CNT_CLR, 1, 2)
    DEP_FIELD(CRCPARCTL0, DFI_ALERT_ERR_INT_CLR, 1, 1)
    DEP_FIELD(CRCPARCTL0, DFI_ALERT_ERR_INT_EN, 1, 0)
DEP_REG32(CRCPARCTL1, 0xc4)
    DEP_FIELD(CRCPARCTL1, DFI_T_PHY_RDLAT, 6, 24)
    DEP_FIELD(CRCPARCTL1, ALERT_WAIT_FOR_SW, 1, 9)
    DEP_FIELD(CRCPARCTL1, CRC_PARITY_RETRY_ENABLE, 1, 8)
    DEP_FIELD(CRCPARCTL1, CRC_INC_DM, 1, 7)
    DEP_FIELD(CRCPARCTL1, CRC_ENABLE, 1, 4)
    DEP_FIELD(CRCPARCTL1, PARITY_ENABLE, 1, 0)
DEP_REG32(CRCPARCTL2, 0xc8)
    DEP_FIELD(CRCPARCTL2, T_PAR_ALERT_PW_MAX, 9, 16)
    DEP_FIELD(CRCPARCTL2, T_CRC_ALERT_PW_MAX, 5, 8)
    DEP_FIELD(CRCPARCTL2, RETRY_FIFO_MAX_HOLD_TIMER_X4, 6, 0)
DEP_REG32(CRCPARSTAT, 0xcc)
    DEP_FIELD(CRCPARSTAT, CMD_IN_ERR_WINDOW, 1, 29)
    DEP_FIELD(CRCPARSTAT, RETRY_OPERATING_MODE, 1, 28)
    DEP_FIELD(CRCPARSTAT, DFI_ALERT_ERR_FATL_CODE, 3, 20)
    DEP_FIELD(CRCPARSTAT, DFI_ALERT_ERR_NO_SW, 1, 19)
    DEP_FIELD(CRCPARSTAT, DFI_ALERT_ERR_MAX_REACHED_INT, 1, 18)
    DEP_FIELD(CRCPARSTAT, DFI_ALERT_ERR_FATL_INT, 1, 17)
    DEP_FIELD(CRCPARSTAT, DFI_ALERT_ERR_INT, 1, 16)
    DEP_FIELD(CRCPARSTAT, DFI_ALERT_ERR_CNT, 16, 0)
DEP_REG32(INIT0, 0xd0)
    DEP_FIELD(INIT0, SKIP_DRAM_INIT, 2, 30)
    DEP_FIELD(INIT0, POST_CKE_X1024, 10, 16)
    DEP_FIELD(INIT0, PRE_CKE_X1024, 12, 0)
DEP_REG32(INIT1, 0xd4)
    DEP_FIELD(INIT1, DRAM_RSTN_X1024, 9, 16)
    DEP_FIELD(INIT1, FINAL_WAIT_X32, 7, 8)
    DEP_FIELD(INIT1, PRE_OCD_X32, 4, 0)
DEP_REG32(INIT2, 0xd8)
    DEP_FIELD(INIT2, IDLE_AFTER_RESET_X32, 8, 8)
    DEP_FIELD(INIT2, MIN_STABLE_CLOCK_X1, 4, 0)
DEP_REG32(INIT3, 0xdc)
    DEP_FIELD(INIT3, MR, 16, 16)
    DEP_FIELD(INIT3, EMR, 16, 0)
DEP_REG32(INIT4, 0xe0)
    DEP_FIELD(INIT4, EMR2, 16, 16)
    DEP_FIELD(INIT4, EMR3, 16, 0)
DEP_REG32(INIT5, 0xe4)
    DEP_FIELD(INIT5, DEV_ZQINIT_X32, 8, 16)
    DEP_FIELD(INIT5, MAX_AUTO_INIT_X1024, 10, 0)
DEP_REG32(INIT6, 0xe8)
    DEP_FIELD(INIT6, MR4, 16, 16)
    DEP_FIELD(INIT6, MR5, 16, 0)
DEP_REG32(INIT7, 0xec)
    DEP_FIELD(INIT7, MR6, 16, 16)
DEP_REG32(DIMMCTL, 0xf0)
    DEP_FIELD(DIMMCTL, DIMM_DIS_BG_MIRRORING, 1, 5)
    DEP_FIELD(DIMMCTL, MRS_BG1_EN, 1, 4)
    DEP_FIELD(DIMMCTL, MRS_A17_EN, 1, 3)
    DEP_FIELD(DIMMCTL, DIMM_OUTPUT_INV_EN, 1, 2)
    DEP_FIELD(DIMMCTL, DIMM_ADDR_MIRR_EN, 1, 1)
    DEP_FIELD(DIMMCTL, DIMM_STAGGER_CS_EN, 1, 0)
DEP_REG32(RANKCTL, 0xf4)
    DEP_FIELD(RANKCTL, DIFF_RANK_WR_GAP, 4, 8)
    DEP_FIELD(RANKCTL, DIFF_RANK_RD_GAP, 4, 4)
    DEP_FIELD(RANKCTL, MAX_RANK_RD, 4, 0)
DEP_REG32(DRAMTMG0, 0x100)
    DEP_FIELD(DRAMTMG0, WR2PRE, 7, 24)
    DEP_FIELD(DRAMTMG0, T_FAW, 6, 16)
    DEP_FIELD(DRAMTMG0, T_RAS_MAX, 7, 8)
    DEP_FIELD(DRAMTMG0, T_RAS_MIN, 6, 0)
DEP_REG32(DRAMTMG1, 0x104)
    DEP_FIELD(DRAMTMG1, T_XP, 5, 16)
    DEP_FIELD(DRAMTMG1, RD2PRE, 5, 8)
    DEP_FIELD(DRAMTMG1, T_RC, 7, 0)
DEP_REG32(DRAMTMG2, 0x108)
    DEP_FIELD(DRAMTMG2, WRITE_LATENCY, 6, 24)
    DEP_FIELD(DRAMTMG2, READ_LATENCY, 6, 16)
    DEP_FIELD(DRAMTMG2, RD2WR, 6, 8)
    DEP_FIELD(DRAMTMG2, WR2RD, 6, 0)
DEP_REG32(DRAMTMG3, 0x10c)
    DEP_FIELD(DRAMTMG3, T_MRW, 10, 20)
    DEP_FIELD(DRAMTMG3, T_MRD, 6, 12)
    DEP_FIELD(DRAMTMG3, T_MOD, 10, 0)
DEP_REG32(DRAMTMG4, 0x110)
    DEP_FIELD(DRAMTMG4, T_RCD, 5, 24)
    DEP_FIELD(DRAMTMG4, T_CCD, 4, 16)
    DEP_FIELD(DRAMTMG4, T_RRD, 4, 8)
    DEP_FIELD(DRAMTMG4, T_RP, 5, 0)
DEP_REG32(DRAMTMG5, 0x114)
    DEP_FIELD(DRAMTMG5, T_CKSRX, 4, 24)
    DEP_FIELD(DRAMTMG5, T_CKSRE, 4, 16)
    DEP_FIELD(DRAMTMG5, T_CKESR, 6, 8)
    DEP_FIELD(DRAMTMG5, T_CKE, 5, 0)
DEP_REG32(DRAMTMG6, 0x118)
    DEP_FIELD(DRAMTMG6, T_CKDPDE, 4, 24)
    DEP_FIELD(DRAMTMG6, T_CKDPDX, 4, 16)
    DEP_FIELD(DRAMTMG6, T_CKCSX, 4, 0)
DEP_REG32(DRAMTMG7, 0x11c)
    DEP_FIELD(DRAMTMG7, T_CKPDE, 4, 8)
    DEP_FIELD(DRAMTMG7, T_CKPDX, 4, 0)
DEP_REG32(DRAMTMG8, 0x120)
    DEP_FIELD(DRAMTMG8, T_XS_FAST_X32, 7, 24)
    DEP_FIELD(DRAMTMG8, T_XS_ABORT_X32, 7, 16)
    DEP_FIELD(DRAMTMG8, T_XS_DLL_X32, 7, 8)
    DEP_FIELD(DRAMTMG8, T_XS_X32, 7, 0)
DEP_REG32(DRAMTMG9, 0x124)
    DEP_FIELD(DRAMTMG9, DDR4_WR_PREAMBLE, 1, 30)
    DEP_FIELD(DRAMTMG9, T_CCD_S, 3, 16)
    DEP_FIELD(DRAMTMG9, T_RRD_S, 4, 8)
    DEP_FIELD(DRAMTMG9, WR2RD_S, 6, 0)
DEP_REG32(DRAMTMG10, 0x128)
    DEP_FIELD(DRAMTMG10, T_SYNC_GEAR, 5, 16)
    DEP_FIELD(DRAMTMG10, T_CMD_GEAR, 5, 8)
    DEP_FIELD(DRAMTMG10, T_GEAR_SETUP, 2, 2)
    DEP_FIELD(DRAMTMG10, T_GEAR_HOLD, 2, 0)
DEP_REG32(DRAMTMG11, 0x12c)
    DEP_FIELD(DRAMTMG11, POST_MPSM_GAP_X32, 7, 24)
    DEP_FIELD(DRAMTMG11, T_MPX_LH, 5, 16)
    DEP_FIELD(DRAMTMG11, T_MPX_S, 2, 8)
    DEP_FIELD(DRAMTMG11, T_CKMPE, 5, 0)
DEP_REG32(DRAMTMG12, 0x130)
    DEP_FIELD(DRAMTMG12, T_CMDCKE, 2, 16)
    DEP_FIELD(DRAMTMG12, T_CKEHCMD, 4, 8)
    DEP_FIELD(DRAMTMG12, T_MRD_PDA, 5, 0)
DEP_REG32(DRAMTMG13, 0x134)
    DEP_FIELD(DRAMTMG13, ODTLOFF, 7, 24)
    DEP_FIELD(DRAMTMG13, T_CCD_MW, 6, 16)
    DEP_FIELD(DRAMTMG13, T_PPD, 3, 0)
DEP_REG32(DRAMTMG14, 0x138)
    DEP_FIELD(DRAMTMG14, T_XSR, 12, 0)
DEP_REG32(ZQCTL0, 0x180)
    DEP_FIELD(ZQCTL0, DIS_AUTO_ZQ, 1, 31)
    DEP_FIELD(ZQCTL0, DIS_SRX_ZQCL, 1, 30)
    DEP_FIELD(ZQCTL0, ZQ_RESISTOR_SHARED, 1, 29)
    DEP_FIELD(ZQCTL0, DIS_MPSMX_ZQCL, 1, 28)
    DEP_FIELD(ZQCTL0, T_ZQ_LONG_NOP, 11, 16)
    DEP_FIELD(ZQCTL0, T_ZQ_SHORT_NOP, 10, 0)
DEP_REG32(ZQCTL1, 0x184)
    DEP_FIELD(ZQCTL1, T_ZQ_RESET_NOP, 10, 20)
    DEP_FIELD(ZQCTL1, T_ZQ_SHORT_INTERVAL_X1024, 20, 0)
DEP_REG32(ZQCTL2, 0x188)
    DEP_FIELD(ZQCTL2, ZQ_RESET, 1, 0)
DEP_REG32(ZQSTAT, 0x18c)
    DEP_FIELD(ZQSTAT, ZQ_RESET_BUSY, 1, 0)
DEP_REG32(DFITMG0, 0x190)
    DEP_FIELD(DFITMG0, DFI_T_CTRL_DELAY, 5, 24)
    DEP_FIELD(DFITMG0, DFI_RDDATA_USE_SDR, 1, 23)
    DEP_FIELD(DFITMG0, DFI_T_RDDATA_EN, 6, 16)
    DEP_FIELD(DFITMG0, DFI_WRDATA_USE_SDR, 1, 15)
    DEP_FIELD(DFITMG0, DFI_TPHY_WRDATA, 6, 8)
    DEP_FIELD(DFITMG0, DFI_TPHY_WRLAT, 6, 0)
DEP_REG32(DFITMG1, 0x194)
    DEP_FIELD(DFITMG1, DFI_T_CMD_LAT, 4, 28)
    DEP_FIELD(DFITMG1, DFI_T_PARIN_LAT, 2, 24)
    DEP_FIELD(DFITMG1, DFI_T_WRDATA_DELAY, 5, 16)
    DEP_FIELD(DFITMG1, DFI_T_DRAM_CLK_DISABLE, 4, 8)
    DEP_FIELD(DFITMG1, DFI_T_DRAM_CLK_ENABLE, 4, 0)
DEP_REG32(DFILPCFG0, 0x198)
    DEP_FIELD(DFILPCFG0, DFI_TLP_RESP, 4, 24)
    DEP_FIELD(DFILPCFG0, DFI_LP_WAKEUP_DPD, 4, 20)
    DEP_FIELD(DFILPCFG0, DFI_LP_EN_DPD, 1, 16)
    DEP_FIELD(DFILPCFG0, DFI_LP_WAKEUP_SR, 4, 12)
    DEP_FIELD(DFILPCFG0, DFI_LP_EN_SR, 1, 8)
    DEP_FIELD(DFILPCFG0, DFI_LP_WAKEUP_PD, 4, 4)
    DEP_FIELD(DFILPCFG0, DFI_LP_EN_PD, 1, 0)
DEP_REG32(DFILPCFG1, 0x19c)
    DEP_FIELD(DFILPCFG1, DFI_LP_WAKEUP_MPSM, 4, 4)
    DEP_FIELD(DFILPCFG1, DFI_LP_EN_MPSM, 1, 0)
DEP_REG32(DFIUPD0, 0x1a0)
    DEP_FIELD(DFIUPD0, DIS_AUTO_CTRLUPD, 1, 31)
    DEP_FIELD(DFIUPD0, DIS_AUTO_CTRLUPD_SRX, 1, 30)
    DEP_FIELD(DFIUPD0, DFI_T_CTRLUP_MAX, 10, 16)
    DEP_FIELD(DFIUPD0, DFI_T_CTRLUP_MIN, 10, 0)
DEP_REG32(DFIUPD1, 0x1a4)
    DEP_FIELD(DFIUPD1, DFI_T_CTRLUPD_INTERVAL_MIN_X1024, 8, 16)
    DEP_FIELD(DFIUPD1, DFI_T_CTRLUPD_INTERVAL_MAX_X1024, 8, 0)
DEP_REG32(DFIUPD2, 0x1a8)
    DEP_FIELD(DFIUPD2, DFI_PHYUPD_EN, 1, 31)
DEP_REG32(DFIMISC, 0x1b0)
    DEP_FIELD(DFIMISC, DFI_DATA_CS_POLARITY, 1, 2)
    DEP_FIELD(DFIMISC, PHY_DBI_MODE, 1, 1)
    DEP_FIELD(DFIMISC, DFI_INIT_COMPLETE_EN, 1, 0)
DEP_REG32(DFITMG2, 0x1b4)
    DEP_FIELD(DFITMG2, DFI_TPHY_RDCSLAT, 6, 8)
    DEP_FIELD(DFITMG2, DFI_TPHY_WRCSLAT, 6, 0)
DEP_REG32(DBICTL, 0x1c0)
    DEP_FIELD(DBICTL, RD_DBI_EN, 1, 2)
    DEP_FIELD(DBICTL, WR_DBI_EN, 1, 1)
    DEP_FIELD(DBICTL, DM_EN, 1, 0)
DEP_REG32(ADDRMAP0, 0x200)
    DEP_FIELD(ADDRMAP0, ADDRMAP_CS_BIT0, 5, 0)
DEP_REG32(ADDRMAP1, 0x204)
    DEP_FIELD(ADDRMAP1, ADDRMAP_BANK_B2, 5, 16)
    DEP_FIELD(ADDRMAP1, ADDRMAP_BANK_B1, 5, 8)
    DEP_FIELD(ADDRMAP1, ADDRMAP_BANK_B0, 5, 0)
DEP_REG32(ADDRMAP2, 0x208)
    DEP_FIELD(ADDRMAP2, ADDRMAP_COL_B5, 4, 24)
    DEP_FIELD(ADDRMAP2, ADDRMAP_COL_B4, 4, 16)
    DEP_FIELD(ADDRMAP2, ADDRMAP_COL_B3, 4, 8)
    DEP_FIELD(ADDRMAP2, ADDRMAP_COL_B2, 4, 0)
DEP_REG32(ADDRMAP3, 0x20c)
    DEP_FIELD(ADDRMAP3, ADDRMAP_COL_B9, 4, 24)
    DEP_FIELD(ADDRMAP3, ADDRMAP_COL_B8, 4, 16)
    DEP_FIELD(ADDRMAP3, ADDRMAP_COL_B7, 4, 8)
    DEP_FIELD(ADDRMAP3, ADDRMAP_COL_B6, 4, 0)
DEP_REG32(ADDRMAP4, 0x210)
    DEP_FIELD(ADDRMAP4, ADDRMAP_COL_B11, 4, 8)
    DEP_FIELD(ADDRMAP4, ADDRMAP_COL_B10, 4, 0)
DEP_REG32(ADDRMAP5, 0x214)
    DEP_FIELD(ADDRMAP5, ADDRMAP_ROW_B11, 4, 24)
    DEP_FIELD(ADDRMAP5, ADDRMAP_ROW_B2_10, 4, 16)
    DEP_FIELD(ADDRMAP5, ADDRMAP_ROW_B1, 4, 8)
    DEP_FIELD(ADDRMAP5, ADDRMAP_ROW_B0, 4, 0)
DEP_REG32(ADDRMAP6, 0x218)
    DEP_FIELD(ADDRMAP6, LPDDR3_6GB_12GB, 1, 31)
    DEP_FIELD(ADDRMAP6, ADDRMAP_ROW_B15, 4, 24)
    DEP_FIELD(ADDRMAP6, ADDRMAP_ROW_B14, 4, 16)
    DEP_FIELD(ADDRMAP6, ADDRMAP_ROW_B13, 4, 8)
    DEP_FIELD(ADDRMAP6, ADDRMAP_ROW_B12, 4, 0)
DEP_REG32(ADDRMAP7, 0x21c)
    DEP_FIELD(ADDRMAP7, ADDRMAP_ROW_B17, 4, 8)
    DEP_FIELD(ADDRMAP7, ADDRMAP_ROW_B16, 4, 0)
DEP_REG32(ADDRMAP8, 0x220)
    DEP_FIELD(ADDRMAP8, ADDRMAP_BG_B1, 5, 8)
    DEP_FIELD(ADDRMAP8, ADDRMAP_BG_B0, 5, 0)
DEP_REG32(ADDRMAP9, 0x224)
    DEP_FIELD(ADDRMAP9, ADDRMAP_ROW_B5, 4, 24)
    DEP_FIELD(ADDRMAP9, ADDRMAP_ROW_B4, 4, 16)
    DEP_FIELD(ADDRMAP9, ADDRMAP_ROW_B3, 4, 8)
    DEP_FIELD(ADDRMAP9, ADDRMAP_ROW_B2, 4, 0)
DEP_REG32(ADDRMAP10, 0x228)
    DEP_FIELD(ADDRMAP10, ADDRMAP_ROW_B9, 4, 24)
    DEP_FIELD(ADDRMAP10, ADDRMAP_ROW_B8, 4, 16)
    DEP_FIELD(ADDRMAP10, ADDRMAP_ROW_B7, 4, 8)
    DEP_FIELD(ADDRMAP10, ADDRMAP_ROW_B6, 4, 0)
DEP_REG32(ADDRMAP11, 0x22c)
    DEP_FIELD(ADDRMAP11, ADDRMAP_ROW_B10, 4, 0)
DEP_REG32(ODTCFG, 0x240)
    DEP_FIELD(ODTCFG, WR_ODT_HOLD, 4, 24)
    DEP_FIELD(ODTCFG, WR_ODT_DELAY, 5, 16)
    DEP_FIELD(ODTCFG, RD_ODT_HOLD, 4, 8)
    DEP_FIELD(ODTCFG, RD_ODT_DELAY, 5, 2)
DEP_REG32(ODTMAP, 0x244)
    DEP_FIELD(ODTMAP, RANK1_RD_ODT, 2, 12)
    DEP_FIELD(ODTMAP, RANK1_WR_ODT, 2, 8)
    DEP_FIELD(ODTMAP, RANK0_RD_ODT, 2, 4)
    DEP_FIELD(ODTMAP, RANK0_WR_ODT, 2, 0)
DEP_REG32(SCHED, 0x250)
    DEP_FIELD(SCHED, RDWR_IDLE_GAP, 7, 24)
    DEP_FIELD(SCHED, GO2CRITICAL_HYSTERESIS, 8, 16)
    DEP_FIELD(SCHED, LPR_NUM_ENTRIES, 6, 8)
    DEP_FIELD(SCHED, PAGECLOSE, 1, 2)
    DEP_FIELD(SCHED, PREFER_WRITE, 1, 1)
    DEP_FIELD(SCHED, FORCE_LOW_PRI_N, 1, 0)
DEP_REG32(SCHED1, 0x254)
    DEP_FIELD(SCHED1, PAGECLOSE_TIMER, 8, 0)
DEP_REG32(PERFHPR1, 0x25c)
    DEP_FIELD(PERFHPR1, HPR_XACT_RUN_LENGTH, 8, 24)
    DEP_FIELD(PERFHPR1, HPR_MAX_STARVE, 16, 0)
DEP_REG32(PERFLPR1, 0x264)
    DEP_FIELD(PERFLPR1, LPR_XACT_RUN_LENGTH, 8, 24)
    DEP_FIELD(PERFLPR1, LPR_MAX_STARVE, 16, 0)
DEP_REG32(PERFWR1, 0x26c)
    DEP_FIELD(PERFWR1, W_XACT_RUN_LENGTH, 8, 24)
    DEP_FIELD(PERFWR1, W_MAX_STARVE, 16, 0)
DEP_REG32(PERFVPR1, 0x274)
    DEP_FIELD(PERFVPR1, VPR_TIMEOUT_RANGE, 11, 0)
DEP_REG32(PERFVPW1, 0x278)
    DEP_FIELD(PERFVPW1, VPW_TIMEOUT_RANGE, 11, 0)
DEP_REG32(DQMAP0, 0x280)
    DEP_FIELD(DQMAP0, DQ_NIBBLE_MAP_12_15, 8, 24)
    DEP_FIELD(DQMAP0, DQ_NIBBLE_MAP_8_11, 8, 16)
    DEP_FIELD(DQMAP0, DQ_NIBBLE_MAP_4_7, 8, 8)
    DEP_FIELD(DQMAP0, DQ_NIBBLE_MAP_0_3, 8, 0)
DEP_REG32(DQMAP1, 0x284)
    DEP_FIELD(DQMAP1, DQ_NIBBLE_MAP_28_31, 8, 24)
    DEP_FIELD(DQMAP1, DQ_NIBBLE_MAP_24_27, 8, 16)
    DEP_FIELD(DQMAP1, DQ_NIBBLE_MAP_20_23, 8, 8)
    DEP_FIELD(DQMAP1, DQ_NIBBLE_MAP_16_19, 8, 0)
DEP_REG32(DQMAP2, 0x288)
    DEP_FIELD(DQMAP2, DQ_NIBBLE_MAP_44_47, 8, 24)
    DEP_FIELD(DQMAP2, DQ_NIBBLE_MAP_40_43, 8, 16)
    DEP_FIELD(DQMAP2, DQ_NIBBLE_MAP_36_39, 8, 8)
    DEP_FIELD(DQMAP2, DQ_NIBBLE_MAP_32_35, 8, 0)
DEP_REG32(DQMAP3, 0x28c)
    DEP_FIELD(DQMAP3, DQ_NIBBLE_MAP_60_63, 8, 24)
    DEP_FIELD(DQMAP3, DQ_NIBBLE_MAP_56_59, 8, 16)
    DEP_FIELD(DQMAP3, DQ_NIBBLE_MAP_52_55, 8, 8)
    DEP_FIELD(DQMAP3, DQ_NIBBLE_MAP_48_51, 8, 0)
DEP_REG32(DQMAP4, 0x290)
    DEP_FIELD(DQMAP4, DQ_NIBBLE_MAP_CB_4_7, 8, 8)
    DEP_FIELD(DQMAP4, DQ_NIBBLE_MAP_CB_0_3, 8, 0)
DEP_REG32(DQMAP5, 0x294)
    DEP_FIELD(DQMAP5, DIS_DQ_RANK_SWAP, 1, 0)
DEP_REG32(DBG0, 0x300)
    DEP_FIELD(DBG0, DIS_COLLISION_PAGE_OPT, 1, 4)
    DEP_FIELD(DBG0, DIS_WC, 1, 0)
DEP_REG32(DBG1, 0x304)
    DEP_FIELD(DBG1, DIS_HIF, 1, 1)
    DEP_FIELD(DBG1, DIS_DQ, 1, 0)
DEP_REG32(DBGCAM, 0x308)
    DEP_FIELD(DBGCAM, DBG_STALL_RD, 1, 31)
    DEP_FIELD(DBGCAM, DBG_STALL_WR, 1, 30)
    DEP_FIELD(DBGCAM, WR_DATA_PIPELINE_EMPTY, 1, 29)
    DEP_FIELD(DBGCAM, RD_DATA_PIPELINE_EMPTY, 1, 28)
    DEP_FIELD(DBGCAM, DBG_WR_Q_EMPTY, 1, 26)
    DEP_FIELD(DBGCAM, DBG_RD_Q_EMPTY, 1, 25)
    DEP_FIELD(DBGCAM, DBG_STALL, 1, 24)
    DEP_FIELD(DBGCAM, DBG_W_Q_DEPTH, 7, 16)
    DEP_FIELD(DBGCAM, DBG_LPR_Q_DEPTH, 7, 8)
    DEP_FIELD(DBGCAM, DBG_HPR_Q_DEPTH, 7, 0)
DEP_REG32(DBGCMD, 0x30c)
    DEP_FIELD(DBGCMD, HW_REF_ZQ_EN, 1, 31)
    DEP_FIELD(DBGCMD, CTRLUPD, 1, 5)
    DEP_FIELD(DBGCMD, ZQ_CALIB_SHORT, 1, 4)
    DEP_FIELD(DBGCMD, RANK1_REFRESH, 1, 1)
    DEP_FIELD(DBGCMD, RANK0_REFRESH, 1, 0)
DEP_REG32(DBGSTAT, 0x310)
    DEP_FIELD(DBGSTAT, CTRLUPD_BUSY, 1, 5)
    DEP_FIELD(DBGSTAT, ZQ_CALIB_SHORT_BUSY, 1, 4)
    DEP_FIELD(DBGSTAT, RANK1_REFRESH_BUSY, 1, 1)
    DEP_FIELD(DBGSTAT, RANK0_REFRESH_BUSY, 1, 0)
DEP_REG32(SWCTL, 0x320)
    DEP_FIELD(SWCTL, SW_DONE, 1, 0)
DEP_REG32(SWSTAT, 0x324)
    DEP_FIELD(SWSTAT, SW_DONE_ACK, 1, 0)
DEP_REG32(POISONCFG, 0x36c)
    DEP_FIELD(POISONCFG, RD_POISON_INTR_CLR, 1, 24)
    DEP_FIELD(POISONCFG, RD_POISON_INTR_EN, 1, 20)
    DEP_FIELD(POISONCFG, RD_POISON_SLVERR_EN, 1, 16)
    DEP_FIELD(POISONCFG, WR_POISON_INTR_CLR, 1, 8)
    DEP_FIELD(POISONCFG, WR_POISON_INTR_EN, 1, 4)
    DEP_FIELD(POISONCFG, WR_POISON_SLVERR_EN, 1, 0)
DEP_REG32(POISONSTAT, 0x370)
    DEP_FIELD(POISONSTAT, RD_POISON_INTR_5, 1, 21)
    DEP_FIELD(POISONSTAT, RD_POISON_INTR_4, 1, 20)
    DEP_FIELD(POISONSTAT, RD_POISON_INTR_3, 1, 19)
    DEP_FIELD(POISONSTAT, RD_POISON_INTR_2, 1, 18)
    DEP_FIELD(POISONSTAT, RD_POISON_INTR_1, 1, 17)
    DEP_FIELD(POISONSTAT, RD_POISON_INTR_0, 1, 16)
    DEP_FIELD(POISONSTAT, WR_POISON_INTR_5, 1, 5)
    DEP_FIELD(POISONSTAT, WR_POISON_INTR_4, 1, 4)
    DEP_FIELD(POISONSTAT, WR_POISON_INTR_3, 1, 3)
    DEP_FIELD(POISONSTAT, WR_POISON_INTR_2, 1, 2)
    DEP_FIELD(POISONSTAT, WR_POISON_INTR_1, 1, 1)
    DEP_FIELD(POISONSTAT, WR_POISON_INTR_0, 1, 0)
DEP_REG32(PSTAT, 0x3fc)
    DEP_FIELD(PSTAT, WR_PORT_BUSY_5, 1, 21)
    DEP_FIELD(PSTAT, WR_PORT_BUSY_4, 1, 20)
    DEP_FIELD(PSTAT, WR_PORT_BUSY_3, 1, 19)
    DEP_FIELD(PSTAT, WR_PORT_BUSY_2, 1, 18)
    DEP_FIELD(PSTAT, WR_PORT_BUSY_1, 1, 17)
    DEP_FIELD(PSTAT, WR_PORT_BUSY_0, 1, 16)
    DEP_FIELD(PSTAT, RD_PORT_BUSY_5, 1, 5)
    DEP_FIELD(PSTAT, RD_PORT_BUSY_4, 1, 4)
    DEP_FIELD(PSTAT, RD_PORT_BUSY_3, 1, 3)
    DEP_FIELD(PSTAT, RD_PORT_BUSY_2, 1, 2)
    DEP_FIELD(PSTAT, RD_PORT_BUSY_1, 1, 1)
    DEP_FIELD(PSTAT, RD_PORT_BUSY_0, 1, 0)
DEP_REG32(PCCFG, 0x400)
    DEP_FIELD(PCCFG, BL_EXP_MODE, 1, 8)
    DEP_FIELD(PCCFG, PAGEMATCH_LIMIT, 1, 4)
    DEP_FIELD(PCCFG, GO2CRITICAL_EN, 1, 0)
DEP_REG32(PCFGR_0, 0x404)
    DEP_FIELD(PCFGR_0, RD_PORT_PAGEMATCH_EN, 1, 14)
    DEP_FIELD(PCFGR_0, RD_PORT_URGENT_EN, 1, 13)
    DEP_FIELD(PCFGR_0, RD_PORT_AGING_EN, 1, 12)
    DEP_FIELD(PCFGR_0, RD_PORT_PRIORITY, 10, 0)
DEP_REG32(PCFGW_0, 0x408)
    DEP_FIELD(PCFGW_0, WR_PORT_PAGEMATCH_EN, 1, 14)
    DEP_FIELD(PCFGW_0, WR_PORT_URGENT_EN, 1, 13)
    DEP_FIELD(PCFGW_0, WR_PORT_AGING_EN, 1, 12)
    DEP_FIELD(PCFGW_0, WR_PORT_PRIORITY, 10, 0)
DEP_REG32(PCTRL_0, 0x490)
    DEP_FIELD(PCTRL_0, PORT_EN, 1, 0)
DEP_REG32(PCFGQOS0_0, 0x494)
    DEP_FIELD(PCFGQOS0_0, RQOS_MAP_REGION1, 2, 20)
    DEP_FIELD(PCFGQOS0_0, RQOS_MAP_REGION0, 2, 16)
    DEP_FIELD(PCFGQOS0_0, RQOS_MAP_LEVEL1, 4, 0)
DEP_REG32(PCFGQOS1_0, 0x498)
    DEP_FIELD(PCFGQOS1_0, RQOS_MAP_TIMEOUTR, 11, 16)
    DEP_FIELD(PCFGQOS1_0, RQOS_MAP_TIMEOUTB, 11, 0)
DEP_REG32(PCFGWQOS0_0, 0x49c)
    DEP_FIELD(PCFGWQOS0_0, WQOS_MAP_REGION1, 2, 20)
    DEP_FIELD(PCFGWQOS0_0, WQOS_MAP_REGION0, 2, 16)
    DEP_FIELD(PCFGWQOS0_0, WQOS_MAP_LEVEL, 4, 0)
DEP_REG32(PCFGWQOS1_0, 0x4a0)
    DEP_FIELD(PCFGWQOS1_0, WQOS_MAP_TIMEOUT, 11, 0)
DEP_REG32(PCFGR_1, 0x4b4)
    DEP_FIELD(PCFGR_1, RD_PORT_PAGEMATCH_EN, 1, 14)
    DEP_FIELD(PCFGR_1, RD_PORT_URGENT_EN, 1, 13)
    DEP_FIELD(PCFGR_1, RD_PORT_AGING_EN, 1, 12)
    DEP_FIELD(PCFGR_1, RD_PORT_PRIORITY, 10, 0)
DEP_REG32(PCFGW_1, 0x4b8)
    DEP_FIELD(PCFGW_1, WR_PORT_PAGEMATCH_EN, 1, 14)
    DEP_FIELD(PCFGW_1, WR_PORT_URGENT_EN, 1, 13)
    DEP_FIELD(PCFGW_1, WR_PORT_AGING_EN, 1, 12)
    DEP_FIELD(PCFGW_1, WR_PORT_PRIORITY, 10, 0)
DEP_REG32(PCTRL_1, 0x540)
    DEP_FIELD(PCTRL_1, PORT_EN, 1, 0)
DEP_REG32(PCFGQOS0_1, 0x544)
    DEP_FIELD(PCFGQOS0_1, RQOS_MAP_REGION2, 2, 24)
    DEP_FIELD(PCFGQOS0_1, RQOS_MAP_REGION1, 2, 20)
    DEP_FIELD(PCFGQOS0_1, RQOS_MAP_REGION0, 2, 16)
    DEP_FIELD(PCFGQOS0_1, RQOS_MAP_LEVEL2, 4, 8)
    DEP_FIELD(PCFGQOS0_1, RQOS_MAP_LEVEL1, 4, 0)
DEP_REG32(PCFGQOS1_1, 0x548)
    DEP_FIELD(PCFGQOS1_1, RQOS_MAP_TIMEOUTR, 11, 16)
    DEP_FIELD(PCFGQOS1_1, RQOS_MAP_TIMEOUTB, 11, 0)
DEP_REG32(PCFGWQOS0_1, 0x54c)
    DEP_FIELD(PCFGWQOS0_1, WQOS_MAP_REGION1, 2, 20)
    DEP_FIELD(PCFGWQOS0_1, WQOS_MAP_REGION0, 2, 16)
    DEP_FIELD(PCFGWQOS0_1, WQOS_MAP_LEVEL, 4, 0)
DEP_REG32(PCFGWQOS1_1, 0x550)
    DEP_FIELD(PCFGWQOS1_1, WQOS_MAP_TIMEOUT, 11, 0)
DEP_REG32(PCFGR_2, 0x564)
    DEP_FIELD(PCFGR_2, RD_PORT_PAGEMATCH_EN, 1, 14)
    DEP_FIELD(PCFGR_2, RD_PORT_URGENT_EN, 1, 13)
    DEP_FIELD(PCFGR_2, RD_PORT_AGING_EN, 1, 12)
    DEP_FIELD(PCFGR_2, RD_PORT_PRIORITY, 10, 0)
DEP_REG32(PCFGW_2, 0x568)
    DEP_FIELD(PCFGW_2, WR_PORT_PAGEMATCH_EN, 1, 14)
    DEP_FIELD(PCFGW_2, WR_PORT_URGENT_EN, 1, 13)
    DEP_FIELD(PCFGW_2, WR_PORT_AGING_EN, 1, 12)
    DEP_FIELD(PCFGW_2, WR_PORT_PRIORITY, 10, 0)
DEP_REG32(PCTRL_2, 0x5f0)
    DEP_FIELD(PCTRL_2, PORT_EN, 1, 0)
DEP_REG32(PCFGQOS0_2, 0x5f4)
    DEP_FIELD(PCFGQOS0_2, RQOS_MAP_REGION2, 2, 24)
    DEP_FIELD(PCFGQOS0_2, RQOS_MAP_REGION1, 2, 20)
    DEP_FIELD(PCFGQOS0_2, RQOS_MAP_REGION0, 2, 16)
    DEP_FIELD(PCFGQOS0_2, RQOS_MAP_LEVEL2, 4, 8)
    DEP_FIELD(PCFGQOS0_2, RQOS_MAP_LEVEL1, 4, 0)
DEP_REG32(PCFGQOS1_2, 0x5f8)
    DEP_FIELD(PCFGQOS1_2, RQOS_MAP_TIMEOUTR, 11, 16)
    DEP_FIELD(PCFGQOS1_2, RQOS_MAP_TIMEOUTB, 11, 0)
DEP_REG32(PCFGWQOS0_2, 0x5fc)
    DEP_FIELD(PCFGWQOS0_2, WQOS_MAP_REGION1, 2, 20)
    DEP_FIELD(PCFGWQOS0_2, WQOS_MAP_REGION0, 2, 16)
    DEP_FIELD(PCFGWQOS0_2, WQOS_MAP_LEVEL, 4, 0)
DEP_REG32(PCFGWQOS1_2, 0x600)
    DEP_FIELD(PCFGWQOS1_2, WQOS_MAP_TIMEOUT, 11, 0)
DEP_REG32(PCFGR_3, 0x614)
    DEP_FIELD(PCFGR_3, RD_PORT_PAGEMATCH_EN, 1, 14)
    DEP_FIELD(PCFGR_3, RD_PORT_URGENT_EN, 1, 13)
    DEP_FIELD(PCFGR_3, RD_PORT_AGING_EN, 1, 12)
    DEP_FIELD(PCFGR_3, RD_PORT_PRIORITY, 10, 0)
DEP_REG32(PCFGW_3, 0x618)
    DEP_FIELD(PCFGW_3, WR_PORT_PAGEMATCH_EN, 1, 14)
    DEP_FIELD(PCFGW_3, WR_PORT_URGENT_EN, 1, 13)
    DEP_FIELD(PCFGW_3, WR_PORT_AGING_EN, 1, 12)
    DEP_FIELD(PCFGW_3, WR_PORT_PRIORITY, 10, 0)
DEP_REG32(PCTRL_3, 0x6a0)
    DEP_FIELD(PCTRL_3, PORT_EN, 1, 0)
DEP_REG32(PCFGQOS0_3, 0x6a4)
    DEP_FIELD(PCFGQOS0_3, RQOS_MAP_REGION1, 2, 20)
    DEP_FIELD(PCFGQOS0_3, RQOS_MAP_REGION0, 2, 16)
    DEP_FIELD(PCFGQOS0_3, RQOS_MAP_LEVEL1, 4, 0)
DEP_REG32(PCFGQOS1_3, 0x6a8)
    DEP_FIELD(PCFGQOS1_3, RQOS_MAP_TIMEOUTR, 11, 16)
    DEP_FIELD(PCFGQOS1_3, RQOS_MAP_TIMEOUTB, 11, 0)
DEP_REG32(PCFGWQOS0_3, 0x6ac)
    DEP_FIELD(PCFGWQOS0_3, WQOS_MAP_REGION1, 2, 20)
    DEP_FIELD(PCFGWQOS0_3, WQOS_MAP_REGION0, 2, 16)
    DEP_FIELD(PCFGWQOS0_3, WQOS_MAP_LEVEL, 4, 0)
DEP_REG32(PCFGWQOS1_3, 0x6b0)
    DEP_FIELD(PCFGWQOS1_3, WQOS_MAP_TIMEOUT, 11, 0)
DEP_REG32(PCFGR_4, 0x6c4)
    DEP_FIELD(PCFGR_4, RD_PORT_PAGEMATCH_EN, 1, 14)
    DEP_FIELD(PCFGR_4, RD_PORT_URGENT_EN, 1, 13)
    DEP_FIELD(PCFGR_4, RD_PORT_AGING_EN, 1, 12)
    DEP_FIELD(PCFGR_4, RD_PORT_PRIORITY, 10, 0)
DEP_REG32(PCFGW_4, 0x6c8)
    DEP_FIELD(PCFGW_4, WR_PORT_PAGEMATCH_EN, 1, 14)
    DEP_FIELD(PCFGW_4, WR_PORT_URGENT_EN, 1, 13)
    DEP_FIELD(PCFGW_4, WR_PORT_AGING_EN, 1, 12)
    DEP_FIELD(PCFGW_4, WR_PORT_PRIORITY, 10, 0)
DEP_REG32(PCTRL_4, 0x750)
    DEP_FIELD(PCTRL_4, PORT_EN, 1, 0)
DEP_REG32(PCFGQOS0_4, 0x754)
    DEP_FIELD(PCFGQOS0_4, RQOS_MAP_REGION1, 2, 20)
    DEP_FIELD(PCFGQOS0_4, RQOS_MAP_REGION0, 2, 16)
    DEP_FIELD(PCFGQOS0_4, RQOS_MAP_LEVEL1, 4, 0)
DEP_REG32(PCFGQOS1_4, 0x758)
    DEP_FIELD(PCFGQOS1_4, RQOS_MAP_TIMEOUTR, 11, 16)
    DEP_FIELD(PCFGQOS1_4, RQOS_MAP_TIMEOUTB, 11, 0)
DEP_REG32(PCFGWQOS0_4, 0x75c)
    DEP_FIELD(PCFGWQOS0_4, WQOS_MAP_REGION1, 2, 20)
    DEP_FIELD(PCFGWQOS0_4, WQOS_MAP_REGION0, 2, 16)
    DEP_FIELD(PCFGWQOS0_4, WQOS_MAP_LEVEL, 4, 0)
DEP_REG32(PCFGWQOS1_4, 0x760)
    DEP_FIELD(PCFGWQOS1_4, WQOS_MAP_TIMEOUT, 11, 0)
DEP_REG32(PCFGR_5, 0x774)
    DEP_FIELD(PCFGR_5, RD_PORT_PAGEMATCH_EN, 1, 14)
    DEP_FIELD(PCFGR_5, RD_PORT_URGENT_EN, 1, 13)
    DEP_FIELD(PCFGR_5, RD_PORT_AGING_EN, 1, 12)
    DEP_FIELD(PCFGR_5, RD_PORT_PRIORITY, 10, 0)
DEP_REG32(PCFGW_5, 0x778)
    DEP_FIELD(PCFGW_5, WR_PORT_PAGEMATCH_EN, 1, 14)
    DEP_FIELD(PCFGW_5, WR_PORT_URGENT_EN, 1, 13)
    DEP_FIELD(PCFGW_5, WR_PORT_AGING_EN, 1, 12)
    DEP_FIELD(PCFGW_5, WR_PORT_PRIORITY, 10, 0)
DEP_REG32(PCTRL_5, 0x800)
    DEP_FIELD(PCTRL_5, PORT_EN, 1, 0)
DEP_REG32(PCFGQOS0_5, 0x804)
    DEP_FIELD(PCFGQOS0_5, RQOS_MAP_REGION1, 2, 20)
    DEP_FIELD(PCFGQOS0_5, RQOS_MAP_REGION0, 2, 16)
    DEP_FIELD(PCFGQOS0_5, RQOS_MAP_LEVEL1, 4, 0)
DEP_REG32(PCFGQOS1_5, 0x808)
    DEP_FIELD(PCFGQOS1_5, RQOS_MAP_TIMEOUTR, 11, 16)
    DEP_FIELD(PCFGQOS1_5, RQOS_MAP_TIMEOUTB, 11, 0)
DEP_REG32(PCFGWQOS0_5, 0x80c)
    DEP_FIELD(PCFGWQOS0_5, WQOS_MAP_REGION1, 2, 20)
    DEP_FIELD(PCFGWQOS0_5, WQOS_MAP_REGION0, 2, 16)
    DEP_FIELD(PCFGWQOS0_5, WQOS_MAP_LEVEL, 4, 0)
DEP_REG32(PCFGWQOS1_5, 0x810)
    DEP_FIELD(PCFGWQOS1_5, WQOS_MAP_TIMEOUT, 11, 0)
DEP_REG32(SARBASE0, 0xf04)
    DEP_FIELD(SARBASE0, BASE_ADDR, 9, 0)
DEP_REG32(SARSIZE0, 0xf08)
    DEP_FIELD(SARSIZE0, NBLOCKS, 8, 0)
DEP_REG32(SARBASE1, 0xf0c)
    DEP_FIELD(SARBASE1, BASE_ADDR, 9, 0)
DEP_REG32(SARSIZE1, 0xf10)
    DEP_FIELD(SARSIZE1, NBLOCKS, 8, 0)
DEP_REG32(DERATEINT_SHADOW, 0x2024)
DEP_REG32(RFSHCTL0_SHADOW, 0x2050)
    DEP_FIELD(RFSHCTL0_SHADOW, REFRESH_MARGIN, 4, 20)
    DEP_FIELD(RFSHCTL0_SHADOW, REFRESH_TO_X32, 5, 12)
    DEP_FIELD(RFSHCTL0_SHADOW, REFRESH_BURST, 5, 4)
    DEP_FIELD(RFSHCTL0_SHADOW, PER_BANK_REFRESH, 1, 2)
DEP_REG32(RFSHTMG_SHADOW, 0x2064)
    DEP_FIELD(RFSHTMG_SHADOW, T_RFC_NOM_X32, 12, 16)
    DEP_FIELD(RFSHTMG_SHADOW, LPDDR3_TREFBW_EN, 1, 15)
    DEP_FIELD(RFSHTMG_SHADOW, T_RFC_MIN, 10, 0)
DEP_REG32(INIT3_SHADOW, 0x20dc)
    DEP_FIELD(INIT3_SHADOW, MR, 16, 16)
    DEP_FIELD(INIT3_SHADOW, EMR, 16, 0)
DEP_REG32(INIT4_SHADOW, 0x20e0)
    DEP_FIELD(INIT4_SHADOW, EMR2, 16, 16)
    DEP_FIELD(INIT4_SHADOW, EMR3, 16, 0)
DEP_REG32(INIT6_SHADOW, 0x20e8)
    DEP_FIELD(INIT6_SHADOW, MR4, 16, 16)
    DEP_FIELD(INIT6_SHADOW, MR5, 16, 0)
DEP_REG32(INIT7_SHADOW, 0x20ec)
    DEP_FIELD(INIT7_SHADOW, MR6, 16, 16)
DEP_REG32(DRAMTMG0_SHADOW, 0x2100)
    DEP_FIELD(DRAMTMG0_SHADOW, WR2PRE, 7, 24)
    DEP_FIELD(DRAMTMG0_SHADOW, T_FAW, 6, 16)
    DEP_FIELD(DRAMTMG0_SHADOW, T_RAS_MAX, 7, 8)
    DEP_FIELD(DRAMTMG0_SHADOW, T_RAS_MIN, 6, 0)
DEP_REG32(DRAMTMG1_SHADOW, 0x2104)
    DEP_FIELD(DRAMTMG1_SHADOW, T_XP, 5, 16)
    DEP_FIELD(DRAMTMG1_SHADOW, RD2PRE, 5, 8)
    DEP_FIELD(DRAMTMG1_SHADOW, T_RC, 7, 0)
DEP_REG32(DRAMTMG2_SHADOW, 0x2108)
    DEP_FIELD(DRAMTMG2_SHADOW, WRITE_LATENCY, 6, 24)
    DEP_FIELD(DRAMTMG2_SHADOW, READ_LATENCY, 6, 16)
    DEP_FIELD(DRAMTMG2_SHADOW, RD2WR, 6, 8)
    DEP_FIELD(DRAMTMG2_SHADOW, WR2RD, 6, 0)
DEP_REG32(DRAMTMG3_SHADOW, 0x210c)
    DEP_FIELD(DRAMTMG3_SHADOW, T_MRW, 10, 20)
    DEP_FIELD(DRAMTMG3_SHADOW, T_MRD, 6, 12)
    DEP_FIELD(DRAMTMG3_SHADOW, T_MOD, 10, 0)
DEP_REG32(DRAMTMG4_SHADOW, 0x2110)
    DEP_FIELD(DRAMTMG4_SHADOW, T_RCD, 5, 24)
    DEP_FIELD(DRAMTMG4_SHADOW, T_CCD, 4, 16)
    DEP_FIELD(DRAMTMG4_SHADOW, T_RRD, 4, 8)
    DEP_FIELD(DRAMTMG4_SHADOW, T_RP, 5, 0)
DEP_REG32(DRAMTMG5_SHADOW, 0x2114)
    DEP_FIELD(DRAMTMG5_SHADOW, T_CKSRX, 4, 24)
    DEP_FIELD(DRAMTMG5_SHADOW, T_CKSRE, 4, 16)
    DEP_FIELD(DRAMTMG5_SHADOW, T_CKESR, 6, 8)
    DEP_FIELD(DRAMTMG5_SHADOW, T_CKE, 5, 0)
DEP_REG32(DRAMTMG6_SHADOW, 0x2118)
    DEP_FIELD(DRAMTMG6_SHADOW, T_CKDPDE, 4, 24)
    DEP_FIELD(DRAMTMG6_SHADOW, T_CKDPDX, 4, 16)
    DEP_FIELD(DRAMTMG6_SHADOW, T_CKCSX, 4, 0)
DEP_REG32(DRAMTMG7_SHADOW, 0x211c)
    DEP_FIELD(DRAMTMG7_SHADOW, T_CKPDE, 4, 8)
    DEP_FIELD(DRAMTMG7_SHADOW, T_CKPDX, 4, 0)
DEP_REG32(DRAMTMG8_SHADOW, 0x2120)
    DEP_FIELD(DRAMTMG8_SHADOW, T_XS_FAST_X32, 7, 24)
    DEP_FIELD(DRAMTMG8_SHADOW, T_XS_ABORT_X32, 7, 16)
    DEP_FIELD(DRAMTMG8_SHADOW, T_XS_DLL_X32, 7, 8)
    DEP_FIELD(DRAMTMG8_SHADOW, T_XS_X32, 7, 0)
DEP_REG32(DRAMTMG9_SHADOW, 0x2124)
    DEP_FIELD(DRAMTMG9_SHADOW, DDR4_WR_PREAMBLE, 1, 30)
    DEP_FIELD(DRAMTMG9_SHADOW, T_CCD_S, 3, 16)
    DEP_FIELD(DRAMTMG9_SHADOW, T_RRD_S, 4, 8)
    DEP_FIELD(DRAMTMG9_SHADOW, WR2RD_S, 6, 0)
DEP_REG32(DRAMTMG10_SHADOW, 0x2128)
    DEP_FIELD(DRAMTMG10_SHADOW, T_SYNC_GEAR, 5, 16)
    DEP_FIELD(DRAMTMG10_SHADOW, T_CMD_GEAR, 5, 8)
    DEP_FIELD(DRAMTMG10_SHADOW, T_GEAR_SETUP, 2, 2)
    DEP_FIELD(DRAMTMG10_SHADOW, T_GEAR_HOLD, 2, 0)
DEP_REG32(DRAMTMG11_SHADOW, 0x212c)
    DEP_FIELD(DRAMTMG11_SHADOW, POST_MPSM_GAP_X32, 7, 24)
    DEP_FIELD(DRAMTMG11_SHADOW, T_MPX_LH, 5, 16)
    DEP_FIELD(DRAMTMG11_SHADOW, T_MPX_S, 2, 8)
    DEP_FIELD(DRAMTMG11_SHADOW, T_CKMPE, 5, 0)
DEP_REG32(DRAMTMG12_SHADOW, 0x2130)
    DEP_FIELD(DRAMTMG12_SHADOW, T_CMDCKE, 2, 16)
    DEP_FIELD(DRAMTMG12_SHADOW, T_CKEHCMD, 4, 8)
    DEP_FIELD(DRAMTMG12_SHADOW, T_MRD_PDA, 5, 0)
DEP_REG32(DRAMTMG13_SHADOW, 0x2134)
    DEP_FIELD(DRAMTMG13_SHADOW, ODTLOFF, 7, 24)
    DEP_FIELD(DRAMTMG13_SHADOW, T_CCD_MW, 6, 16)
    DEP_FIELD(DRAMTMG13_SHADOW, T_PPD, 3, 0)
DEP_REG32(DRAMTMG14_SHADOW, 0x2138)
    DEP_FIELD(DRAMTMG14_SHADOW, T_XSR, 12, 0)
DEP_REG32(ZQCTL0_SHADOW, 0x2180)
    DEP_FIELD(ZQCTL0_SHADOW, DIS_AUTO_ZQ, 1, 31)
    DEP_FIELD(ZQCTL0_SHADOW, DIS_SRX_ZQCL, 1, 30)
    DEP_FIELD(ZQCTL0_SHADOW, ZQ_RESISTOR_SHARED, 1, 29)
    DEP_FIELD(ZQCTL0_SHADOW, DIS_MPSMX_ZQCL, 1, 28)
    DEP_FIELD(ZQCTL0_SHADOW, T_ZQ_LONG_NOP, 11, 16)
    DEP_FIELD(ZQCTL0_SHADOW, T_ZQ_SHORT_NOP, 10, 0)
DEP_REG32(DFITMG0_SHADOW, 0x2190)
    DEP_FIELD(DFITMG0_SHADOW, DFI_T_CTRL_DELAY, 5, 24)
    DEP_FIELD(DFITMG0_SHADOW, DFI_RDDATA_USE_SDR, 1, 23)
    DEP_FIELD(DFITMG0_SHADOW, DFI_T_RDDATA_EN, 6, 16)
    DEP_FIELD(DFITMG0_SHADOW, DFI_WRDATA_USE_SDR, 1, 15)
    DEP_FIELD(DFITMG0_SHADOW, DFI_TPHY_WRDATA, 6, 8)
    DEP_FIELD(DFITMG0_SHADOW, DFI_TPHY_WRLAT, 6, 0)
DEP_REG32(DFITMG1_SHADOW, 0x2194)
    DEP_FIELD(DFITMG1_SHADOW, DFI_T_CMD_LAT, 4, 28)
    DEP_FIELD(DFITMG1_SHADOW, DFI_T_PARIN_LAT, 2, 24)
    DEP_FIELD(DFITMG1_SHADOW, DFI_T_WRDATA_DELAY, 5, 16)
    DEP_FIELD(DFITMG1_SHADOW, DFI_T_DRAM_CLK_DISABLE, 4, 8)
    DEP_FIELD(DFITMG1_SHADOW, DFI_T_DRAM_CLK_ENABLE, 4, 0)
DEP_REG32(DFITMG2_SHADOW, 0x21b4)
    DEP_FIELD(DFITMG2_SHADOW, DFI_TPHY_RDCSLAT, 6, 8)
    DEP_FIELD(DFITMG2_SHADOW, DFI_TPHY_WRCSLAT, 6, 0)
DEP_REG32(ODTCFG_SHADOW, 0x2240)
    DEP_FIELD(ODTCFG_SHADOW, WR_ODT_HOLD, 4, 24)
    DEP_FIELD(ODTCFG_SHADOW, WR_ODT_DELAY, 5, 16)
    DEP_FIELD(ODTCFG_SHADOW, RD_ODT_HOLD, 4, 8)
    DEP_FIELD(ODTCFG_SHADOW, RD_ODT_DELAY, 5, 2)

#define R_MAX (R_ODTCFG_SHADOW + 1)

#define R_STAT_OPERATING_MODE_SR     3
#define R_STAT_OPERATING_MODE_NORMAL 1

#define R_STAT_SELFREF_TYPE_SRSW 2
#define R_STAT_SELFREF_TYPE_NONE 0

typedef struct DDRC {
    SysBusDevice parent_obj;
    MemoryRegion iomem;

    uint32_t regs[R_MAX];
    DepRegisterInfo regs_info[R_MAX];
} DDRC;

static void ddrc_pwrctl_post_write(DepRegisterInfo *reg, uint64_t val)
{
    DDRC *s = XILINX_DDRC(reg->opaque);

    /*
     * Software requests self-refresh enter. Pretend that we complied and update
     * the STAT register accordingly.
     */
    if (val & R_PWRCTL_SELFREF_SW_MASK) {
        DEP_AF_DP32(s->regs, STAT, OPERATING_MODE, R_STAT_OPERATING_MODE_SR);
        DEP_AF_DP32(s->regs, STAT, SELFREF_TYPE, R_STAT_SELFREF_TYPE_SRSW);
    }

    /* switch to normal mode */
    if (!(val & R_PWRCTL_SELFREF_SW_MASK)) {
        DEP_AF_DP32(s->regs, STAT, OPERATING_MODE, R_STAT_OPERATING_MODE_NORMAL);
        DEP_AF_DP32(s->regs, STAT, SELFREF_TYPE, R_STAT_SELFREF_TYPE_NONE);
    }
}

static DepRegisterAccessInfo ddrc_regs_info[] = {
    {   .name = "MSTR",  .decode.addr = A_MSTR,
        .reset = 0x3040001,
    },{ .name = "STAT",  .decode.addr = A_STAT,
        .ro = 0x337,
        /* Reset to Normal mode. */
        .reset = 0x1,
    },{ .name = "MRCTRL0",  .decode.addr = A_MRCTRL0,
        .reset = 0x30,
    },{ .name = "MRCTRL1",  .decode.addr = A_MRCTRL1,
    },{ .name = "MRSTAT",  .decode.addr = A_MRSTAT,
        .ro = 0x101,
    },{ .name = "MRCTRL2",  .decode.addr = A_MRCTRL2,
    },{ .name = "DERATEEN",  .decode.addr = A_DERATEEN,
    },{ .name = "DERATEINT",  .decode.addr = A_DERATEINT,
        .reset = 0x800000,
    },{ .name = "PWRCTL",  .decode.addr = A_PWRCTL,
        .post_write = ddrc_pwrctl_post_write,
    },{ .name = "PWRTMG",  .decode.addr = A_PWRTMG,
        .reset = 0x402010,
    },{ .name = "HWLPCTL",  .decode.addr = A_HWLPCTL,
        .reset = 0x3,
    },{ .name = "RFSHCTL0",  .decode.addr = A_RFSHCTL0,
        .reset = 0x210000,
    },{ .name = "RFSHCTL1",  .decode.addr = A_RFSHCTL1,
    },{ .name = "RFSHCTL3",  .decode.addr = A_RFSHCTL3,
    },{ .name = "RFSHTMG",  .decode.addr = A_RFSHTMG,
        .reset = 0x62008c,
    },{ .name = "ECCCFG0",  .decode.addr = A_ECCCFG0,
    },{ .name = "ECCCFG1",  .decode.addr = A_ECCCFG1,
    },{ .name = "ECCSTAT",  .decode.addr = A_ECCSTAT,
        .ro = 0xf0f7f,
    },{ .name = "ECCCLR",  .decode.addr = A_ECCCLR,
        .w1c = 0xf,
    },{ .name = "ECCERRCNT",  .decode.addr = A_ECCERRCNT,
        .ro = 0xffffffff,
    },{ .name = "ECCCADDR0",  .decode.addr = A_ECCCADDR0,
        .ro = 0x103ffff,
    },{ .name = "ECCCADDR1",  .decode.addr = A_ECCCADDR1,
        .ro = 0x3070fff,
    },{ .name = "ECCCSYN0",  .decode.addr = A_ECCCSYN0,
        .ro = 0xffffffff,
    },{ .name = "ECCCSYN1",  .decode.addr = A_ECCCSYN1,
        .ro = 0xffffffff,
    },{ .name = "ECCCSYN2",  .decode.addr = A_ECCCSYN2,
        .ro = 0xff,
    },{ .name = "ECCBITMASK0",  .decode.addr = A_ECCBITMASK0,
        .ro = 0xffffffff,
    },{ .name = "ECCBITMASK1",  .decode.addr = A_ECCBITMASK1,
        .ro = 0xffffffff,
    },{ .name = "ECCBITMASK2",  .decode.addr = A_ECCBITMASK2,
        .ro = 0xff,
    },{ .name = "ECCUADDR0",  .decode.addr = A_ECCUADDR0,
        .ro = 0x103ffff,
    },{ .name = "ECCUADDR1",  .decode.addr = A_ECCUADDR1,
        .ro = 0x3070fff,
    },{ .name = "ECCUSYN0",  .decode.addr = A_ECCUSYN0,
        .ro = 0xffffffff,
    },{ .name = "ECCUSYN1",  .decode.addr = A_ECCUSYN1,
        .ro = 0xffffffff,
    },{ .name = "ECCUSYN2",  .decode.addr = A_ECCUSYN2,
        .ro = 0xff,
    },{ .name = "ECCPOISONADDR0",  .decode.addr = A_ECCPOISONADDR0,
    },{ .name = "ECCPOISONADDR1",  .decode.addr = A_ECCPOISONADDR1,
    },{ .name = "CRCPARCTL0",  .decode.addr = A_CRCPARCTL0,
        .reset = 0x8000,
        .w1c = 0x116,
    },{ .name = "CRCPARCTL1",  .decode.addr = A_CRCPARCTL1,
        .reset = 0x10000200,
    },{ .name = "CRCPARCTL2",  .decode.addr = A_CRCPARCTL2,
        .reset = 0x30050c,
    },{ .name = "CRCPARSTAT",  .decode.addr = A_CRCPARSTAT,
        .ro = 0x307fffff,
    },{ .name = "INIT0",  .decode.addr = A_INIT0,
        .reset = 0x2004e,
    },{ .name = "INIT1",  .decode.addr = A_INIT1,
    },{ .name = "INIT2",  .decode.addr = A_INIT2,
        .reset = 0xd05,
    },{ .name = "INIT3",  .decode.addr = A_INIT3,
        .reset = 0x510,
    },{ .name = "INIT4",  .decode.addr = A_INIT4,
    },{ .name = "INIT5",  .decode.addr = A_INIT5,
        .reset = 0x100004,
    },{ .name = "INIT6",  .decode.addr = A_INIT6,
    },{ .name = "INIT7",  .decode.addr = A_INIT7,
    },{ .name = "DIMMCTL",  .decode.addr = A_DIMMCTL,
    },{ .name = "RANKCTL",  .decode.addr = A_RANKCTL,
        .reset = 0x66f,
    },{ .name = "DRAMTMG0",  .decode.addr = A_DRAMTMG0,
        .reset = 0xf101b0f,
    },{ .name = "DRAMTMG1",  .decode.addr = A_DRAMTMG1,
        .reset = 0x80414,
    },{ .name = "DRAMTMG2",  .decode.addr = A_DRAMTMG2,
        .reset = 0x305060d,
    },{ .name = "DRAMTMG3",  .decode.addr = A_DRAMTMG3,
        .reset = 0x50400c,
    },{ .name = "DRAMTMG4",  .decode.addr = A_DRAMTMG4,
        .reset = 0x5040405,
    },{ .name = "DRAMTMG5",  .decode.addr = A_DRAMTMG5,
        .reset = 0x5050403,
    },{ .name = "DRAMTMG6",  .decode.addr = A_DRAMTMG6,
        .reset = 0x2020005,
    },{ .name = "DRAMTMG7",  .decode.addr = A_DRAMTMG7,
        .reset = 0x202,
    },{ .name = "DRAMTMG8",  .decode.addr = A_DRAMTMG8,
        .reset = 0x3034405,
    },{ .name = "DRAMTMG9",  .decode.addr = A_DRAMTMG9,
        .reset = 0x4040d,
    },{ .name = "DRAMTMG10",  .decode.addr = A_DRAMTMG10,
        .reset = 0x1c180a,
    },{ .name = "DRAMTMG11",  .decode.addr = A_DRAMTMG11,
        .reset = 0x440c021c,
    },{ .name = "DRAMTMG12",  .decode.addr = A_DRAMTMG12,
        .reset = 0x20610,
    },{ .name = "DRAMTMG13",  .decode.addr = A_DRAMTMG13,
        .reset = 0x1c200004,
    },{ .name = "DRAMTMG14",  .decode.addr = A_DRAMTMG14,
        .reset = 0xa0,
    },{ .name = "ZQCTL0",  .decode.addr = A_ZQCTL0,
        .reset = 0x2000040,
    },{ .name = "ZQCTL1",  .decode.addr = A_ZQCTL1,
        .reset = 0x2000100,
    },{ .name = "ZQCTL2",  .decode.addr = A_ZQCTL2,
    },{ .name = "ZQSTAT",  .decode.addr = A_ZQSTAT,
        .ro = 0x1,
    },{ .name = "DFITMG0",  .decode.addr = A_DFITMG0,
        .reset = 0x7020002,
    },{ .name = "DFITMG1",  .decode.addr = A_DFITMG1,
        .reset = 0x404,
    },{ .name = "DFILPCFG0",  .decode.addr = A_DFILPCFG0,
        .reset = 0x7000000,
    },{ .name = "DFILPCFG1",  .decode.addr = A_DFILPCFG1,
    },{ .name = "DFIUPD0",  .decode.addr = A_DFIUPD0,
        .reset = 0x400003,
    },{ .name = "DFIUPD1",  .decode.addr = A_DFIUPD1,
    },{ .name = "DFIUPD2",  .decode.addr = A_DFIUPD2,
        .reset = 0x80000000,
    },{ .name = "DFIMISC",  .decode.addr = A_DFIMISC,
        .reset = 0x1,
    },{ .name = "DFITMG2",  .decode.addr = A_DFITMG2,
        .reset = 0x202,
    },{ .name = "DBICTL",  .decode.addr = A_DBICTL,
        .reset = 0x1,
    },{ .name = "ADDRMAP0",  .decode.addr = A_ADDRMAP0,
    },{ .name = "ADDRMAP1",  .decode.addr = A_ADDRMAP1,
    },{ .name = "ADDRMAP2",  .decode.addr = A_ADDRMAP2,
    },{ .name = "ADDRMAP3",  .decode.addr = A_ADDRMAP3,
    },{ .name = "ADDRMAP4",  .decode.addr = A_ADDRMAP4,
    },{ .name = "ADDRMAP5",  .decode.addr = A_ADDRMAP5,
    },{ .name = "ADDRMAP6",  .decode.addr = A_ADDRMAP6,
    },{ .name = "ADDRMAP7",  .decode.addr = A_ADDRMAP7,
    },{ .name = "ADDRMAP8",  .decode.addr = A_ADDRMAP8,
    },{ .name = "ADDRMAP9",  .decode.addr = A_ADDRMAP9,
    },{ .name = "ADDRMAP10",  .decode.addr = A_ADDRMAP10,
    },{ .name = "ADDRMAP11",  .decode.addr = A_ADDRMAP11,
    },{ .name = "ODTCFG",  .decode.addr = A_ODTCFG,
        .reset = 0x4000400,
    },{ .name = "ODTMAP",  .decode.addr = A_ODTMAP,
        .reset = 0x2211,
    },{ .name = "SCHED",  .decode.addr = A_SCHED,
        .reset = 0x2005,
    },{ .name = "SCHED1",  .decode.addr = A_SCHED1,
    },{ .name = "PERFHPR1",  .decode.addr = A_PERFHPR1,
        .reset = 0xf000001,
    },{ .name = "PERFLPR1",  .decode.addr = A_PERFLPR1,
        .reset = 0xf00007f,
    },{ .name = "PERFWR1",  .decode.addr = A_PERFWR1,
        .reset = 0xf00007f,
    },{ .name = "PERFVPR1",  .decode.addr = A_PERFVPR1,
    },{ .name = "PERFVPW1",  .decode.addr = A_PERFVPW1,
    },{ .name = "DQMAP0",  .decode.addr = A_DQMAP0,
    },{ .name = "DQMAP1",  .decode.addr = A_DQMAP1,
    },{ .name = "DQMAP2",  .decode.addr = A_DQMAP2,
    },{ .name = "DQMAP3",  .decode.addr = A_DQMAP3,
    },{ .name = "DQMAP4",  .decode.addr = A_DQMAP4,
    },{ .name = "DQMAP5",  .decode.addr = A_DQMAP5,
    },{ .name = "DBG0",  .decode.addr = A_DBG0,
    },{ .name = "DBG1",  .decode.addr = A_DBG1,
    },{ .name = "DBGCAM",  .decode.addr = A_DBGCAM,
        .ro = 0xf77f7f7f,
    },{ .name = "DBGCMD",  .decode.addr = A_DBGCMD,
    },{ .name = "DBGSTAT",  .decode.addr = A_DBGSTAT,
        .ro = 0x33,
    },{ .name = "SWCTL",  .decode.addr = A_SWCTL,
        .reset = 0x1,
    },{ .name = "SWSTAT",  .decode.addr = A_SWSTAT,
        .ro = 0x1,
    },{ .name = "POISONCFG",  .decode.addr = A_POISONCFG,
        .reset = 0x110011,
        .w1c = 0x1000100,
    },{ .name = "POISONSTAT",  .decode.addr = A_POISONSTAT,
        .ro = 0x3f003f,
    },{ .name = "PSTAT",  .decode.addr = A_PSTAT,
        .ro = 0x3f003f,
    },{ .name = "PCCFG",  .decode.addr = A_PCCFG,
    },{ .name = "PCFGR_0",  .decode.addr = A_PCFGR_0,
    },{ .name = "PCFGW_0",  .decode.addr = A_PCFGW_0,
        .reset = 0x4000,
    },{ .name = "PCTRL_0",  .decode.addr = A_PCTRL_0,
    },{ .name = "PCFGQOS0_0",  .decode.addr = A_PCFGQOS0_0,
    },{ .name = "PCFGQOS1_0",  .decode.addr = A_PCFGQOS1_0,
    },{ .name = "PCFGWQOS0_0",  .decode.addr = A_PCFGWQOS0_0,
    },{ .name = "PCFGWQOS1_0",  .decode.addr = A_PCFGWQOS1_0,
    },{ .name = "PCFGR_1",  .decode.addr = A_PCFGR_1,
    },{ .name = "PCFGW_1",  .decode.addr = A_PCFGW_1,
        .reset = 0x4000,
    },{ .name = "PCTRL_1",  .decode.addr = A_PCTRL_1,
    },{ .name = "PCFGQOS0_1",  .decode.addr = A_PCFGQOS0_1,
        .reset = 0x2000e00,
    },{ .name = "PCFGQOS1_1",  .decode.addr = A_PCFGQOS1_1,
    },{ .name = "PCFGWQOS0_1",  .decode.addr = A_PCFGWQOS0_1,
    },{ .name = "PCFGWQOS1_1",  .decode.addr = A_PCFGWQOS1_1,
    },{ .name = "PCFGR_2",  .decode.addr = A_PCFGR_2,
    },{ .name = "PCFGW_2",  .decode.addr = A_PCFGW_2,
        .reset = 0x4000,
    },{ .name = "PCTRL_2",  .decode.addr = A_PCTRL_2,
    },{ .name = "PCFGQOS0_2",  .decode.addr = A_PCFGQOS0_2,
        .reset = 0x2000e00,
    },{ .name = "PCFGQOS1_2",  .decode.addr = A_PCFGQOS1_2,
    },{ .name = "PCFGWQOS0_2",  .decode.addr = A_PCFGWQOS0_2,
    },{ .name = "PCFGWQOS1_2",  .decode.addr = A_PCFGWQOS1_2,
    },{ .name = "PCFGR_3",  .decode.addr = A_PCFGR_3,
    },{ .name = "PCFGW_3",  .decode.addr = A_PCFGW_3,
        .reset = 0x4000,
    },{ .name = "PCTRL_3",  .decode.addr = A_PCTRL_3,
    },{ .name = "PCFGQOS0_3",  .decode.addr = A_PCFGQOS0_3,
    },{ .name = "PCFGQOS1_3",  .decode.addr = A_PCFGQOS1_3,
    },{ .name = "PCFGWQOS0_3",  .decode.addr = A_PCFGWQOS0_3,
    },{ .name = "PCFGWQOS1_3",  .decode.addr = A_PCFGWQOS1_3,
    },{ .name = "PCFGR_4",  .decode.addr = A_PCFGR_4,
    },{ .name = "PCFGW_4",  .decode.addr = A_PCFGW_4,
        .reset = 0x4000,
    },{ .name = "PCTRL_4",  .decode.addr = A_PCTRL_4,
    },{ .name = "PCFGQOS0_4",  .decode.addr = A_PCFGQOS0_4,
    },{ .name = "PCFGQOS1_4",  .decode.addr = A_PCFGQOS1_4,
    },{ .name = "PCFGWQOS0_4",  .decode.addr = A_PCFGWQOS0_4,
    },{ .name = "PCFGWQOS1_4",  .decode.addr = A_PCFGWQOS1_4,
    },{ .name = "PCFGR_5",  .decode.addr = A_PCFGR_5,
    },{ .name = "PCFGW_5",  .decode.addr = A_PCFGW_5,
        .reset = 0x4000,
    },{ .name = "PCTRL_5",  .decode.addr = A_PCTRL_5,
    },{ .name = "PCFGQOS0_5",  .decode.addr = A_PCFGQOS0_5,
    },{ .name = "PCFGQOS1_5",  .decode.addr = A_PCFGQOS1_5,
    },{ .name = "PCFGWQOS0_5",  .decode.addr = A_PCFGWQOS0_5,
    },{ .name = "PCFGWQOS1_5",  .decode.addr = A_PCFGWQOS1_5,
    },{ .name = "SARBASE0",  .decode.addr = A_SARBASE0,
    },{ .name = "SARSIZE0",  .decode.addr = A_SARSIZE0,
    },{ .name = "SARBASE1",  .decode.addr = A_SARBASE1,
        .reset = 0x1,
    },{ .name = "SARSIZE1",  .decode.addr = A_SARSIZE1,
    },{ .name = "DERATEINT_SHADOW",  .decode.addr = A_DERATEINT_SHADOW,
        .reset = 0x800000,
    },{ .name = "RFSHCTL0_SHADOW",  .decode.addr = A_RFSHCTL0_SHADOW,
        .reset = 0x210000,
    },{ .name = "RFSHTMG_SHADOW",  .decode.addr = A_RFSHTMG_SHADOW,
        .reset = 0x62008c,
    },{ .name = "INIT3_SHADOW",  .decode.addr = A_INIT3_SHADOW,
        .reset = 0x510,
    },{ .name = "INIT4_SHADOW",  .decode.addr = A_INIT4_SHADOW,
    },{ .name = "INIT6_SHADOW",  .decode.addr = A_INIT6_SHADOW,
    },{ .name = "INIT7_SHADOW",  .decode.addr = A_INIT7_SHADOW,
    },{ .name = "DRAMTMG0_SHADOW",  .decode.addr = A_DRAMTMG0_SHADOW,
        .reset = 0xf101b0f,
    },{ .name = "DRAMTMG1_SHADOW",  .decode.addr = A_DRAMTMG1_SHADOW,
        .reset = 0x80414,
    },{ .name = "DRAMTMG2_SHADOW",  .decode.addr = A_DRAMTMG2_SHADOW,
        .reset = 0x305060d,
    },{ .name = "DRAMTMG3_SHADOW",  .decode.addr = A_DRAMTMG3_SHADOW,
        .reset = 0x50400c,
    },{ .name = "DRAMTMG4_SHADOW",  .decode.addr = A_DRAMTMG4_SHADOW,
        .reset = 0x5040405,
    },{ .name = "DRAMTMG5_SHADOW",  .decode.addr = A_DRAMTMG5_SHADOW,
        .reset = 0x5050403,
    },{ .name = "DRAMTMG6_SHADOW",  .decode.addr = A_DRAMTMG6_SHADOW,
        .reset = 0x2020005,
    },{ .name = "DRAMTMG7_SHADOW",  .decode.addr = A_DRAMTMG7_SHADOW,
        .reset = 0x202,
    },{ .name = "DRAMTMG8_SHADOW",  .decode.addr = A_DRAMTMG8_SHADOW,
        .reset = 0x3034405,
    },{ .name = "DRAMTMG9_SHADOW",  .decode.addr = A_DRAMTMG9_SHADOW,
        .reset = 0x4040d,
    },{ .name = "DRAMTMG10_SHADOW",  .decode.addr = A_DRAMTMG10_SHADOW,
        .reset = 0x1c180a,
    },{ .name = "DRAMTMG11_SHADOW",  .decode.addr = A_DRAMTMG11_SHADOW,
        .reset = 0x440c021c,
    },{ .name = "DRAMTMG12_SHADOW",  .decode.addr = A_DRAMTMG12_SHADOW,
        .reset = 0x20610,
    },{ .name = "DRAMTMG13_SHADOW",  .decode.addr = A_DRAMTMG13_SHADOW,
        .reset = 0x1c200004,
    },{ .name = "DRAMTMG14_SHADOW",  .decode.addr = A_DRAMTMG14_SHADOW,
        .reset = 0xa0,
    },{ .name = "ZQCTL0_SHADOW",  .decode.addr = A_ZQCTL0_SHADOW,
        .reset = 0x2000040,
    },{ .name = "DFITMG0_SHADOW",  .decode.addr = A_DFITMG0_SHADOW,
        .reset = 0x7020002,
    },{ .name = "DFITMG1_SHADOW",  .decode.addr = A_DFITMG1_SHADOW,
        .reset = 0x404,
    },{ .name = "DFITMG2_SHADOW",  .decode.addr = A_DFITMG2_SHADOW,
        .reset = 0x202,
    },{ .name = "ODTCFG_SHADOW",  .decode.addr = A_ODTCFG_SHADOW,
        .reset = 0x4000400,
    }
};

static void ddrc_reset(DeviceState *dev)
{
    DDRC *s = XILINX_DDRC(dev);
    unsigned int i;

    for (i = 0; i < ARRAY_SIZE(s->regs_info); ++i) {
        dep_register_reset(&s->regs_info[i]);
    }

}

static uint64_t ddrc_read(void *opaque, hwaddr addr, unsigned size)
{
    DDRC *s = XILINX_DDRC(opaque);
    DepRegisterInfo *r = &s->regs_info[addr / 4];

    if (!r->data) {
        qemu_log("%s: Decode error: read from %" HWADDR_PRIx "\n",
                 object_get_canonical_path(OBJECT(s)),
                 addr);
        return 0;
    }
    return dep_register_read(r);
}

static void ddrc_write(void *opaque, hwaddr addr, uint64_t value,
                      unsigned size)
{
    DDRC *s = XILINX_DDRC(opaque);
    DepRegisterInfo *r = &s->regs_info[addr / 4];

    if (!r->data) {
        qemu_log("%s: Decode error: write to %" HWADDR_PRIx "=%" PRIx64 "\n",
                 object_get_canonical_path(OBJECT(s)),
                 addr, value);
        return;
    }
    dep_register_write(r, value, ~0);
}

static const MemoryRegionOps ddrc_ops = {
    .read = ddrc_read,
    .write = ddrc_write,
    .endianness = DEVICE_LITTLE_ENDIAN,
    .valid = {
        .min_access_size = 4,
        .max_access_size = 4,
    },
};

static void ddrc_realize(DeviceState *dev, Error **errp)
{
    DDRC *s = XILINX_DDRC(dev);
    const char *prefix = object_get_canonical_path(OBJECT(dev));
    unsigned int i;

    for (i = 0; i < ARRAY_SIZE(ddrc_regs_info); ++i) {
        DepRegisterInfo *r = &s->regs_info[ddrc_regs_info[i].decode.addr/4];

        *r = (DepRegisterInfo) {
            .data = (uint8_t *)&s->regs[
                    ddrc_regs_info[i].decode.addr/4],
            .data_size = sizeof(uint32_t),
            .access = &ddrc_regs_info[i],
            .debug = XILINX_DDRC_ERR_DEBUG,
            .prefix = prefix,
            .opaque = s,
        };
    }
}

static void ddrc_init(Object *obj)
{
    DDRC *s = XILINX_DDRC(obj);
    SysBusDevice *sbd = SYS_BUS_DEVICE(obj);

    memory_region_init_io(&s->iomem, obj, &ddrc_ops, s,
                          TYPE_XILINX_DDRC, R_MAX * 4);
    sysbus_init_mmio(sbd, &s->iomem);
}

static const VMStateDescription vmstate_ddrc = {
    .name = TYPE_XILINX_DDRC,
    .version_id = 1,
    .minimum_version_id = 1,
    .minimum_version_id_old = 1,
    .fields = (VMStateField[]) {
        VMSTATE_UINT32_ARRAY(regs, DDRC, R_MAX),
        VMSTATE_END_OF_LIST(),
    }
};

static void ddrc_class_init(ObjectClass *klass, void *data)
{
    DeviceClass *dc = DEVICE_CLASS(klass);

    dc->reset = ddrc_reset;
    dc->realize = ddrc_realize;
    dc->vmsd = &vmstate_ddrc;
}

static const TypeInfo ddrc_info = {
    .name          = TYPE_XILINX_DDRC,
    .parent        = TYPE_SYS_BUS_DEVICE,
    .instance_size = sizeof(DDRC),
    .class_init    = ddrc_class_init,
    .instance_init = ddrc_init,
};

static void ddrc_register_types(void)
{
    type_register_static(&ddrc_info);
}

type_init(ddrc_register_types)
