/*
 * QEMU model of the PMU_GLOBAL
 *
 * Copyright (c) 2014 Xilinx Inc.
 *
 * Partly autogenerated by xregqemu.py 2014-09-01.
 * Written by Edgar E. Iglesias.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#include "qemu/osdep.h"
#include "hw/sysbus.h"
#include "hw/register-dep.h"
#include "qemu/bitops.h"
#include "qemu/log.h"

#include "hw/fdt_generic_util.h"

#ifndef XILINX_PMU_GLOBAL_ERR_DEBUG
#define XILINX_PMU_GLOBAL_ERR_DEBUG 0
#endif

#define TYPE_XILINX_PMU_GLOBAL "xlnx,pmu_global"

#define XILINX_PMU_GLOBAL(obj) \
     OBJECT_CHECK(PMU_GLOBAL, (obj), TYPE_XILINX_PMU_GLOBAL)

DEP_REG32(GLOBAL_CNTRL, 0x0)
    DEP_FIELD(GLOBAL_CNTRL, MB_SLEEP, 1, 16)
    DEP_FIELD(GLOBAL_CNTRL, WRITE_QOS, 4, 12)
    DEP_FIELD(GLOBAL_CNTRL, READ_QOS, 4, 8)
    DEP_FIELD(GLOBAL_CNTRL, FW_IS_PRESENT, 1, 4)
    DEP_FIELD(GLOBAL_CNTRL, COHERENT, 1, 2)
    DEP_FIELD(GLOBAL_CNTRL, SLVERR_ENABLE, 1, 1)
    DEP_FIELD(GLOBAL_CNTRL, DONT_SLEEP, 1, 0)
DEP_REG32(PS_CNTRL, 0x4)
    DEP_FIELD(PS_CNTRL, PROG_GATE_STATUS, 1, 16)
    DEP_FIELD(PS_CNTRL, PROG_ENABLE, 1, 1)
    DEP_FIELD(PS_CNTRL, PROG_GATE, 1, 0)
DEP_REG32(APU_PWR_STATUS_INIT, 0x8)
    DEP_FIELD(APU_PWR_STATUS_INIT, ACPU3, 1, 3)
    DEP_FIELD(APU_PWR_STATUS_INIT, ACPU2, 1, 2)
    DEP_FIELD(APU_PWR_STATUS_INIT, ACPU1, 1, 1)
    DEP_FIELD(APU_PWR_STATUS_INIT, ACPU0, 1, 0)
DEP_REG32(ADDR_ERROR_STATUS, 0x10)
    DEP_FIELD(ADDR_ERROR_STATUS, STATUS, 1, 0)
DEP_REG32(ADDR_ERROR_INT_MASK, 0x14)
    DEP_FIELD(ADDR_ERROR_INT_MASK, MASK, 1, 0)
DEP_REG32(ADDR_ERROR_INT_EN, 0x18)
    DEP_FIELD(ADDR_ERROR_INT_EN, ENABLE, 1, 0)
DEP_REG32(ADDR_ERROR_INT_DIS, 0x1c)
    DEP_FIELD(ADDR_ERROR_INT_DIS, DISABLE, 1, 0)
DEP_REG32(GLOBAL_GEN_STORAGE0, 0x30)
DEP_REG32(GLOBAL_GEN_STORAGE1, 0x34)
DEP_REG32(GLOBAL_GEN_STORAGE2, 0x38)
DEP_REG32(GLOBAL_GEN_STORAGE3, 0x3c)
DEP_REG32(GLOBAL_GEN_STORAGE4, 0x40)
DEP_REG32(GLOBAL_GEN_STORAGE5, 0x44)
DEP_REG32(GLOBAL_GEN_STORAGE6, 0x48)
DEP_REG32(PERS_GLOB_GEN_STORAGE0, 0x50)
DEP_REG32(PERS_GLOB_GEN_STORAGE1, 0x54)
DEP_REG32(PERS_GLOB_GEN_STORAGE2, 0x58)
DEP_REG32(PERS_GLOB_GEN_STORAGE3, 0x5c)
DEP_REG32(PERS_GLOB_GEN_STORAGE4, 0x60)
DEP_REG32(PERS_GLOB_GEN_STORAGE5, 0x64)
DEP_REG32(PERS_GLOB_GEN_STORAGE6, 0x68)
DEP_REG32(PERS_GLOB_GEN_STORAGE7, 0x6c)
DEP_REG32(DDR_CNTRL, 0x70)
    DEP_FIELD(DDR_CNTRL, RET, 1, 0)
DEP_REG32(PWR_STATE, 0x100)
    DEP_FIELD(PWR_STATE, PL, 1, 23)
    DEP_FIELD(PWR_STATE, FP, 1, 22)
    DEP_FIELD(PWR_STATE, USB1, 1, 21)
    DEP_FIELD(PWR_STATE, USB0, 1, 20)
    DEP_FIELD(PWR_STATE, OCM_BANK3, 1, 19)
    DEP_FIELD(PWR_STATE, OCM_BANK2, 1, 18)
    DEP_FIELD(PWR_STATE, OCM_BANK1, 1, 17)
    DEP_FIELD(PWR_STATE, OCM_BANK0, 1, 16)
    DEP_FIELD(PWR_STATE, TCM1B, 1, 15)
    DEP_FIELD(PWR_STATE, TCM1A, 1, 14)
    DEP_FIELD(PWR_STATE, TCM0B, 1, 13)
    DEP_FIELD(PWR_STATE, TCM0A, 1, 12)
    DEP_FIELD(PWR_STATE, R5_1, 1, 11)
    DEP_FIELD(PWR_STATE, R5_0, 1, 10)
    DEP_FIELD(PWR_STATE, L2_BANK0, 1, 7)
    DEP_FIELD(PWR_STATE, PP1, 1, 5)
    DEP_FIELD(PWR_STATE, PP0, 1, 4)
    DEP_FIELD(PWR_STATE, ACPU3, 1, 3)
    DEP_FIELD(PWR_STATE, ACPU2, 1, 2)
    DEP_FIELD(PWR_STATE, ACPU1, 1, 1)
    DEP_FIELD(PWR_STATE, ACPU0, 1, 0)
DEP_REG32(AUX_PWR_STATE, 0x104)
    DEP_FIELD(AUX_PWR_STATE, ACPU3_EMULATION, 1, 31)
    DEP_FIELD(AUX_PWR_STATE, ACPU2_EMULATION, 1, 30)
    DEP_FIELD(AUX_PWR_STATE, ACPU1_EMULATION, 1, 29)
    DEP_FIELD(AUX_PWR_STATE, ACPU0_EMULATION, 1, 28)
    DEP_FIELD(AUX_PWR_STATE, RPU_EMULATION, 1, 27)
    DEP_FIELD(AUX_PWR_STATE, OCM_BANK3, 1, 19)
    DEP_FIELD(AUX_PWR_STATE, OCM_BANK2, 1, 18)
    DEP_FIELD(AUX_PWR_STATE, OCM_BANK1, 1, 17)
    DEP_FIELD(AUX_PWR_STATE, OCM_BANK0, 1, 16)
    DEP_FIELD(AUX_PWR_STATE, TCM1B, 1, 15)
    DEP_FIELD(AUX_PWR_STATE, TCM1A, 1, 14)
    DEP_FIELD(AUX_PWR_STATE, TCM0B, 1, 13)
    DEP_FIELD(AUX_PWR_STATE, TCM0A, 1, 12)
    DEP_FIELD(AUX_PWR_STATE, L2_BANK0, 1, 7)
DEP_REG32(RAM_RET_CNTRL, 0x108)
    DEP_FIELD(RAM_RET_CNTRL, OCM_BANK3, 1, 19)
    DEP_FIELD(RAM_RET_CNTRL, OCM_BANK2, 1, 18)
    DEP_FIELD(RAM_RET_CNTRL, OCM_BANK1, 1, 17)
    DEP_FIELD(RAM_RET_CNTRL, OCM_BANK0, 1, 16)
    DEP_FIELD(RAM_RET_CNTRL, TCM1B, 1, 15)
    DEP_FIELD(RAM_RET_CNTRL, TCM1A, 1, 14)
    DEP_FIELD(RAM_RET_CNTRL, TCM0B, 1, 13)
    DEP_FIELD(RAM_RET_CNTRL, TCM0A, 1, 12)
    DEP_FIELD(RAM_RET_CNTRL, L2_BANK0, 1, 7)
DEP_REG32(PWR_SUPPLY_STATUS, 0x10c)
    DEP_FIELD(PWR_SUPPLY_STATUS, VCC_INT, 1, 1)
    DEP_FIELD(PWR_SUPPLY_STATUS, VCC_PSINTFP, 1, 0)
DEP_REG32(REQ_PWRUP_STATUS, 0x110)
    DEP_FIELD(REQ_PWRUP_STATUS, PL, 1, 23)
    DEP_FIELD(REQ_PWRUP_STATUS, FP, 1, 22)
    DEP_FIELD(REQ_PWRUP_STATUS, USB1, 1, 21)
    DEP_FIELD(REQ_PWRUP_STATUS, USB0, 1, 20)
    DEP_FIELD(REQ_PWRUP_STATUS, OCM_BANK3, 1, 19)
    DEP_FIELD(REQ_PWRUP_STATUS, OCM_BANK2, 1, 18)
    DEP_FIELD(REQ_PWRUP_STATUS, OCM_BANK1, 1, 17)
    DEP_FIELD(REQ_PWRUP_STATUS, OCM_BANK0, 1, 16)
    DEP_FIELD(REQ_PWRUP_STATUS, TCM1B, 1, 15)
    DEP_FIELD(REQ_PWRUP_STATUS, TCM1A, 1, 14)
    DEP_FIELD(REQ_PWRUP_STATUS, TCM0B, 1, 13)
    DEP_FIELD(REQ_PWRUP_STATUS, TCM0A, 1, 12)
    DEP_FIELD(REQ_PWRUP_STATUS, RPU, 1, 10)
    DEP_FIELD(REQ_PWRUP_STATUS, L2_BANK0, 1, 7)
    DEP_FIELD(REQ_PWRUP_STATUS, PP1, 1, 5)
    DEP_FIELD(REQ_PWRUP_STATUS, PP0, 1, 4)
    DEP_FIELD(REQ_PWRUP_STATUS, ACPU3, 1, 3)
    DEP_FIELD(REQ_PWRUP_STATUS, ACPU2, 1, 2)
    DEP_FIELD(REQ_PWRUP_STATUS, ACPU1, 1, 1)
    DEP_FIELD(REQ_PWRUP_STATUS, ACPU0, 1, 0)
DEP_REG32(REQ_PWRUP_INT_MASK, 0x114)
    DEP_FIELD(REQ_PWRUP_INT_MASK, PL, 1, 23)
    DEP_FIELD(REQ_PWRUP_INT_MASK, FP, 1, 22)
    DEP_FIELD(REQ_PWRUP_INT_MASK, USB1, 1, 21)
    DEP_FIELD(REQ_PWRUP_INT_MASK, USB0, 1, 20)
    DEP_FIELD(REQ_PWRUP_INT_MASK, OCM_BANK3, 1, 19)
    DEP_FIELD(REQ_PWRUP_INT_MASK, OCM_BANK2, 1, 18)
    DEP_FIELD(REQ_PWRUP_INT_MASK, OCM_BANK1, 1, 17)
    DEP_FIELD(REQ_PWRUP_INT_MASK, OCM_BANK0, 1, 16)
    DEP_FIELD(REQ_PWRUP_INT_MASK, TCM1B, 1, 15)
    DEP_FIELD(REQ_PWRUP_INT_MASK, TCM1A, 1, 14)
    DEP_FIELD(REQ_PWRUP_INT_MASK, TCM0B, 1, 13)
    DEP_FIELD(REQ_PWRUP_INT_MASK, TCM0A, 1, 12)
    DEP_FIELD(REQ_PWRUP_INT_MASK, RPU, 1, 10)
    DEP_FIELD(REQ_PWRUP_INT_MASK, L2_BANK0, 1, 7)
    DEP_FIELD(REQ_PWRUP_INT_MASK, PP1, 1, 5)
    DEP_FIELD(REQ_PWRUP_INT_MASK, PP0, 1, 4)
    DEP_FIELD(REQ_PWRUP_INT_MASK, ACPU3, 1, 3)
    DEP_FIELD(REQ_PWRUP_INT_MASK, ACPU2, 1, 2)
    DEP_FIELD(REQ_PWRUP_INT_MASK, ACPU1, 1, 1)
    DEP_FIELD(REQ_PWRUP_INT_MASK, ACPU0, 1, 0)
DEP_REG32(REQ_PWRUP_INT_EN, 0x118)
    DEP_FIELD(REQ_PWRUP_INT_EN, PL, 1, 23)
    DEP_FIELD(REQ_PWRUP_INT_EN, FP, 1, 22)
    DEP_FIELD(REQ_PWRUP_INT_EN, USB1, 1, 21)
    DEP_FIELD(REQ_PWRUP_INT_EN, USB0, 1, 20)
    DEP_FIELD(REQ_PWRUP_INT_EN, OCM_BANK3, 1, 19)
    DEP_FIELD(REQ_PWRUP_INT_EN, OCM_BANK2, 1, 18)
    DEP_FIELD(REQ_PWRUP_INT_EN, OCM_BANK1, 1, 17)
    DEP_FIELD(REQ_PWRUP_INT_EN, OCM_BANK0, 1, 16)
    DEP_FIELD(REQ_PWRUP_INT_EN, TCM1B, 1, 15)
    DEP_FIELD(REQ_PWRUP_INT_EN, TCM1A, 1, 14)
    DEP_FIELD(REQ_PWRUP_INT_EN, TCM0B, 1, 13)
    DEP_FIELD(REQ_PWRUP_INT_EN, TCM0A, 1, 12)
    DEP_FIELD(REQ_PWRUP_INT_EN, RPU, 1, 10)
    DEP_FIELD(REQ_PWRUP_INT_EN, L2_BANK0, 1, 7)
    DEP_FIELD(REQ_PWRUP_INT_EN, PP1, 1, 5)
    DEP_FIELD(REQ_PWRUP_INT_EN, PP0, 1, 4)
    DEP_FIELD(REQ_PWRUP_INT_EN, ACPU3, 1, 3)
    DEP_FIELD(REQ_PWRUP_INT_EN, ACPU2, 1, 2)
    DEP_FIELD(REQ_PWRUP_INT_EN, ACPU1, 1, 1)
    DEP_FIELD(REQ_PWRUP_INT_EN, ACPU0, 1, 0)
DEP_REG32(REQ_PWRUP_INT_DIS, 0x11c)
    DEP_FIELD(REQ_PWRUP_INT_DIS, PL, 1, 23)
    DEP_FIELD(REQ_PWRUP_INT_DIS, FP, 1, 22)
    DEP_FIELD(REQ_PWRUP_INT_DIS, USB1, 1, 21)
    DEP_FIELD(REQ_PWRUP_INT_DIS, USB0, 1, 20)
    DEP_FIELD(REQ_PWRUP_INT_DIS, OCM_BANK3, 1, 19)
    DEP_FIELD(REQ_PWRUP_INT_DIS, OCM_BANK2, 1, 18)
    DEP_FIELD(REQ_PWRUP_INT_DIS, OCM_BANK1, 1, 17)
    DEP_FIELD(REQ_PWRUP_INT_DIS, OCM_BANK0, 1, 16)
    DEP_FIELD(REQ_PWRUP_INT_DIS, TCM1B, 1, 15)
    DEP_FIELD(REQ_PWRUP_INT_DIS, TCM1A, 1, 14)
    DEP_FIELD(REQ_PWRUP_INT_DIS, TCM0B, 1, 13)
    DEP_FIELD(REQ_PWRUP_INT_DIS, TCM0A, 1, 12)
    DEP_FIELD(REQ_PWRUP_INT_DIS, RPU, 1, 10)
    DEP_FIELD(REQ_PWRUP_INT_DIS, L2_BANK0, 1, 7)
    DEP_FIELD(REQ_PWRUP_INT_DIS, PP1, 1, 5)
    DEP_FIELD(REQ_PWRUP_INT_DIS, PP0, 1, 4)
    DEP_FIELD(REQ_PWRUP_INT_DIS, ACPU3, 1, 3)
    DEP_FIELD(REQ_PWRUP_INT_DIS, ACPU2, 1, 2)
    DEP_FIELD(REQ_PWRUP_INT_DIS, ACPU1, 1, 1)
    DEP_FIELD(REQ_PWRUP_INT_DIS, ACPU0, 1, 0)
DEP_REG32(REQ_PWRUP_TRIG, 0x120)
    DEP_FIELD(REQ_PWRUP_TRIG, PL, 1, 23)
    DEP_FIELD(REQ_PWRUP_TRIG, FP, 1, 22)
    DEP_FIELD(REQ_PWRUP_TRIG, USB1, 1, 21)
    DEP_FIELD(REQ_PWRUP_TRIG, USB0, 1, 20)
    DEP_FIELD(REQ_PWRUP_TRIG, OCM_BANK3, 1, 19)
    DEP_FIELD(REQ_PWRUP_TRIG, OCM_BANK2, 1, 18)
    DEP_FIELD(REQ_PWRUP_TRIG, OCM_BANK1, 1, 17)
    DEP_FIELD(REQ_PWRUP_TRIG, OCM_BANK0, 1, 16)
    DEP_FIELD(REQ_PWRUP_TRIG, TCM1B, 1, 15)
    DEP_FIELD(REQ_PWRUP_TRIG, TCM1A, 1, 14)
    DEP_FIELD(REQ_PWRUP_TRIG, TCM0B, 1, 13)
    DEP_FIELD(REQ_PWRUP_TRIG, TCM0A, 1, 12)
    DEP_FIELD(REQ_PWRUP_TRIG, RPU, 1, 10)
    DEP_FIELD(REQ_PWRUP_TRIG, L2_BANK0, 1, 7)
    DEP_FIELD(REQ_PWRUP_TRIG, PP1, 1, 5)
    DEP_FIELD(REQ_PWRUP_TRIG, PP0, 1, 4)
    DEP_FIELD(REQ_PWRUP_TRIG, ACPU3, 1, 3)
    DEP_FIELD(REQ_PWRUP_TRIG, ACPU2, 1, 2)
    DEP_FIELD(REQ_PWRUP_TRIG, ACPU1, 1, 1)
    DEP_FIELD(REQ_PWRUP_TRIG, ACPU0, 1, 0)
DEP_REG32(REQ_PWRDWN_STATUS, 0x210)
    DEP_FIELD(REQ_PWRDWN_STATUS, PL, 1, 23)
    DEP_FIELD(REQ_PWRDWN_STATUS, FP, 1, 22)
    DEP_FIELD(REQ_PWRDWN_STATUS, USB1, 1, 21)
    DEP_FIELD(REQ_PWRDWN_STATUS, USB0, 1, 20)
    DEP_FIELD(REQ_PWRDWN_STATUS, OCM_BANK3, 1, 19)
    DEP_FIELD(REQ_PWRDWN_STATUS, OCM_BANK2, 1, 18)
    DEP_FIELD(REQ_PWRDWN_STATUS, OCM_BANK1, 1, 17)
    DEP_FIELD(REQ_PWRDWN_STATUS, OCM_BANK0, 1, 16)
    DEP_FIELD(REQ_PWRDWN_STATUS, TCM1B, 1, 15)
    DEP_FIELD(REQ_PWRDWN_STATUS, TCM1A, 1, 14)
    DEP_FIELD(REQ_PWRDWN_STATUS, TCM0B, 1, 13)
    DEP_FIELD(REQ_PWRDWN_STATUS, TCM0A, 1, 12)
    DEP_FIELD(REQ_PWRDWN_STATUS, RPU, 1, 10)
    DEP_FIELD(REQ_PWRDWN_STATUS, L2_BANK0, 1, 7)
    DEP_FIELD(REQ_PWRDWN_STATUS, PP1, 1, 5)
    DEP_FIELD(REQ_PWRDWN_STATUS, PP0, 1, 4)
    DEP_FIELD(REQ_PWRDWN_STATUS, ACPU3, 1, 3)
    DEP_FIELD(REQ_PWRDWN_STATUS, ACPU2, 1, 2)
    DEP_FIELD(REQ_PWRDWN_STATUS, ACPU1, 1, 1)
    DEP_FIELD(REQ_PWRDWN_STATUS, ACPU0, 1, 0)
DEP_REG32(REQ_PWRDWN_INT_MASK, 0x214)
    DEP_FIELD(REQ_PWRDWN_INT_MASK, PL, 1, 23)
    DEP_FIELD(REQ_PWRDWN_INT_MASK, FP, 1, 22)
    DEP_FIELD(REQ_PWRDWN_INT_MASK, USB1, 1, 21)
    DEP_FIELD(REQ_PWRDWN_INT_MASK, USB0, 1, 20)
    DEP_FIELD(REQ_PWRDWN_INT_MASK, OCM_BANK3, 1, 19)
    DEP_FIELD(REQ_PWRDWN_INT_MASK, OCM_BANK2, 1, 18)
    DEP_FIELD(REQ_PWRDWN_INT_MASK, OCM_BANK1, 1, 17)
    DEP_FIELD(REQ_PWRDWN_INT_MASK, OCM_BANK0, 1, 16)
    DEP_FIELD(REQ_PWRDWN_INT_MASK, TCM1B, 1, 15)
    DEP_FIELD(REQ_PWRDWN_INT_MASK, TCM1A, 1, 14)
    DEP_FIELD(REQ_PWRDWN_INT_MASK, TCM0B, 1, 13)
    DEP_FIELD(REQ_PWRDWN_INT_MASK, TCM0A, 1, 12)
    DEP_FIELD(REQ_PWRDWN_INT_MASK, RPU, 1, 10)
    DEP_FIELD(REQ_PWRDWN_INT_MASK, L2_BANK0, 1, 7)
    DEP_FIELD(REQ_PWRDWN_INT_MASK, PP1, 1, 5)
    DEP_FIELD(REQ_PWRDWN_INT_MASK, PP0, 1, 4)
    DEP_FIELD(REQ_PWRDWN_INT_MASK, ACPU3, 1, 3)
    DEP_FIELD(REQ_PWRDWN_INT_MASK, ACPU2, 1, 2)
    DEP_FIELD(REQ_PWRDWN_INT_MASK, ACPU1, 1, 1)
    DEP_FIELD(REQ_PWRDWN_INT_MASK, ACPU0, 1, 0)
DEP_REG32(REQ_PWRDWN_INT_EN, 0x218)
    DEP_FIELD(REQ_PWRDWN_INT_EN, PL, 1, 23)
    DEP_FIELD(REQ_PWRDWN_INT_EN, FP, 1, 22)
    DEP_FIELD(REQ_PWRDWN_INT_EN, USB1, 1, 21)
    DEP_FIELD(REQ_PWRDWN_INT_EN, USB0, 1, 20)
    DEP_FIELD(REQ_PWRDWN_INT_EN, OCM_BANK3, 1, 19)
    DEP_FIELD(REQ_PWRDWN_INT_EN, OCM_BANK2, 1, 18)
    DEP_FIELD(REQ_PWRDWN_INT_EN, OCM_BANK1, 1, 17)
    DEP_FIELD(REQ_PWRDWN_INT_EN, OCM_BANK0, 1, 16)
    DEP_FIELD(REQ_PWRDWN_INT_EN, TCM1B, 1, 15)
    DEP_FIELD(REQ_PWRDWN_INT_EN, TCM1A, 1, 14)
    DEP_FIELD(REQ_PWRDWN_INT_EN, TCM0B, 1, 13)
    DEP_FIELD(REQ_PWRDWN_INT_EN, TCM0A, 1, 12)
    DEP_FIELD(REQ_PWRDWN_INT_EN, RPU, 1, 10)
    DEP_FIELD(REQ_PWRDWN_INT_EN, L2_BANK0, 1, 7)
    DEP_FIELD(REQ_PWRDWN_INT_EN, PP1, 1, 5)
    DEP_FIELD(REQ_PWRDWN_INT_EN, PP0, 1, 4)
    DEP_FIELD(REQ_PWRDWN_INT_EN, ACPU3, 1, 3)
    DEP_FIELD(REQ_PWRDWN_INT_EN, ACPU2, 1, 2)
    DEP_FIELD(REQ_PWRDWN_INT_EN, ACPU1, 1, 1)
    DEP_FIELD(REQ_PWRDWN_INT_EN, ACPU0, 1, 0)
DEP_REG32(REQ_PWRDWN_INT_DIS, 0x21c)
    DEP_FIELD(REQ_PWRDWN_INT_DIS, PL, 1, 23)
    DEP_FIELD(REQ_PWRDWN_INT_DIS, FP, 1, 22)
    DEP_FIELD(REQ_PWRDWN_INT_DIS, USB1, 1, 21)
    DEP_FIELD(REQ_PWRDWN_INT_DIS, USB0, 1, 20)
    DEP_FIELD(REQ_PWRDWN_INT_DIS, OCM_BANK3, 1, 19)
    DEP_FIELD(REQ_PWRDWN_INT_DIS, OCM_BANK2, 1, 18)
    DEP_FIELD(REQ_PWRDWN_INT_DIS, OCM_BANK1, 1, 17)
    DEP_FIELD(REQ_PWRDWN_INT_DIS, OCM_BANK0, 1, 16)
    DEP_FIELD(REQ_PWRDWN_INT_DIS, TCM1B, 1, 15)
    DEP_FIELD(REQ_PWRDWN_INT_DIS, TCM1A, 1, 14)
    DEP_FIELD(REQ_PWRDWN_INT_DIS, TCM0B, 1, 13)
    DEP_FIELD(REQ_PWRDWN_INT_DIS, TCM0A, 1, 12)
    DEP_FIELD(REQ_PWRDWN_INT_DIS, RPU, 1, 10)
    DEP_FIELD(REQ_PWRDWN_INT_DIS, L2_BANK0, 1, 7)
    DEP_FIELD(REQ_PWRDWN_INT_DIS, PP1, 1, 5)
    DEP_FIELD(REQ_PWRDWN_INT_DIS, PP0, 1, 4)
    DEP_FIELD(REQ_PWRDWN_INT_DIS, ACPU3, 1, 3)
    DEP_FIELD(REQ_PWRDWN_INT_DIS, ACPU2, 1, 2)
    DEP_FIELD(REQ_PWRDWN_INT_DIS, ACPU1, 1, 1)
    DEP_FIELD(REQ_PWRDWN_INT_DIS, ACPU0, 1, 0)
DEP_REG32(REQ_PWRDWN_TRIG, 0x220)
    DEP_FIELD(REQ_PWRDWN_TRIG, PL, 1, 23)
    DEP_FIELD(REQ_PWRDWN_TRIG, FP, 1, 22)
    DEP_FIELD(REQ_PWRDWN_TRIG, USB1, 1, 21)
    DEP_FIELD(REQ_PWRDWN_TRIG, USB0, 1, 20)
    DEP_FIELD(REQ_PWRDWN_TRIG, OCM_BANK3, 1, 19)
    DEP_FIELD(REQ_PWRDWN_TRIG, OCM_BANK2, 1, 18)
    DEP_FIELD(REQ_PWRDWN_TRIG, OCM_BANK1, 1, 17)
    DEP_FIELD(REQ_PWRDWN_TRIG, OCM_BANK0, 1, 16)
    DEP_FIELD(REQ_PWRDWN_TRIG, TCM1B, 1, 15)
    DEP_FIELD(REQ_PWRDWN_TRIG, TCM1A, 1, 14)
    DEP_FIELD(REQ_PWRDWN_TRIG, TCM0B, 1, 13)
    DEP_FIELD(REQ_PWRDWN_TRIG, TCM0A, 1, 12)
    DEP_FIELD(REQ_PWRDWN_TRIG, RPU, 1, 10)
    DEP_FIELD(REQ_PWRDWN_TRIG, L2_BANK0, 1, 7)
    DEP_FIELD(REQ_PWRDWN_TRIG, PP1, 1, 5)
    DEP_FIELD(REQ_PWRDWN_TRIG, PP0, 1, 4)
    DEP_FIELD(REQ_PWRDWN_TRIG, ACPU3, 1, 3)
    DEP_FIELD(REQ_PWRDWN_TRIG, ACPU2, 1, 2)
    DEP_FIELD(REQ_PWRDWN_TRIG, ACPU1, 1, 1)
    DEP_FIELD(REQ_PWRDWN_TRIG, ACPU0, 1, 0)
DEP_REG32(REQ_ISO_STATUS, 0x310)
    DEP_FIELD(REQ_ISO_STATUS, FP_LOCKED, 1, 4)
    DEP_FIELD(REQ_ISO_STATUS, PL, 1, 1)
    DEP_FIELD(REQ_ISO_STATUS, FP, 1, 0)
DEP_REG32(REQ_ISO_INT_MASK, 0x314)
    DEP_FIELD(REQ_ISO_INT_MASK, FP_LOCKED, 1, 4)
    DEP_FIELD(REQ_ISO_INT_MASK, PL, 1, 1)
    DEP_FIELD(REQ_ISO_INT_MASK, FP, 1, 0)
DEP_REG32(REQ_ISO_INT_EN, 0x318)
    DEP_FIELD(REQ_ISO_INT_EN, FP_LOCKED, 1, 4)
    DEP_FIELD(REQ_ISO_INT_EN, PL, 1, 1)
    DEP_FIELD(REQ_ISO_INT_EN, FP, 1, 0)
DEP_REG32(REQ_ISO_INT_DIS, 0x31c)
    DEP_FIELD(REQ_ISO_INT_DIS, FP_LOCKED, 1, 4)
    DEP_FIELD(REQ_ISO_INT_DIS, PL, 1, 1)
    DEP_FIELD(REQ_ISO_INT_DIS, FP, 1, 0)
DEP_REG32(REQ_ISO_TRIG, 0x320)
    DEP_FIELD(REQ_ISO_TRIG, FP_LOCKED, 1, 4)
    DEP_FIELD(REQ_ISO_TRIG, PL, 1, 1)
    DEP_FIELD(REQ_ISO_TRIG, FP, 1, 0)
DEP_REG32(REQ_SWRST_STATUS, 0x410)
    DEP_FIELD(REQ_SWRST_STATUS, PL, 1, 31)
    DEP_FIELD(REQ_SWRST_STATUS, FP, 1, 30)
    DEP_FIELD(REQ_SWRST_STATUS, LP, 1, 29)
    DEP_FIELD(REQ_SWRST_STATUS, PS_ONLY, 1, 28)
    DEP_FIELD(REQ_SWRST_STATUS, IOU, 1, 27)
    DEP_FIELD(REQ_SWRST_STATUS, USB1, 1, 25)
    DEP_FIELD(REQ_SWRST_STATUS, USB0, 1, 24)
    DEP_FIELD(REQ_SWRST_STATUS, GEM3, 1, 23)
    DEP_FIELD(REQ_SWRST_STATUS, GEM2, 1, 22)
    DEP_FIELD(REQ_SWRST_STATUS, GEM1, 1, 21)
    DEP_FIELD(REQ_SWRST_STATUS, GEM0, 1, 20)
    DEP_FIELD(REQ_SWRST_STATUS, LS_R5, 1, 18)
    DEP_FIELD(REQ_SWRST_STATUS, R5_1, 1, 17)
    DEP_FIELD(REQ_SWRST_STATUS, R5_0, 1, 16)
    DEP_FIELD(REQ_SWRST_STATUS, DISPLAY_PORT, 1, 12)
    DEP_FIELD(REQ_SWRST_STATUS, SATA, 1, 10)
    DEP_FIELD(REQ_SWRST_STATUS, PCIE, 1, 9)
    DEP_FIELD(REQ_SWRST_STATUS, GPU, 1, 8)
    DEP_FIELD(REQ_SWRST_STATUS, PP1, 1, 7)
    DEP_FIELD(REQ_SWRST_STATUS, PP0, 1, 6)
    DEP_FIELD(REQ_SWRST_STATUS, APU, 1, 4)
    DEP_FIELD(REQ_SWRST_STATUS, ACPU3, 1, 3)
    DEP_FIELD(REQ_SWRST_STATUS, ACPU2, 1, 2)
    DEP_FIELD(REQ_SWRST_STATUS, ACPU1, 1, 1)
    DEP_FIELD(REQ_SWRST_STATUS, ACPU0, 1, 0)
DEP_REG32(REQ_SWRST_INT_MASK, 0x414)
    DEP_FIELD(REQ_SWRST_INT_MASK, PL, 1, 31)
    DEP_FIELD(REQ_SWRST_INT_MASK, FP, 1, 30)
    DEP_FIELD(REQ_SWRST_INT_MASK, LP, 1, 29)
    DEP_FIELD(REQ_SWRST_INT_MASK, PS_ONLY, 1, 28)
    DEP_FIELD(REQ_SWRST_INT_MASK, IOU, 1, 27)
    DEP_FIELD(REQ_SWRST_INT_MASK, USB1, 1, 25)
    DEP_FIELD(REQ_SWRST_INT_MASK, USB0, 1, 24)
    DEP_FIELD(REQ_SWRST_INT_MASK, GEM3, 1, 23)
    DEP_FIELD(REQ_SWRST_INT_MASK, GEM2, 1, 22)
    DEP_FIELD(REQ_SWRST_INT_MASK, GEM1, 1, 21)
    DEP_FIELD(REQ_SWRST_INT_MASK, GEM0, 1, 20)
    DEP_FIELD(REQ_SWRST_INT_MASK, LS_R5, 1, 18)
    DEP_FIELD(REQ_SWRST_INT_MASK, R5_1, 1, 17)
    DEP_FIELD(REQ_SWRST_INT_MASK, R5_0, 1, 16)
    DEP_FIELD(REQ_SWRST_INT_MASK, DISPLAY_PORT, 1, 12)
    DEP_FIELD(REQ_SWRST_INT_MASK, SATA, 1, 10)
    DEP_FIELD(REQ_SWRST_INT_MASK, PCIE, 1, 9)
    DEP_FIELD(REQ_SWRST_INT_MASK, GPU, 1, 8)
    DEP_FIELD(REQ_SWRST_INT_MASK, PP1, 1, 7)
    DEP_FIELD(REQ_SWRST_INT_MASK, PP0, 1, 6)
    DEP_FIELD(REQ_SWRST_INT_MASK, APU, 1, 4)
    DEP_FIELD(REQ_SWRST_INT_MASK, ACPU3, 1, 3)
    DEP_FIELD(REQ_SWRST_INT_MASK, ACPU2, 1, 2)
    DEP_FIELD(REQ_SWRST_INT_MASK, ACPU1, 1, 1)
    DEP_FIELD(REQ_SWRST_INT_MASK, ACPU0, 1, 0)
DEP_REG32(REQ_SWRST_INT_EN, 0x418)
    DEP_FIELD(REQ_SWRST_INT_EN, PL, 1, 31)
    DEP_FIELD(REQ_SWRST_INT_EN, FP, 1, 30)
    DEP_FIELD(REQ_SWRST_INT_EN, LP, 1, 29)
    DEP_FIELD(REQ_SWRST_INT_EN, PS_ONLY, 1, 28)
    DEP_FIELD(REQ_SWRST_INT_EN, IOU, 1, 27)
    DEP_FIELD(REQ_SWRST_INT_EN, USB1, 1, 25)
    DEP_FIELD(REQ_SWRST_INT_EN, USB0, 1, 24)
    DEP_FIELD(REQ_SWRST_INT_EN, GEM3, 1, 23)
    DEP_FIELD(REQ_SWRST_INT_EN, GEM2, 1, 22)
    DEP_FIELD(REQ_SWRST_INT_EN, GEM1, 1, 21)
    DEP_FIELD(REQ_SWRST_INT_EN, GEM0, 1, 20)
    DEP_FIELD(REQ_SWRST_INT_EN, LS_R5, 1, 18)
    DEP_FIELD(REQ_SWRST_INT_EN, R5_1, 1, 17)
    DEP_FIELD(REQ_SWRST_INT_EN, R5_0, 1, 16)
    DEP_FIELD(REQ_SWRST_INT_EN, DISPLAY_PORT, 1, 12)
    DEP_FIELD(REQ_SWRST_INT_EN, SATA, 1, 10)
    DEP_FIELD(REQ_SWRST_INT_EN, PCIE, 1, 9)
    DEP_FIELD(REQ_SWRST_INT_EN, GPU, 1, 8)
    DEP_FIELD(REQ_SWRST_INT_EN, PP1, 1, 7)
    DEP_FIELD(REQ_SWRST_INT_EN, PP0, 1, 6)
    DEP_FIELD(REQ_SWRST_INT_EN, APU, 1, 4)
    DEP_FIELD(REQ_SWRST_INT_EN, ACPU3, 1, 3)
    DEP_FIELD(REQ_SWRST_INT_EN, ACPU2, 1, 2)
    DEP_FIELD(REQ_SWRST_INT_EN, ACPU1, 1, 1)
    DEP_FIELD(REQ_SWRST_INT_EN, ACPU0, 1, 0)
DEP_REG32(REQ_SWRST_INT_DIS, 0x41c)
    DEP_FIELD(REQ_SWRST_INT_DIS, PL, 1, 31)
    DEP_FIELD(REQ_SWRST_INT_DIS, FP, 1, 30)
    DEP_FIELD(REQ_SWRST_INT_DIS, LP, 1, 29)
    DEP_FIELD(REQ_SWRST_INT_DIS, PS_ONLY, 1, 28)
    DEP_FIELD(REQ_SWRST_INT_DIS, IOU, 1, 27)
    DEP_FIELD(REQ_SWRST_INT_DIS, USB1, 1, 25)
    DEP_FIELD(REQ_SWRST_INT_DIS, USB0, 1, 24)
    DEP_FIELD(REQ_SWRST_INT_DIS, GEM3, 1, 23)
    DEP_FIELD(REQ_SWRST_INT_DIS, GEM2, 1, 22)
    DEP_FIELD(REQ_SWRST_INT_DIS, GEM1, 1, 21)
    DEP_FIELD(REQ_SWRST_INT_DIS, GEM0, 1, 20)
    DEP_FIELD(REQ_SWRST_INT_DIS, LS_R5, 1, 18)
    DEP_FIELD(REQ_SWRST_INT_DIS, R5_1, 1, 17)
    DEP_FIELD(REQ_SWRST_INT_DIS, R5_0, 1, 16)
    DEP_FIELD(REQ_SWRST_INT_DIS, DISPLAY_PORT, 1, 12)
    DEP_FIELD(REQ_SWRST_INT_DIS, SATA, 1, 10)
    DEP_FIELD(REQ_SWRST_INT_DIS, PCIE, 1, 9)
    DEP_FIELD(REQ_SWRST_INT_DIS, GPU, 1, 8)
    DEP_FIELD(REQ_SWRST_INT_DIS, PP1, 1, 7)
    DEP_FIELD(REQ_SWRST_INT_DIS, PP0, 1, 6)
    DEP_FIELD(REQ_SWRST_INT_DIS, APU, 1, 4)
    DEP_FIELD(REQ_SWRST_INT_DIS, ACPU3, 1, 3)
    DEP_FIELD(REQ_SWRST_INT_DIS, ACPU2, 1, 2)
    DEP_FIELD(REQ_SWRST_INT_DIS, ACPU1, 1, 1)
    DEP_FIELD(REQ_SWRST_INT_DIS, ACPU0, 1, 0)
DEP_REG32(REQ_SWRST_TRIG, 0x420)
    DEP_FIELD(REQ_SWRST_TRIG, PL, 1, 31)
    DEP_FIELD(REQ_SWRST_TRIG, FP, 1, 30)
    DEP_FIELD(REQ_SWRST_TRIG, LP, 1, 29)
    DEP_FIELD(REQ_SWRST_TRIG, PS_ONLY, 1, 28)
    DEP_FIELD(REQ_SWRST_TRIG, IOU, 1, 27)
    DEP_FIELD(REQ_SWRST_TRIG, USB1, 1, 25)
    DEP_FIELD(REQ_SWRST_TRIG, USB0, 1, 24)
    DEP_FIELD(REQ_SWRST_TRIG, GEM3, 1, 23)
    DEP_FIELD(REQ_SWRST_TRIG, GEM2, 1, 22)
    DEP_FIELD(REQ_SWRST_TRIG, GEM1, 1, 21)
    DEP_FIELD(REQ_SWRST_TRIG, GEM0, 1, 20)
    DEP_FIELD(REQ_SWRST_TRIG, LS_R5, 1, 18)
    DEP_FIELD(REQ_SWRST_TRIG, R5_1, 1, 17)
    DEP_FIELD(REQ_SWRST_TRIG, R5_0, 1, 16)
    DEP_FIELD(REQ_SWRST_TRIG, DISPLAY_PORT, 1, 12)
    DEP_FIELD(REQ_SWRST_TRIG, SATA, 1, 10)
    DEP_FIELD(REQ_SWRST_TRIG, PCIE, 1, 9)
    DEP_FIELD(REQ_SWRST_TRIG, GPU, 1, 8)
    DEP_FIELD(REQ_SWRST_TRIG, PP1, 1, 7)
    DEP_FIELD(REQ_SWRST_TRIG, PP0, 1, 6)
    DEP_FIELD(REQ_SWRST_TRIG, APU, 1, 4)
    DEP_FIELD(REQ_SWRST_TRIG, ACPU3, 1, 3)
    DEP_FIELD(REQ_SWRST_TRIG, ACPU2, 1, 2)
    DEP_FIELD(REQ_SWRST_TRIG, ACPU1, 1, 1)
    DEP_FIELD(REQ_SWRST_TRIG, ACPU0, 1, 0)
DEP_REG32(REQ_AUX_STATUS, 0x510)
    DEP_FIELD(REQ_AUX_STATUS, SERV_REQ_10, 1, 17)
    DEP_FIELD(REQ_AUX_STATUS, SERV_REQ_9, 1, 16)
    DEP_FIELD(REQ_AUX_STATUS, SERV_REQ_8, 1, 13)
    DEP_FIELD(REQ_AUX_STATUS, SERV_REQ_7, 1, 12)
    DEP_FIELD(REQ_AUX_STATUS, SERV_REQ_6, 1, 10)
    DEP_FIELD(REQ_AUX_STATUS, SERV_REQ_5, 1, 7)
    DEP_FIELD(REQ_AUX_STATUS, SERV_REQ_4, 1, 6)
    DEP_FIELD(REQ_AUX_STATUS, SERV_REQ_3, 1, 3)
    DEP_FIELD(REQ_AUX_STATUS, SERV_REQ_2, 1, 2)
    DEP_FIELD(REQ_AUX_STATUS, SERV_REQ_1, 1, 1)
    DEP_FIELD(REQ_AUX_STATUS, SERV_REQ_0, 1, 0)
DEP_REG32(REQ_AUX_INT_MASK, 0x514)
    DEP_FIELD(REQ_AUX_MASK, SERV_REQ_10, 1, 17)
    DEP_FIELD(REQ_AUX_MASK, SERV_REQ_9, 1, 16)
    DEP_FIELD(REQ_AUX_MASK, SERV_REQ_8, 1, 13)
    DEP_FIELD(REQ_AUX_MASK, SERV_REQ_7, 1, 12)
    DEP_FIELD(REQ_AUX_MASK, SERV_REQ_6, 1, 10)
    DEP_FIELD(REQ_AUX_MASK, SERV_REQ_5, 1, 7)
    DEP_FIELD(REQ_AUX_MASK, SERV_REQ_4, 1, 6)
    DEP_FIELD(REQ_AUX_MASK, SERV_REQ_3, 1, 3)
    DEP_FIELD(REQ_AUX_MASK, SERV_REQ_2, 1, 2)
    DEP_FIELD(REQ_AUX_MASK, SERV_REQ_1, 1, 1)
    DEP_FIELD(REQ_AUX_MASK, SERV_REQ_0, 1, 0)
DEP_REG32(REQ_AUX_INT_EN, 0x518)
    DEP_FIELD(REQ_AUX_INT_EN, SERV_REQ_10, 1, 17)
    DEP_FIELD(REQ_AUX_INT_EN, SERV_REQ_9, 1, 16)
    DEP_FIELD(REQ_AUX_INT_EN, SERV_REQ_8, 1, 13)
    DEP_FIELD(REQ_AUX_INT_EN, SERV_REQ_7, 1, 12)
    DEP_FIELD(REQ_AUX_INT_EN, SERV_REQ_6, 1, 10)
    DEP_FIELD(REQ_AUX_INT_EN, SERV_REQ_5, 1, 7)
    DEP_FIELD(REQ_AUX_INT_EN, SERV_REQ_4, 1, 6)
    DEP_FIELD(REQ_AUX_INT_EN, SERV_REQ_3, 1, 3)
    DEP_FIELD(REQ_AUX_INT_EN, SERV_REQ_2, 1, 2)
    DEP_FIELD(REQ_AUX_INT_EN, SERV_REQ_1, 1, 1)
    DEP_FIELD(REQ_AUX_INT_EN, SERV_REQ_0, 1, 0)
DEP_REG32(REQ_AUX_INT_DIS, 0x51c)
    DEP_FIELD(REQ_AUX_INT_DIS, SERV_REQ_10, 1, 17)
    DEP_FIELD(REQ_AUX_INT_DIS, SERV_REQ_9, 1, 16)
    DEP_FIELD(REQ_AUX_INT_DIS, SERV_REQ_8, 1, 13)
    DEP_FIELD(REQ_AUX_INT_DIS, SERV_REQ_7, 1, 12)
    DEP_FIELD(REQ_AUX_INT_DIS, SERV_REQ_6, 1, 10)
    DEP_FIELD(REQ_AUX_INT_DIS, SERV_REQ_5, 1, 7)
    DEP_FIELD(REQ_AUX_INT_DIS, SERV_REQ_4, 1, 6)
    DEP_FIELD(REQ_AUX_INT_DIS, SERV_REQ_3, 1, 3)
    DEP_FIELD(REQ_AUX_INT_DIS, SERV_REQ_2, 1, 2)
    DEP_FIELD(REQ_AUX_INT_DIS, SERV_REQ_1, 1, 1)
    DEP_FIELD(REQ_AUX_INT_DIS, SERV_REQ_0, 1, 0)
DEP_REG32(REQ_AUX_TRIG, 0x520)
    DEP_FIELD(REQ_AUX_TRIG, SERV_REQ_10, 1, 17)
    DEP_FIELD(REQ_AUX_TRIG, SERV_REQ_9, 1, 16)
    DEP_FIELD(REQ_AUX_TRIG, SERV_REQ_8, 1, 13)
    DEP_FIELD(REQ_AUX_TRIG, SERV_REQ_7, 1, 12)
    DEP_FIELD(REQ_AUX_TRIG, SERV_REQ_6, 1, 10)
    DEP_FIELD(REQ_AUX_TRIG, SERV_REQ_5, 1, 7)
    DEP_FIELD(REQ_AUX_TRIG, SERV_REQ_4, 1, 6)
    DEP_FIELD(REQ_AUX_TRIG, SERV_REQ_3, 1, 3)
    DEP_FIELD(REQ_AUX_TRIG, SERV_REQ_2, 1, 2)
    DEP_FIELD(REQ_AUX_TRIG, SERV_REQ_1, 1, 1)
    DEP_FIELD(REQ_AUX_TRIG, SERV_REQ_0, 1, 0)
DEP_REG32(LOGCLR_STATUS, 0x524)
    DEP_FIELD(LOGCLR_STATUS, FP, 1, 17)
    DEP_FIELD(LOGCLR_STATUS, LP, 1, 16)
    DEP_FIELD(LOGCLR_STATUS, USB1, 1, 13)
    DEP_FIELD(LOGCLR_STATUS, USB0, 1, 12)
    DEP_FIELD(LOGCLR_STATUS, RPU, 1, 10)
    DEP_FIELD(LOGCLR_STATUS, PP1, 1, 7)
    DEP_FIELD(LOGCLR_STATUS, PP0, 1, 6)
    DEP_FIELD(LOGCLR_STATUS, ACPU3, 1, 3)
    DEP_FIELD(LOGCLR_STATUS, ACPU2, 1, 2)
    DEP_FIELD(LOGCLR_STATUS, ACPU1, 1, 1)
    DEP_FIELD(LOGCLR_STATUS, ACPU0, 1, 0)
DEP_REG32(CSU_BR_ERROR, 0x528)
    DEP_FIELD(CSU_BR_ERROR, BR_ERROR, 1, 31)
    DEP_FIELD(CSU_BR_ERROR, ERR_TYPE, 16, 0)
DEP_REG32(MB_FAULT_STATUS, 0x52c)
    DEP_FIELD(MB_FAULT_STATUS, R_FFAIL, 8, 24)
    DEP_FIELD(MB_FAULT_STATUS, R_SLEEP_RST, 1, 19)
    DEP_FIELD(MB_FAULT_STATUS, R_LSFAIL, 3, 16)
    DEP_FIELD(MB_FAULT_STATUS, N_FFAIL, 8, 8)
    DEP_FIELD(MB_FAULT_STATUS, N_SLEEP_RST, 1, 3)
    DEP_FIELD(MB_FAULT_STATUS, N_LSFAIL, 3, 0)
DEP_REG32(ERROR_STATUS_1, 0x530)
    DEP_FIELD(ERROR_STATUS_1, AUX3, 1, 31)
    DEP_FIELD(ERROR_STATUS_1, AUX2, 1, 30)
    DEP_FIELD(ERROR_STATUS_1, AUX1, 1, 29)
    DEP_FIELD(ERROR_STATUS_1, AUX0, 1, 28)
    DEP_FIELD(ERROR_STATUS_1, DFT, 1, 27)
    DEP_FIELD(ERROR_STATUS_1, CLK_MON, 1, 26)
    DEP_FIELD(ERROR_STATUS_1, XMPU, 2, 24)
    DEP_FIELD(ERROR_STATUS_1, PWR_SUPPLY, 8, 16)
    DEP_FIELD(ERROR_STATUS_1, FPD_SWDT, 1, 13)
    DEP_FIELD(ERROR_STATUS_1, LPD_SWDT, 1, 12)
    DEP_FIELD(ERROR_STATUS_1, RPU_CCF, 1, 9)
    DEP_FIELD(ERROR_STATUS_1, RPU_LS, 2, 6)
    DEP_FIELD(ERROR_STATUS_1, FPD_TEMP, 1, 5)
    DEP_FIELD(ERROR_STATUS_1, LPD_TEMP, 1, 4)
    DEP_FIELD(ERROR_STATUS_1, RPU1, 1, 3)
    DEP_FIELD(ERROR_STATUS_1, RPU0, 1, 2)
    DEP_FIELD(ERROR_STATUS_1, OCM_ECC, 1, 1)
    DEP_FIELD(ERROR_STATUS_1, DDR_ECC, 1, 0)
DEP_REG32(ERROR_INT_MASK_1, 0x534)
    DEP_FIELD(ERROR_INT_MASK_1, AUX3, 1, 31)
    DEP_FIELD(ERROR_INT_MASK_1, AUX2, 1, 30)
    DEP_FIELD(ERROR_INT_MASK_1, AUX1, 1, 29)
    DEP_FIELD(ERROR_INT_MASK_1, AUX0, 1, 28)
    DEP_FIELD(ERROR_INT_MASK_1, DFT, 1, 27)
    DEP_FIELD(ERROR_INT_MASK_1, CLK_MON, 1, 26)
    DEP_FIELD(ERROR_INT_MASK_1, XMPU, 2, 24)
    DEP_FIELD(ERROR_INT_MASK_1, PWR_SUPPLY, 8, 16)
    DEP_FIELD(ERROR_INT_MASK_1, FPD_SWDT, 1, 13)
    DEP_FIELD(ERROR_INT_MASK_1, LPD_SWDT, 1, 12)
    DEP_FIELD(ERROR_INT_MASK_1, RPU_CCF, 1, 9)
    DEP_FIELD(ERROR_INT_MASK_1, RPU_LS, 2, 6)
    DEP_FIELD(ERROR_INT_MASK_1, FPD_TEMP, 1, 5)
    DEP_FIELD(ERROR_INT_MASK_1, LPD_TEMP, 1, 4)
    DEP_FIELD(ERROR_INT_MASK_1, RPU1, 1, 3)
    DEP_FIELD(ERROR_INT_MASK_1, RPU0, 1, 2)
    DEP_FIELD(ERROR_INT_MASK_1, OCM_ECC, 1, 1)
    DEP_FIELD(ERROR_INT_MASK_1, DDR_ECC, 1, 0)
DEP_REG32(ERROR_INT_EN_1, 0x538)
    DEP_FIELD(ERROR_INT_EN_1, AUX3, 1, 31)
    DEP_FIELD(ERROR_INT_EN_1, AUX2, 1, 30)
    DEP_FIELD(ERROR_INT_EN_1, AUX1, 1, 29)
    DEP_FIELD(ERROR_INT_EN_1, AUX0, 1, 28)
    DEP_FIELD(ERROR_INT_EN_1, DFT, 1, 27)
    DEP_FIELD(ERROR_INT_EN_1, CLK_MON, 1, 26)
    DEP_FIELD(ERROR_INT_EN_1, XMPU, 2, 24)
    DEP_FIELD(ERROR_INT_EN_1, PWR_SUPPLY, 8, 16)
    DEP_FIELD(ERROR_INT_EN_1, FPD_SWDT, 1, 13)
    DEP_FIELD(ERROR_INT_EN_1, LPD_SWDT, 1, 12)
    DEP_FIELD(ERROR_INT_EN_1, RPU_CCF, 1, 9)
    DEP_FIELD(ERROR_INT_EN_1, RPU_LS, 2, 6)
    DEP_FIELD(ERROR_INT_EN_1, FPD_TEMP, 1, 5)
    DEP_FIELD(ERROR_INT_EN_1, LPD_TEMP, 1, 4)
    DEP_FIELD(ERROR_INT_EN_1, RPU1, 1, 3)
    DEP_FIELD(ERROR_INT_EN_1, RPU0, 1, 2)
    DEP_FIELD(ERROR_INT_EN_1, OCM_ECC, 1, 1)
    DEP_FIELD(ERROR_INT_EN_1, DDR_ECC, 1, 0)
DEP_REG32(ERROR_INT_DIS_1, 0x53c)
    DEP_FIELD(ERROR_INT_DIS_1, AUX3, 1, 31)
    DEP_FIELD(ERROR_INT_DIS_1, AUX2, 1, 30)
    DEP_FIELD(ERROR_INT_DIS_1, AUX1, 1, 29)
    DEP_FIELD(ERROR_INT_DIS_1, AUX0, 1, 28)
    DEP_FIELD(ERROR_INT_DIS_1, DFT, 1, 27)
    DEP_FIELD(ERROR_INT_DIS_1, CLK_MON, 1, 26)
    DEP_FIELD(ERROR_INT_DIS_1, XMPU, 2, 24)
    DEP_FIELD(ERROR_INT_DIS_1, PWR_SUPPLY, 8, 16)
    DEP_FIELD(ERROR_INT_DIS_1, FPD_SWDT, 1, 13)
    DEP_FIELD(ERROR_INT_DIS_1, LPD_SWDT, 1, 12)
    DEP_FIELD(ERROR_INT_DIS_1, RPU_CCF, 1, 9)
    DEP_FIELD(ERROR_INT_DIS_1, RPU_LS, 2, 6)
    DEP_FIELD(ERROR_INT_DIS_1, FPD_TEMP, 1, 5)
    DEP_FIELD(ERROR_INT_DIS_1, LPD_TEMP, 1, 4)
    DEP_FIELD(ERROR_INT_DIS_1, RPU1, 1, 3)
    DEP_FIELD(ERROR_INT_DIS_1, RPU0, 1, 2)
    DEP_FIELD(ERROR_INT_DIS_1, OCM_ECC, 1, 1)
    DEP_FIELD(ERROR_INT_DIS_1, DDR_ECC, 1, 0)
DEP_REG32(ERROR_STATUS_2, 0x540)
    DEP_FIELD(ERROR_STATUS_2, CSU_ROM, 1, 26)
    DEP_FIELD(ERROR_STATUS_2, PMU_PB, 1, 25)
    DEP_FIELD(ERROR_STATUS_2, PMU_SERVICE, 1, 24)
    DEP_FIELD(ERROR_STATUS_2, PMU_FW, 4, 18)
    DEP_FIELD(ERROR_STATUS_2, PMU_UC, 1, 17)
    DEP_FIELD(ERROR_STATUS_2, CSU, 1, 16)
    DEP_FIELD(ERROR_STATUS_2, PLL_LOCK, 5, 8)
    DEP_FIELD(ERROR_STATUS_2, PL, 4, 2)
    DEP_FIELD(ERROR_STATUS_2, TO, 2, 0)
DEP_REG32(ERROR_INT_MASK_2, 0x544)
    DEP_FIELD(ERROR_INT_MASK_2, CSU_ROM, 1, 26)
    DEP_FIELD(ERROR_INT_MASK_2, PMU_PB, 1, 25)
    DEP_FIELD(ERROR_INT_MASK_2, PMU_SERVICE, 1, 24)
    DEP_FIELD(ERROR_INT_MASK_2, PMU_FW, 4, 18)
    DEP_FIELD(ERROR_INT_MASK_2, PMU_UC, 1, 17)
    DEP_FIELD(ERROR_INT_MASK_2, CSU, 1, 16)
    DEP_FIELD(ERROR_INT_MASK_2, PLL_LOCK, 5, 8)
    DEP_FIELD(ERROR_INT_MASK_2, PL, 4, 2)
    DEP_FIELD(ERROR_INT_MASK_2, TO, 2, 0)
DEP_REG32(ERROR_INT_EN_2, 0x548)
    DEP_FIELD(ERROR_INT_EN_2, CSU_ROM, 1, 26)
    DEP_FIELD(ERROR_INT_EN_2, PMU_PB, 1, 25)
    DEP_FIELD(ERROR_INT_EN_2, PMU_SERVICE, 1, 24)
    DEP_FIELD(ERROR_INT_EN_2, PMU_FW, 4, 18)
    DEP_FIELD(ERROR_INT_EN_2, PMU_UC, 1, 17)
    DEP_FIELD(ERROR_INT_EN_2, CSU, 1, 16)
    DEP_FIELD(ERROR_INT_EN_2, PLL_LOCK, 5, 8)
    DEP_FIELD(ERROR_INT_EN_2, PL, 4, 2)
    DEP_FIELD(ERROR_INT_EN_2, TO, 2, 0)
DEP_REG32(ERROR_INT_DIS_2, 0x54c)
    DEP_FIELD(ERROR_INT_DIS_2, CSU_ROM, 1, 26)
    DEP_FIELD(ERROR_INT_DIS_2, PMU_PB, 1, 25)
    DEP_FIELD(ERROR_INT_DIS_2, PMU_SERVICE, 1, 24)
    DEP_FIELD(ERROR_INT_DIS_2, PMU_FW, 4, 18)
    DEP_FIELD(ERROR_INT_DIS_2, PMU_UC, 1, 17)
    DEP_FIELD(ERROR_INT_DIS_2, CSU, 1, 16)
    DEP_FIELD(ERROR_INT_DIS_2, PLL_LOCK, 5, 8)
    DEP_FIELD(ERROR_INT_DIS_2, PL, 4, 2)
    DEP_FIELD(ERROR_INT_DIS_2, TO, 2, 0)
DEP_REG32(ERROR_POR_MASK_1, 0x550)
    DEP_FIELD(ERROR_POR_MASK_1, AUX3, 1, 31)
    DEP_FIELD(ERROR_POR_MASK_1, AUX2, 1, 30)
    DEP_FIELD(ERROR_POR_MASK_1, AUX1, 1, 29)
    DEP_FIELD(ERROR_POR_MASK_1, AUX0, 1, 28)
    DEP_FIELD(ERROR_POR_MASK_1, DFT, 1, 27)
    DEP_FIELD(ERROR_POR_MASK_1, CLK_MON, 1, 26)
    DEP_FIELD(ERROR_POR_MASK_1, XMPU, 2, 24)
    DEP_FIELD(ERROR_POR_MASK_1, PWR_SUPPLY, 8, 16)
    DEP_FIELD(ERROR_POR_MASK_1, FPD_SWDT, 1, 13)
    DEP_FIELD(ERROR_POR_MASK_1, LPD_SWDT, 1, 12)
    DEP_FIELD(ERROR_POR_MASK_1, RPU_CCF, 1, 9)
    DEP_FIELD(ERROR_POR_MASK_1, RPU_LS, 2, 6)
    DEP_FIELD(ERROR_POR_MASK_1, FPD_TEMP, 1, 5)
    DEP_FIELD(ERROR_POR_MASK_1, LPD_TEMP, 1, 4)
    DEP_FIELD(ERROR_POR_MASK_1, RPU1, 1, 3)
    DEP_FIELD(ERROR_POR_MASK_1, RPU0, 1, 2)
    DEP_FIELD(ERROR_POR_MASK_1, OCM_ECC, 1, 1)
    DEP_FIELD(ERROR_POR_MASK_1, DDR_ECC, 1, 0)
DEP_REG32(ERROR_POR_EN_1, 0x554)
    DEP_FIELD(ERROR_POR_EN_1, AUX3, 1, 31)
    DEP_FIELD(ERROR_POR_EN_1, AUX2, 1, 30)
    DEP_FIELD(ERROR_POR_EN_1, AUX1, 1, 29)
    DEP_FIELD(ERROR_POR_EN_1, AUX0, 1, 28)
    DEP_FIELD(ERROR_POR_EN_1, DFT, 1, 27)
    DEP_FIELD(ERROR_POR_EN_1, CLK_MON, 1, 26)
    DEP_FIELD(ERROR_POR_EN_1, XMPU, 2, 24)
    DEP_FIELD(ERROR_POR_EN_1, PWR_SUPPLY, 8, 16)
    DEP_FIELD(ERROR_POR_EN_1, FPD_SWDT, 1, 13)
    DEP_FIELD(ERROR_POR_EN_1, LPD_SWDT, 1, 12)
    DEP_FIELD(ERROR_POR_EN_1, RPU_CCF, 1, 9)
    DEP_FIELD(ERROR_POR_EN_1, RPU_LS, 2, 6)
    DEP_FIELD(ERROR_POR_EN_1, FPD_TEMP, 1, 5)
    DEP_FIELD(ERROR_POR_EN_1, LPD_TEMP, 1, 4)
    DEP_FIELD(ERROR_POR_EN_1, RPU1, 1, 3)
    DEP_FIELD(ERROR_POR_EN_1, RPU0, 1, 2)
    DEP_FIELD(ERROR_POR_EN_1, OCM_ECC, 1, 1)
    DEP_FIELD(ERROR_POR_EN_1, DDR_ECC, 1, 0)
DEP_REG32(ERROR_POR_DIS_1, 0x558)
    DEP_FIELD(ERROR_POR_DIS_1, AUX3, 1, 31)
    DEP_FIELD(ERROR_POR_DIS_1, AUX2, 1, 30)
    DEP_FIELD(ERROR_POR_DIS_1, AUX1, 1, 29)
    DEP_FIELD(ERROR_POR_DIS_1, AUX0, 1, 28)
    DEP_FIELD(ERROR_POR_DIS_1, DFT, 1, 27)
    DEP_FIELD(ERROR_POR_DIS_1, CLK_MON, 1, 26)
    DEP_FIELD(ERROR_POR_DIS_1, XMPU, 2, 24)
    DEP_FIELD(ERROR_POR_DIS_1, PWR_SUPPLY, 8, 16)
    DEP_FIELD(ERROR_POR_DIS_1, FPD_SWDT, 1, 13)
    DEP_FIELD(ERROR_POR_DIS_1, LPD_SWDT, 1, 12)
    DEP_FIELD(ERROR_POR_DIS_1, RPU_CCF, 1, 9)
    DEP_FIELD(ERROR_POR_DIS_1, RPU_LS, 2, 6)
    DEP_FIELD(ERROR_POR_DIS_1, FPD_TEMP, 1, 5)
    DEP_FIELD(ERROR_POR_DIS_1, LPD_TEMP, 1, 4)
    DEP_FIELD(ERROR_POR_DIS_1, RPU1, 1, 3)
    DEP_FIELD(ERROR_POR_DIS_1, RPU0, 1, 2)
    DEP_FIELD(ERROR_POR_DIS_1, OCM_ECC, 1, 1)
    DEP_FIELD(ERROR_POR_DIS_1, DDR_ECC, 1, 0)
DEP_REG32(ERROR_POR_MASK_2, 0x55c)
    DEP_FIELD(ERROR_POR_MASK_2, CSU_ROM, 1, 26)
    DEP_FIELD(ERROR_POR_MASK_2, PMU_PB, 1, 25)
    DEP_FIELD(ERROR_POR_MASK_2, PMU_SERVICE, 1, 24)
    DEP_FIELD(ERROR_POR_MASK_2, PMU_FW, 4, 18)
    DEP_FIELD(ERROR_POR_MASK_2, PMU_UC, 1, 17)
    DEP_FIELD(ERROR_POR_MASK_2, CSU, 1, 16)
    DEP_FIELD(ERROR_POR_MASK_2, PLL_LOCK, 5, 8)
    DEP_FIELD(ERROR_POR_MASK_2, PL, 4, 2)
    DEP_FIELD(ERROR_POR_MASK_2, TO, 2, 0)
DEP_REG32(ERROR_POR_EN_2, 0x560)
    DEP_FIELD(ERROR_POR_EN_2, CSU_ROM, 1, 26)
    DEP_FIELD(ERROR_POR_EN_2, PMU_PB, 1, 25)
    DEP_FIELD(ERROR_POR_EN_2, PMU_SERVICE, 1, 24)
    DEP_FIELD(ERROR_POR_EN_2, PMU_FW, 4, 18)
    DEP_FIELD(ERROR_POR_EN_2, PMU_UC, 1, 17)
    DEP_FIELD(ERROR_POR_EN_2, CSU, 1, 16)
    DEP_FIELD(ERROR_POR_EN_2, PLL_LOCK, 5, 8)
    DEP_FIELD(ERROR_POR_EN_2, PL, 4, 2)
    DEP_FIELD(ERROR_POR_EN_2, TO, 2, 0)
DEP_REG32(ERROR_POR_DIS_2, 0x564)
    DEP_FIELD(ERROR_POR_DIS_2, CSU_ROM, 1, 26)
    DEP_FIELD(ERROR_POR_DIS_2, PMU_PB, 1, 25)
    DEP_FIELD(ERROR_POR_DIS_2, PMU_SERVICE, 1, 24)
    DEP_FIELD(ERROR_POR_DIS_2, PMU_FW, 4, 18)
    DEP_FIELD(ERROR_POR_DIS_2, PMU_UC, 1, 17)
    DEP_FIELD(ERROR_POR_DIS_2, CSU, 1, 16)
    DEP_FIELD(ERROR_POR_DIS_2, PLL_LOCK, 5, 8)
    DEP_FIELD(ERROR_POR_DIS_2, PL, 4, 2)
    DEP_FIELD(ERROR_POR_DIS_2, TO, 2, 0)
DEP_REG32(ERROR_SRST_MASK_1, 0x568)
    DEP_FIELD(ERROR_SRST_MASK_1, AUX3, 1, 31)
    DEP_FIELD(ERROR_SRST_MASK_1, AUX2, 1, 30)
    DEP_FIELD(ERROR_SRST_MASK_1, AUX1, 1, 29)
    DEP_FIELD(ERROR_SRST_MASK_1, AUX0, 1, 28)
    DEP_FIELD(ERROR_SRST_MASK_1, DFT, 1, 27)
    DEP_FIELD(ERROR_SRST_MASK_1, CLK_MON, 1, 26)
    DEP_FIELD(ERROR_SRST_MASK_1, XMPU, 2, 24)
    DEP_FIELD(ERROR_SRST_MASK_1, PWR_SUPPLY, 8, 16)
    DEP_FIELD(ERROR_SRST_MASK_1, FPD_SWDT, 1, 13)
    DEP_FIELD(ERROR_SRST_MASK_1, LPD_SWDT, 1, 12)
    DEP_FIELD(ERROR_SRST_MASK_1, RPU_CCF, 1, 9)
    DEP_FIELD(ERROR_SRST_MASK_1, RPU_LS, 2, 6)
    DEP_FIELD(ERROR_SRST_MASK_1, FPD_TEMP, 1, 5)
    DEP_FIELD(ERROR_SRST_MASK_1, LPD_TEMP, 1, 4)
    DEP_FIELD(ERROR_SRST_MASK_1, RPU1, 1, 3)
    DEP_FIELD(ERROR_SRST_MASK_1, RPU0, 1, 2)
    DEP_FIELD(ERROR_SRST_MASK_1, OCM_ECC, 1, 1)
    DEP_FIELD(ERROR_SRST_MASK_1, DDR_ECC, 1, 0)
DEP_REG32(ERROR_SRST_EN_1, 0x56c)
    DEP_FIELD(ERROR_SRST_EN_1, AUX3, 1, 31)
    DEP_FIELD(ERROR_SRST_EN_1, AUX2, 1, 30)
    DEP_FIELD(ERROR_SRST_EN_1, AUX1, 1, 29)
    DEP_FIELD(ERROR_SRST_EN_1, AUX0, 1, 28)
    DEP_FIELD(ERROR_SRST_EN_1, DFT, 1, 27)
    DEP_FIELD(ERROR_SRST_EN_1, CLK_MON, 1, 26)
    DEP_FIELD(ERROR_SRST_EN_1, XMPU, 2, 24)
    DEP_FIELD(ERROR_SRST_EN_1, PWR_SUPPLY, 8, 16)
    DEP_FIELD(ERROR_SRST_EN_1, FPD_SWDT, 1, 13)
    DEP_FIELD(ERROR_SRST_EN_1, LPD_SWDT, 1, 12)
    DEP_FIELD(ERROR_SRST_EN_1, RPU_CCF, 1, 9)
    DEP_FIELD(ERROR_SRST_EN_1, RPU_LS, 2, 6)
    DEP_FIELD(ERROR_SRST_EN_1, FPD_TEMP, 1, 5)
    DEP_FIELD(ERROR_SRST_EN_1, LPD_TEMP, 1, 4)
    DEP_FIELD(ERROR_SRST_EN_1, RPU1, 1, 3)
    DEP_FIELD(ERROR_SRST_EN_1, RPU0, 1, 2)
    DEP_FIELD(ERROR_SRST_EN_1, OCM_ECC, 1, 1)
    DEP_FIELD(ERROR_SRST_EN_1, DDR_ECC, 1, 0)
DEP_REG32(ERROR_SRST_DIS_1, 0x570)
    DEP_FIELD(ERROR_SRST_DIS_1, AUX3, 1, 31)
    DEP_FIELD(ERROR_SRST_DIS_1, AUX2, 1, 30)
    DEP_FIELD(ERROR_SRST_DIS_1, AUX1, 1, 29)
    DEP_FIELD(ERROR_SRST_DIS_1, AUX0, 1, 28)
    DEP_FIELD(ERROR_SRST_DIS_1, DFT, 1, 27)
    DEP_FIELD(ERROR_SRST_DIS_1, CLK_MON, 1, 26)
    DEP_FIELD(ERROR_SRST_DIS_1, XMPU, 2, 24)
    DEP_FIELD(ERROR_SRST_DIS_1, PWR_SUPPLY, 8, 16)
    DEP_FIELD(ERROR_SRST_DIS_1, FPD_SWDT, 1, 13)
    DEP_FIELD(ERROR_SRST_DIS_1, LPD_SWDT, 1, 12)
    DEP_FIELD(ERROR_SRST_DIS_1, RPU_CCF, 1, 9)
    DEP_FIELD(ERROR_SRST_DIS_1, RPU_LS, 2, 6)
    DEP_FIELD(ERROR_SRST_DIS_1, FPD_TEMP, 1, 5)
    DEP_FIELD(ERROR_SRST_DIS_1, LPD_TEMP, 1, 4)
    DEP_FIELD(ERROR_SRST_DIS_1, RPU1, 1, 3)
    DEP_FIELD(ERROR_SRST_DIS_1, RPU0, 1, 2)
    DEP_FIELD(ERROR_SRST_DIS_1, OCM_ECC, 1, 1)
    DEP_FIELD(ERROR_SRST_DIS_1, DDR_ECC, 1, 0)
DEP_REG32(ERROR_SRST_MASK_2, 0x574)
    DEP_FIELD(ERROR_SRST_MASK_2, CSU_ROM, 1, 26)
    DEP_FIELD(ERROR_SRST_MASK_2, PMU_PB, 1, 25)
    DEP_FIELD(ERROR_SRST_MASK_2, PMU_SERVICE, 1, 24)
    DEP_FIELD(ERROR_SRST_MASK_2, PMU_FW, 4, 18)
    DEP_FIELD(ERROR_SRST_MASK_2, PMU_UC, 1, 17)
    DEP_FIELD(ERROR_SRST_MASK_2, CSU, 1, 16)
    DEP_FIELD(ERROR_SRST_MASK_2, PLL_LOCK, 5, 8)
    DEP_FIELD(ERROR_SRST_MASK_2, PL, 4, 2)
    DEP_FIELD(ERROR_SRST_MASK_2, TO, 2, 0)
DEP_REG32(ERROR_SRST_EN_2, 0x578)
    DEP_FIELD(ERROR_SRST_EN_2, CSU_ROM, 1, 26)
    DEP_FIELD(ERROR_SRST_EN_2, PMU_PB, 1, 25)
    DEP_FIELD(ERROR_SRST_EN_2, PMU_SERVICE, 1, 24)
    DEP_FIELD(ERROR_SRST_EN_2, PMU_FW, 4, 18)
    DEP_FIELD(ERROR_SRST_EN_2, PMU_UC, 1, 17)
    DEP_FIELD(ERROR_SRST_EN_2, CSU, 1, 16)
    DEP_FIELD(ERROR_SRST_EN_2, PLL_LOCK, 5, 8)
    DEP_FIELD(ERROR_SRST_EN_2, PL, 4, 2)
    DEP_FIELD(ERROR_SRST_EN_2, TO, 2, 0)
DEP_REG32(ERROR_SRST_DIS_2, 0x57c)
    DEP_FIELD(ERROR_SRST_DIS_2, CSU_ROM, 1, 26)
    DEP_FIELD(ERROR_SRST_DIS_2, PMU_PB, 1, 25)
    DEP_FIELD(ERROR_SRST_DIS_2, PMU_SERVICE, 1, 24)
    DEP_FIELD(ERROR_SRST_DIS_2, PMU_FW, 4, 18)
    DEP_FIELD(ERROR_SRST_DIS_2, PMU_UC, 1, 17)
    DEP_FIELD(ERROR_SRST_DIS_2, CSU, 1, 16)
    DEP_FIELD(ERROR_SRST_DIS_2, PLL_LOCK, 5, 8)
    DEP_FIELD(ERROR_SRST_DIS_2, PL, 4, 2)
    DEP_FIELD(ERROR_SRST_DIS_2, TO, 2, 0)
DEP_REG32(ERROR_SIG_MASK_1, 0x580)
    DEP_FIELD(ERROR_SIG_MASK_1, AUX3, 1, 31)
    DEP_FIELD(ERROR_SIG_MASK_1, AUX2, 1, 30)
    DEP_FIELD(ERROR_SIG_MASK_1, AUX1, 1, 29)
    DEP_FIELD(ERROR_SIG_MASK_1, AUX0, 1, 28)
    DEP_FIELD(ERROR_SIG_MASK_1, DFT, 1, 27)
    DEP_FIELD(ERROR_SIG_MASK_1, CLK_MON, 1, 26)
    DEP_FIELD(ERROR_SIG_MASK_1, XMPU, 2, 24)
    DEP_FIELD(ERROR_SIG_MASK_1, PWR_SUPPLY, 8, 16)
    DEP_FIELD(ERROR_SIG_MASK_1, FPD_SWDT, 1, 13)
    DEP_FIELD(ERROR_SIG_MASK_1, LPD_SWDT, 1, 12)
    DEP_FIELD(ERROR_SIG_MASK_1, RPU_CCF, 1, 9)
    DEP_FIELD(ERROR_SIG_MASK_1, RPU_LS, 2, 6)
    DEP_FIELD(ERROR_SIG_MASK_1, FPD_TEMP, 1, 5)
    DEP_FIELD(ERROR_SIG_MASK_1, LPD_TEMP, 1, 4)
    DEP_FIELD(ERROR_SIG_MASK_1, RPU1, 1, 3)
    DEP_FIELD(ERROR_SIG_MASK_1, RPU0, 1, 2)
    DEP_FIELD(ERROR_SIG_MASK_1, OCM_ECC, 1, 1)
    DEP_FIELD(ERROR_SIG_MASK_1, DDR_ECC, 1, 0)
DEP_REG32(ERROR_SIG_EN_1, 0x584)
    DEP_FIELD(ERROR_SIG_EN_1, AUX3, 1, 31)
    DEP_FIELD(ERROR_SIG_EN_1, AUX2, 1, 30)
    DEP_FIELD(ERROR_SIG_EN_1, AUX1, 1, 29)
    DEP_FIELD(ERROR_SIG_EN_1, AUX0, 1, 28)
    DEP_FIELD(ERROR_SIG_EN_1, DFT, 1, 27)
    DEP_FIELD(ERROR_SIG_EN_1, CLK_MON, 1, 26)
    DEP_FIELD(ERROR_SIG_EN_1, XMPU, 2, 24)
    DEP_FIELD(ERROR_SIG_EN_1, PWR_SUPPLY, 8, 16)
    DEP_FIELD(ERROR_SIG_EN_1, FPD_SWDT, 1, 13)
    DEP_FIELD(ERROR_SIG_EN_1, LPD_SWDT, 1, 12)
    DEP_FIELD(ERROR_SIG_EN_1, RPU_CCF, 1, 9)
    DEP_FIELD(ERROR_SIG_EN_1, RPU_LS, 2, 6)
    DEP_FIELD(ERROR_SIG_EN_1, FPD_TEMP, 1, 5)
    DEP_FIELD(ERROR_SIG_EN_1, LPD_TEMP, 1, 4)
    DEP_FIELD(ERROR_SIG_EN_1, RPU1, 1, 3)
    DEP_FIELD(ERROR_SIG_EN_1, RPU0, 1, 2)
    DEP_FIELD(ERROR_SIG_EN_1, OCM_ECC, 1, 1)
    DEP_FIELD(ERROR_SIG_EN_1, DDR_ECC, 1, 0)
DEP_REG32(ERROR_SIG_DIS_1, 0x588)
    DEP_FIELD(ERROR_SIG_DIS_1, AUX3, 1, 31)
    DEP_FIELD(ERROR_SIG_DIS_1, AUX2, 1, 30)
    DEP_FIELD(ERROR_SIG_DIS_1, AUX1, 1, 29)
    DEP_FIELD(ERROR_SIG_DIS_1, AUX0, 1, 28)
    DEP_FIELD(ERROR_SIG_DIS_1, DFT, 1, 27)
    DEP_FIELD(ERROR_SIG_DIS_1, CLK_MON, 1, 26)
    DEP_FIELD(ERROR_SIG_DIS_1, XMPU, 2, 24)
    DEP_FIELD(ERROR_SIG_DIS_1, PWR_SUPPLY, 8, 16)
    DEP_FIELD(ERROR_SIG_DIS_1, FPD_SWDT, 1, 13)
    DEP_FIELD(ERROR_SIG_DIS_1, LPD_SWDT, 1, 12)
    DEP_FIELD(ERROR_SIG_DIS_1, RPU_CCF, 1, 9)
    DEP_FIELD(ERROR_SIG_DIS_1, RPU_LS, 2, 6)
    DEP_FIELD(ERROR_SIG_DIS_1, FPD_TEMP, 1, 5)
    DEP_FIELD(ERROR_SIG_DIS_1, LPD_TEMP, 1, 4)
    DEP_FIELD(ERROR_SIG_DIS_1, RPU1, 1, 3)
    DEP_FIELD(ERROR_SIG_DIS_1, RPU0, 1, 2)
    DEP_FIELD(ERROR_SIG_DIS_1, OCM_ECC, 1, 1)
    DEP_FIELD(ERROR_SIG_DIS_1, DDR_ECC, 1, 0)
DEP_REG32(ERROR_SIG_MASK_2, 0x58c)
    DEP_FIELD(ERROR_SIG_MASK_2, CSU_ROM, 1, 26)
    DEP_FIELD(ERROR_SIG_MASK_2, PMU_PB, 1, 25)
    DEP_FIELD(ERROR_SIG_MASK_2, PMU_SERVICE, 1, 24)
    DEP_FIELD(ERROR_SIG_MASK_2, PMU_FW, 4, 18)
    DEP_FIELD(ERROR_SIG_MASK_2, PMU_UC, 1, 17)
    DEP_FIELD(ERROR_SIG_MASK_2, CSU, 1, 16)
    DEP_FIELD(ERROR_SIG_MASK_2, PLL_LOCK, 5, 8)
    DEP_FIELD(ERROR_SIG_MASK_2, PL, 4, 2)
    DEP_FIELD(ERROR_SIG_MASK_2, TO, 2, 0)
DEP_REG32(ERROR_SIG_EN_2, 0x590)
    DEP_FIELD(ERROR_SIG_EN_2, CSU_ROM, 1, 26)
    DEP_FIELD(ERROR_SIG_EN_2, PMU_PB, 1, 25)
    DEP_FIELD(ERROR_SIG_EN_2, PMU_SERVICE, 1, 24)
    DEP_FIELD(ERROR_SIG_EN_2, PMU_FW, 4, 18)
    DEP_FIELD(ERROR_SIG_EN_2, PMU_UC, 1, 17)
    DEP_FIELD(ERROR_SIG_EN_2, CSU, 1, 16)
    DEP_FIELD(ERROR_SIG_EN_2, PLL_LOCK, 5, 8)
    DEP_FIELD(ERROR_SIG_EN_2, PL, 4, 2)
    DEP_FIELD(ERROR_SIG_EN_2, TO, 2, 0)
DEP_REG32(ERROR_SIG_DIS_2, 0x594)
    DEP_FIELD(ERROR_SIG_DIS_2, CSU_ROM, 1, 26)
    DEP_FIELD(ERROR_SIG_DIS_2, PMU_PB, 1, 25)
    DEP_FIELD(ERROR_SIG_DIS_2, PMU_SERVICE, 1, 24)
    DEP_FIELD(ERROR_SIG_DIS_2, PMU_FW, 4, 18)
    DEP_FIELD(ERROR_SIG_DIS_2, PMU_UC, 1, 17)
    DEP_FIELD(ERROR_SIG_DIS_2, CSU, 1, 16)
    DEP_FIELD(ERROR_SIG_DIS_2, PLL_LOCK, 5, 8)
    DEP_FIELD(ERROR_SIG_DIS_2, PL, 4, 2)
    DEP_FIELD(ERROR_SIG_DIS_2, TO, 2, 0)
DEP_REG32(ERROR_EN_1, 0x5A0)
    DEP_FIELD(ERROR_EN_1, AUX3, 1, 31)
    DEP_FIELD(ERROR_EN_1, AUX2, 1, 30)
    DEP_FIELD(ERROR_EN_1, AUX1, 1, 29)
    DEP_FIELD(ERROR_EN_1, AUX0, 1, 28)
    DEP_FIELD(ERROR_EN_1, DFT, 1, 27)
    DEP_FIELD(ERROR_EN_1, CLK_MON, 1, 26)
    DEP_FIELD(ERROR_EN_1, XMPU, 2, 24)
    DEP_FIELD(ERROR_EN_1, PWR_SUPPLY, 8, 16)
    DEP_FIELD(ERROR_EN_1, FPD_SWDT, 1, 13)
    DEP_FIELD(ERROR_EN_1, LPD_SWDT, 1, 12)
    DEP_FIELD(ERROR_EN_1, RPU_CCF, 1, 9)
    DEP_FIELD(ERROR_EN_1, RPU_LS, 2, 6)
    DEP_FIELD(ERROR_EN_1, FPD_TEMP, 1, 5)
    DEP_FIELD(ERROR_EN_1, LPD_TEMP, 1, 4)
    DEP_FIELD(ERROR_EN_1, RPU1, 1, 3)
    DEP_FIELD(ERROR_EN_1, RPU0, 1, 2)
    DEP_FIELD(ERROR_EN_1, OCM_ECC, 1, 1)
    DEP_FIELD(ERROR_EN_1, DDR_ECC, 1, 0)
DEP_REG32(ERROR_EN_2, 0x5A4)
    DEP_FIELD(ERROR_EN_2, CSU_ROM, 1, 26)
    DEP_FIELD(ERROR_EN_2, PMU_PB, 1, 25)
    DEP_FIELD(ERROR_EN_2, PMU_SERVICE, 1, 24)
    DEP_FIELD(ERROR_EN_2, PMU_FW, 4, 18)
    DEP_FIELD(ERROR_EN_2, PMU_UC, 1, 17)
    DEP_FIELD(ERROR_EN_2, CSU, 1, 16)
    DEP_FIELD(ERROR_EN_2, PLL_LOCK, 5, 8)
    DEP_FIELD(ERROR_EN_2, PL, 4, 2)
    DEP_FIELD(ERROR_EN_2, TO, 2, 0)
DEP_REG32(AIB_CNTRL, 0x600)
    DEP_FIELD(AIB_CNTRL, FPD_AFI_FS, 1, 3)
    DEP_FIELD(AIB_CNTRL, FPD_AFI_FM, 1, 2)
    DEP_FIELD(AIB_CNTRL, LPDAFI_FS, 1, 1)
    DEP_FIELD(AIB_CNTRL, LPDAFI_FM, 1, 0)
DEP_REG32(AIB_STATUS, 0x604)
    DEP_FIELD(AIB_STATUS, FPD_AFI_FS, 1, 3)
    DEP_FIELD(AIB_STATUS, FPD_AFI_FM, 1, 2)
    DEP_FIELD(AIB_STATUS, LPDAFI_FS, 1, 1)
    DEP_FIELD(AIB_STATUS, LPDAFI_FM, 1, 0)
DEP_REG32(GLOBAL_RESET, 0x608)
    DEP_FIELD(GLOBAL_RESET, PS_ONLY_RST, 1, 10)
    DEP_FIELD(GLOBAL_RESET, FPD_RST, 1, 9)
    DEP_FIELD(GLOBAL_RESET, RPU_LS_RST, 1, 8)
DEP_REG32(ROM_VALIDATION_STATUS, 0x610)
    DEP_FIELD(ROM_VALIDATION_STATUS, PASS, 1, 1)
    DEP_FIELD(ROM_VALIDATION_STATUS, DONE, 1, 0)
DEP_REG32(ROM_VALIDATION_DIGEST_0, 0x614)
DEP_REG32(ROM_VALIDATION_DIGEST_1, 0x618)
DEP_REG32(ROM_VALIDATION_DIGEST_2, 0x61c)
DEP_REG32(ROM_VALIDATION_DIGEST_3, 0x620)
DEP_REG32(ROM_VALIDATION_DIGEST_4, 0x624)
DEP_REG32(ROM_VALIDATION_DIGEST_5, 0x628)
DEP_REG32(ROM_VALIDATION_DIGEST_6, 0x62c)
DEP_REG32(ROM_VALIDATION_DIGEST_7, 0x630)
DEP_REG32(ROM_VALIDATION_DIGEST_8, 0x634)
DEP_REG32(ROM_VALIDATION_DIGEST_9, 0x638)
DEP_REG32(ROM_VALIDATION_DIGEST_10, 0x63c)
DEP_REG32(ROM_VALIDATION_DIGEST_11, 0x640)
DEP_REG32(SAFETY_GATE, 0x650)
DEP_REG32(MBIST_RST, 0x700)
DEP_REG32(MBIST_PG_EN, 0x704)
DEP_REG32(MBIST_SETUP, 0x708)
DEP_REG32(MBIST_DONE, 0x710)
DEP_REG32(MBIST_GOOD, 0x714)
DEP_REG32(SAFETY_CHK, 0x800)

#define R_MAX (R_SAFETY_CHK + 1)

typedef struct PMU_GLOBAL {
    SysBusDevice parent_obj;
    MemoryRegion iomem;
    qemu_irq irq_req_pwrdwn_int;
    qemu_irq irq_req_swrst_int;
    qemu_irq irq_req_logclr_int;
    qemu_irq irq_req_pwrup_int;
    qemu_irq irq_addr_error_int;
    qemu_irq irq_error_int_2;
    qemu_irq irq_error_int_1;
    qemu_irq irq_req_iso_int;

    bool fw_is_present;
    bool ignore_pwr_req;
    /* Record hardware error events, so error status register can be updated
     * if error is enabled in error enable register.
     */
    uint32_t error_1;
    uint32_t error_2;

    uint32_t regs[R_MAX];
    DepRegisterInfo regs_info[R_MAX];
} PMU_GLOBAL;

static void req_pwrdwn_int_update_irq(PMU_GLOBAL *s)
{
    bool pending = s->regs[R_REQ_PWRDWN_STATUS] & ~s->regs[R_REQ_PWRDWN_INT_MASK];
    qemu_set_irq(s->irq_req_pwrdwn_int, pending);
}

static void req_pwrdwn_status_postw(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    req_pwrdwn_int_update_irq(s);
}

static uint64_t req_pwrdwn_int_en_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_REQ_PWRDWN_INT_MASK] &= ~val;
    req_pwrdwn_int_update_irq(s);
    return 0;
}

static uint64_t req_pwrdwn_int_dis_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_REQ_PWRDWN_INT_MASK] |= val;
    req_pwrdwn_int_update_irq(s);
    return 0;
}

static uint64_t req_pwrdwn_trig_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_REQ_PWRDWN_STATUS] |= val;
    req_pwrdwn_int_update_irq(s);
    return 0;
}

static void req_swrst_int_update_irq(PMU_GLOBAL *s)
{
    bool pending = s->regs[R_REQ_SWRST_STATUS] & ~s->regs[R_REQ_SWRST_INT_MASK];
    qemu_set_irq(s->irq_req_swrst_int, pending);
}

static void req_swrst_status_postw(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    req_swrst_int_update_irq(s);
}

static uint64_t req_swrst_int_en_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_REQ_SWRST_INT_MASK] &= ~val;
    req_swrst_int_update_irq(s);
    return 0;
}

static uint64_t req_swrst_int_dis_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_REQ_SWRST_INT_MASK] |= val;
    req_swrst_int_update_irq(s);
    return 0;
}

static uint64_t req_swrst_trig_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_REQ_SWRST_STATUS] |= val;
    req_swrst_int_update_irq(s);
    return 0;
}

static void req_aux_int_update_irq(PMU_GLOBAL *s)
{
    bool pending = s->regs[R_REQ_AUX_STATUS] & ~s->regs[R_REQ_AUX_INT_MASK];
    qemu_set_irq(s->irq_req_logclr_int, pending);
}

static void req_aux_status_postw(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    req_aux_int_update_irq(s);
}

static uint64_t req_aux_int_en_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_REQ_AUX_INT_MASK] &= ~val;
    req_aux_int_update_irq(s);
    return 0;
}

static uint64_t req_aux_int_dis_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_REQ_AUX_INT_MASK] |= val;
    req_aux_int_update_irq(s);
    return 0;
}

static uint64_t req_aux_trig_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_REQ_AUX_STATUS] |= val;
    req_aux_int_update_irq(s);
    return 0;
}

static uint64_t error_srst_en_2_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_ERROR_SRST_MASK_2] &= ~val;
    return 0;
}

static uint64_t error_srst_dis_2_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_ERROR_SRST_MASK_2] |= val;
    return 0;
}

static uint64_t error_srst_en_1_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_ERROR_SRST_MASK_1] &= ~val;
    return 0;
}

static uint64_t error_srst_dis_1_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_ERROR_SRST_MASK_1] |= val;
    return 0;
}

static uint64_t error_sig_en_2_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_ERROR_SIG_MASK_2] &= ~val;
    return 0;
}

static uint64_t error_sig_dis_2_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_ERROR_SIG_MASK_2] |= val;
    return 0;
}

static void req_pwrup_int_update_irq(PMU_GLOBAL *s)
{
    bool pending = s->regs[R_REQ_PWRUP_STATUS] & ~s->regs[R_REQ_PWRUP_INT_MASK];
    qemu_set_irq(s->irq_req_pwrup_int, pending);
}

static void req_pwrup_status_postw(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    req_pwrup_int_update_irq(s);
}

static uint64_t req_pwrup_int_en_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_REQ_PWRUP_INT_MASK] &= ~val;
    req_pwrup_int_update_irq(s);
    return 0;
}

static uint64_t req_pwrup_int_dis_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_REQ_PWRUP_INT_MASK] |= val;
    req_pwrup_int_update_irq(s);
    return 0;
}

static uint64_t req_pwrup_trig_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    if (!s->ignore_pwr_req) {
        s->regs[R_REQ_PWRUP_STATUS] |= val;
    }
    req_pwrup_int_update_irq(s);
    return 0;
}

static uint64_t error_sig_en_1_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_ERROR_SIG_MASK_1] &= ~val;
    return 0;
}

static uint64_t error_sig_dis_1_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_ERROR_SIG_MASK_1] |= val;
    return 0;
}

static void addr_error_int_update_irq(PMU_GLOBAL *s)
{
    bool pending = s->regs[R_ADDR_ERROR_STATUS] & ~s->regs[R_ADDR_ERROR_INT_MASK];
    qemu_set_irq(s->irq_addr_error_int, pending);
}

static void addr_error_status_postw(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    addr_error_int_update_irq(s);
}

static uint64_t addr_error_int_en_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_ADDR_ERROR_INT_MASK] &= ~val;
    addr_error_int_update_irq(s);
    return 0;
}

static uint64_t addr_error_int_dis_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_ADDR_ERROR_INT_MASK] |= val;
    addr_error_int_update_irq(s);
    return 0;
}

static void error_int_2_update_irq(PMU_GLOBAL *s)
{
    bool pending = s->regs[R_ERROR_STATUS_2] & ~s->regs[R_ERROR_INT_MASK_2];
    qemu_set_irq(s->irq_error_int_2, pending);
}

static void error_status_2_postw(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    s->error_2 = val64;
    error_int_2_update_irq(s);
}

static uint64_t error_int_en_2_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_ERROR_INT_MASK_2] &= ~val;
    error_int_2_update_irq(s);
    return 0;
}

static uint64_t error_int_dis_2_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_ERROR_INT_MASK_2] |= val;
    error_int_2_update_irq(s);
    return 0;
}

static void error_int_1_update_irq(PMU_GLOBAL *s)
{
    bool pending = s->regs[R_ERROR_STATUS_1] & ~s->regs[R_ERROR_INT_MASK_1];
    qemu_set_irq(s->irq_error_int_1, pending);
}

/* Set error in ERROR_STATUS_1 register if it is enabled in ERROR_EN_1 and
 * error input is set.
 * Error is only cleared by explicitly writing a 1 to its corresponding
 * ERROR_STATUS_1 register bit.
 */
static void set_error_1(PMU_GLOBAL *s)
{
    s->regs[R_ERROR_STATUS_1] |= s->error_1 & s->regs[R_ERROR_EN_1];
    error_int_1_update_irq(s);
}

static void error_en_1_postw(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);

    set_error_1(s);
}

/* Set error in ERROR_STATUS_2 register if it is enabled in ERROR_EN_2 and
 * error input is set.
 * Error is only cleared by explicitly writing a 1 to its corresponding
 * ERROR_STATUS_2 register bit.
 */
static void set_error_2(PMU_GLOBAL *s)
{
    s->regs[R_ERROR_STATUS_2] |= s->error_2 & s->regs[R_ERROR_EN_2];
    error_int_2_update_irq(s);
}

static void error_en_2_postw(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);

    set_error_2(s);
}

static void error_status_1_postw(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    s->error_1 = val64;
    error_int_1_update_irq(s);
}

static uint64_t error_int_en_1_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_ERROR_INT_MASK_1] &= ~val;
    error_int_1_update_irq(s);
    return 0;
}

static uint64_t error_int_dis_1_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_ERROR_INT_MASK_1] |= val;
    error_int_1_update_irq(s);
    return 0;
}

static uint64_t error_por_en_2_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_ERROR_POR_MASK_2] &= ~val;
    return 0;
}

static uint64_t error_por_dis_2_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_ERROR_POR_MASK_2] |= val;
    return 0;
}

static uint64_t error_por_en_1_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_ERROR_POR_MASK_1] &= ~val;
    return 0;
}

static uint64_t error_por_dis_1_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_ERROR_POR_MASK_1] |= val;
    return 0;
}

static void req_iso_int_update_irq(PMU_GLOBAL *s)
{
    bool pending = s->regs[R_REQ_ISO_STATUS] & ~s->regs[R_REQ_ISO_INT_MASK];
    qemu_set_irq(s->irq_req_iso_int, pending);
}

static void req_iso_status_postw(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    req_iso_int_update_irq(s);
}

static uint64_t req_iso_int_en_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_REQ_ISO_INT_MASK] &= ~val;
    req_iso_int_update_irq(s);
    return 0;
}

static uint64_t req_iso_int_dis_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_REQ_ISO_INT_MASK] |= val;
    req_iso_int_update_irq(s);
    return 0;
}

static uint64_t req_iso_trig_prew(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);
    uint32_t val = val64;

    s->regs[R_REQ_ISO_STATUS] |= val;
    req_iso_int_update_irq(s);
    return 0;
}

static void mbist_rst_postw(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);

    /* Reset the MBIST_DONE, MBIST_GOOD registers */
    s->regs[R_MBIST_DONE] &= s->regs[R_MBIST_RST];
    s->regs[R_MBIST_GOOD] &= s->regs[R_MBIST_RST];
}

static void mbist_pg_en_postw(DepRegisterInfo *reg, uint64_t val64)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(reg->opaque);

    s->regs[R_MBIST_DONE] |= s->regs[R_MBIST_RST]
                           & s->regs[R_MBIST_SETUP] & s->regs[R_MBIST_PG_EN];
    s->regs[R_MBIST_GOOD] |= s->regs[R_MBIST_RST]
                           & s->regs[R_MBIST_SETUP] & s->regs[R_MBIST_PG_EN];
}

static DepRegisterAccessInfo pmu_global_regs_info[] = {
    {   .name = "GLOBAL_CNTRL",  .decode.addr = A_GLOBAL_CNTRL,
        .rsvd = 0xfffe00e8,
        .ro = 0xffff00e8,
        .reset = 0x00008800,
        .gpios = (DepRegisterGPIOMapping[]) {
            { .name = "pmu_wake", .bit_pos = 0, .width = 1 },
            {},
        }
    },{ .name = "PS_CNTRL",  .decode.addr = A_PS_CNTRL,
        .rsvd = 0xfffefffc,
        .ro = 0xfffffffc,
    },{ .name = "APU_PWR_STATUS_INIT",  .decode.addr = A_APU_PWR_STATUS_INIT,
        .rsvd = 0xfffffff0,
        .ro = 0xfffffff0,
    },{ .name = "ADDR_ERROR_STATUS",  .decode.addr = A_ADDR_ERROR_STATUS,
        .rsvd = 0xfffffffe,
        .ro = 0xfffffffe,
        .w1c = 0x1,
        .post_write = addr_error_status_postw,
    },{ .name = "ADDR_ERROR_INT_MASK",  .decode.addr = A_ADDR_ERROR_INT_MASK,
        .reset = 0x1,
        .rsvd = 0xfffffffe,
        .ro = 0xffffffff,
    },{ .name = "ADDR_ERROR_INT_EN",  .decode.addr = A_ADDR_ERROR_INT_EN,
        .pre_write = addr_error_int_en_prew,
    },{ .name = "ADDR_ERROR_INT_DIS",  .decode.addr = A_ADDR_ERROR_INT_DIS,
        .pre_write = addr_error_int_dis_prew,
    },{ .name = "GLOBAL_GEN_STORAGE0",  .decode.addr = A_GLOBAL_GEN_STORAGE0,
    },{ .name = "GLOBAL_GEN_STORAGE1",  .decode.addr = A_GLOBAL_GEN_STORAGE1,
    },{ .name = "GLOBAL_GEN_STORAGE2",  .decode.addr = A_GLOBAL_GEN_STORAGE2,
    },{ .name = "GLOBAL_GEN_STORAGE3",  .decode.addr = A_GLOBAL_GEN_STORAGE3,
    },{ .name = "GLOBAL_GEN_STORAGE4",  .decode.addr = A_GLOBAL_GEN_STORAGE4,
    },{ .name = "GLOBAL_GEN_STORAGE5",  .decode.addr = A_GLOBAL_GEN_STORAGE5,
    },{ .name = "GLOBAL_GEN_STORAGE6",  .decode.addr = A_GLOBAL_GEN_STORAGE6,
    },{ .name = "PERS_GLOB_GEN_STORAGE0",  .decode.addr = A_PERS_GLOB_GEN_STORAGE0,
        .inhibit_reset = 0xFFFFFFFF,
    },{ .name = "PERS_GLOB_GEN_STORAGE1",  .decode.addr = A_PERS_GLOB_GEN_STORAGE1,
        .inhibit_reset = 0xFFFFFFFF,
    },{ .name = "PERS_GLOB_GEN_STORAGE2",  .decode.addr = A_PERS_GLOB_GEN_STORAGE2,
        .inhibit_reset = 0xFFFFFFFF,
    },{ .name = "PERS_GLOB_GEN_STORAGE3",  .decode.addr = A_PERS_GLOB_GEN_STORAGE3,
        .inhibit_reset = 0xFFFFFFFF,
    },{ .name = "PERS_GLOB_GEN_STORAGE4",  .decode.addr = A_PERS_GLOB_GEN_STORAGE4,
        .inhibit_reset = 0xFFFFFFFF,
    },{ .name = "PERS_GLOB_GEN_STORAGE5",  .decode.addr = A_PERS_GLOB_GEN_STORAGE5,
        .inhibit_reset = 0xFFFFFFFF,
    },{ .name = "PERS_GLOB_GEN_STORAGE6",  .decode.addr = A_PERS_GLOB_GEN_STORAGE6,
        .inhibit_reset = 0xFFFFFFFF,
    },{ .name = "PERS_GLOB_GEN_STORAGE7",  .decode.addr = A_PERS_GLOB_GEN_STORAGE7,
        .inhibit_reset = 0xFFFFFFFF,
    },{ .name = "DDR_CNTRL",  .decode.addr = A_DDR_CNTRL,
        .rsvd = 0xfffffffe,
    },{ .name = "PWR_STATE",  .decode.addr = A_PWR_STATE,
        .reset = 0x00fffcbf,
        .rsvd = 0xff000340,
        .ro = 0xffffffff,
    },{ .name = "AUX_PWR_STATE",  .decode.addr = A_AUX_PWR_STATE,
        .reset = 0xff080,
        .rsvd = 0x7f00f7f,
        .ro = 0xffffffff,
    },{ .name = "RAM_RET_CNTRL",  .decode.addr = A_RAM_RET_CNTRL,
        .rsvd = 0xfff00f7f,
        .ro = 0xfff00f7f,
    },{ .name = "PWR_SUPPLY_STATUS",  .decode.addr = A_PWR_SUPPLY_STATUS,
        /* FIXME: Added 0x3 to reset bits so FPD will be
         * properly powered up by PMUROM.
         */
        .reset = 0x3,
        .rsvd = 0xfffffffc,
        .ro = 0xffffffff,
    },{ .name = "REQ_PWRUP_STATUS",  .decode.addr = A_REQ_PWRUP_STATUS,
        .rsvd = 0xff000b40,
        .ro = 0xff000b40,
        .w1c = 0xfff4bf,
        .post_write = req_pwrup_status_postw,
    },{ .name = "REQ_PWRUP_INT_MASK",  .decode.addr = A_REQ_PWRUP_INT_MASK,
        .reset = 0xfff4bf,
        .rsvd = 0xff000b40,
        .ro = 0xffffffff,
    },{ .name = "REQ_PWRUP_INT_EN",  .decode.addr = A_REQ_PWRUP_INT_EN,
        .pre_write = req_pwrup_int_en_prew,
    },{ .name = "REQ_PWRUP_INT_DIS",  .decode.addr = A_REQ_PWRUP_INT_DIS,
        .pre_write = req_pwrup_int_dis_prew,
    },{ .name = "REQ_PWRUP_TRIG",  .decode.addr = A_REQ_PWRUP_TRIG,
        .pre_write = req_pwrup_trig_prew,
    },{ .name = "REQ_PWRDWN_STATUS",  .decode.addr = A_REQ_PWRDWN_STATUS,
        .rsvd = 0xff000b40,
        .ro = 0xff000b40,
        .w1c = 0xfff4bf,
        .post_write = req_pwrdwn_status_postw,
    },{ .name = "REQ_PWRDWN_INT_MASK",  .decode.addr = A_REQ_PWRDWN_INT_MASK,
        .reset = 0xfff4bf,
        .rsvd = 0xff000b40,
        .ro = 0xffffffff,
    },{ .name = "REQ_PWRDWN_INT_EN",  .decode.addr = A_REQ_PWRDWN_INT_EN,
        .pre_write = req_pwrdwn_int_en_prew,
    },{ .name = "REQ_PWRDWN_INT_DIS",  .decode.addr = A_REQ_PWRDWN_INT_DIS,
        .pre_write = req_pwrdwn_int_dis_prew,
    },{ .name = "REQ_PWRDWN_TRIG",  .decode.addr = A_REQ_PWRDWN_TRIG,
        .pre_write = req_pwrdwn_trig_prew,
    },{ .name = "REQ_ISO_STATUS",  .decode.addr = A_REQ_ISO_STATUS,
        .rsvd = 0xffffffec,
        .ro = 0xffffffec,
        .w1c = 0x13,
        .post_write = req_iso_status_postw,
    },{ .name = "REQ_ISO_INT_MASK",  .decode.addr = A_REQ_ISO_INT_MASK,
        .reset = 0x13,
        .rsvd = 0xffffffec,
        .ro = 0xffffffff,
    },{ .name = "REQ_ISO_INT_EN",  .decode.addr = A_REQ_ISO_INT_EN,
        .pre_write = req_iso_int_en_prew,
    },{ .name = "REQ_ISO_INT_DIS",  .decode.addr = A_REQ_ISO_INT_DIS,
        .pre_write = req_iso_int_dis_prew,
    },{ .name = "REQ_ISO_TRIG",  .decode.addr = A_REQ_ISO_TRIG,
        .pre_write = req_iso_trig_prew,
    },{ .name = "REQ_SWRST_STATUS",  .decode.addr = A_REQ_SWRST_STATUS,
        .rsvd = 0x408e820,
        .ro = 0x408e820,
        .w1c = 0xfbf717df,
        .post_write = req_swrst_status_postw,
    },{ .name = "REQ_SWRST_INT_MASK",  .decode.addr = A_REQ_SWRST_INT_MASK,
        .reset = 0xfbf717df,
        .rsvd = 0x408e820,
        .ro = 0xffffffff,
    },{ .name = "REQ_SWRST_INT_EN",  .decode.addr = A_REQ_SWRST_INT_EN,
        .pre_write = req_swrst_int_en_prew,
    },{ .name = "REQ_SWRST_INT_DIS",  .decode.addr = A_REQ_SWRST_INT_DIS,
        .pre_write = req_swrst_int_dis_prew,
    },{ .name = "REQ_SWRST_TRIG",  .decode.addr = A_REQ_SWRST_TRIG,
        .pre_write = req_swrst_trig_prew,
    },{ .name = "REQ_AUX_STATUS",  .decode.addr = A_REQ_AUX_STATUS,
        .rsvd = 0xfffccb30,
        .ro = 0xfffccb30,
        .w1c = 0x334cf,
        .post_write = req_aux_status_postw,
    },{ .name = "REQ_AUX_INT_MASK",  .decode.addr = A_REQ_AUX_INT_MASK,
        .reset = 0x334cf,
        .rsvd = 0xfffccb30,
        .ro = 0xffffffff,
    },{ .name = "REQ_AUX_INT_EN",  .decode.addr = A_REQ_AUX_INT_EN,
        .pre_write = req_aux_int_en_prew,
    },{ .name = "REQ_AUX_INT_DIS",  .decode.addr = A_REQ_AUX_INT_DIS,
        .pre_write = req_aux_int_dis_prew,
    },{ .name = "REQ_AUX_TRIG",  .decode.addr = A_REQ_AUX_TRIG,
        .pre_write = req_aux_trig_prew,
    },{ .name = "LOGCLR_STATUS",  .decode.addr = A_LOGCLR_STATUS,
        .rsvd = 0xfffccb30,
        .ro = 0xffffffff,
    },{ .name = "CSU_BR_ERROR",  .decode.addr = A_CSU_BR_ERROR,
        .rsvd = 0x7fff0000,
        .ro = 0x7fff0000,
    },{ .name = "MB_FAULT_STATUS",  .decode.addr = A_MB_FAULT_STATUS,
        .rsvd = 0xf000f0,
        .ro = 0xffffffff,
    },{ .name = "ERROR_STATUS_1",  .decode.addr = A_ERROR_STATUS_1,
        .rsvd = 0xcd00,
        .ro = 0xcd00,
        .w1c = 0x3ff32ff,
        .post_write = error_status_1_postw,
    },{ .name = "ERROR_INT_MASK_1",  .decode.addr = A_ERROR_INT_MASK_1,
        .reset = 0x3ff32ff,
        .rsvd = 0xcd00,
        .ro = 0x3ffffff,
    },{ .name = "ERROR_INT_EN_1",  .decode.addr = A_ERROR_INT_EN_1,
        .rsvd = 0xcd00,
        .pre_write = error_int_en_1_prew,
    },{ .name = "ERROR_INT_DIS_1",  .decode.addr = A_ERROR_INT_DIS_1,
        .rsvd = 0xcd00,
        .pre_write = error_int_dis_1_prew,
    },{ .name = "ERROR_STATUS_2",  .decode.addr = A_ERROR_STATUS_2,
        .rsvd = 0xf8c0e0c0,
        .ro = 0xf8c0e0c0,
        .w1c = 0x73f1f3f,
        .post_write = error_status_2_postw,
    },{ .name = "ERROR_INT_MASK_2",  .decode.addr = A_ERROR_INT_MASK_2,
        .reset = 0x13f1f3f,
        .rsvd = 0xf8c0e0c0,
        .ro = 0xffffffff,
    },{ .name = "ERROR_INT_EN_2",  .decode.addr = A_ERROR_INT_EN_2,
        .rsvd = 0xf8c0e0c0,
        .pre_write = error_int_en_2_prew,
    },{ .name = "ERROR_INT_DIS_2",  .decode.addr = A_ERROR_INT_DIS_2,
        .rsvd = 0xf8c0e0c0,
        .pre_write = error_int_dis_2_prew,
    },{ .name = "ERROR_POR_MASK_1",  .decode.addr = A_ERROR_POR_MASK_1,
        .reset = 0x3ff32ff,
        .rsvd = 0xcd00,
        .ro = 0x3ffffff,
    },{ .name = "ERROR_POR_EN_1",  .decode.addr = A_ERROR_POR_EN_1,
        .rsvd = 0xcd00,
        .pre_write = error_por_en_1_prew,
    },{ .name = "ERROR_POR_DIS_1",  .decode.addr = A_ERROR_POR_DIS_1,
        .rsvd = 0xcd00,
        .pre_write = error_por_dis_1_prew,
    },{ .name = "ERROR_POR_MASK_2",  .decode.addr = A_ERROR_POR_MASK_2,
        .reset = 0x13f1f3f,
        .rsvd = 0xf8c0e0c0,
        .ro = 0xffffffff,
    },{ .name = "ERROR_POR_EN_2",  .decode.addr = A_ERROR_POR_EN_2,
        .rsvd = 0xf8c0e0c0,
        .pre_write = error_por_en_2_prew,
    },{ .name = "ERROR_POR_DIS_2",  .decode.addr = A_ERROR_POR_DIS_2,
        .rsvd = 0xf8c0e0c0,
        .pre_write = error_por_dis_2_prew,
    },{ .name = "ERROR_SRST_MASK_1",  .decode.addr = A_ERROR_SRST_MASK_1,
        .reset = 0x3ff32ff,
        .rsvd = 0xcd00,
        .ro = 0x3ffffff,
    },{ .name = "ERROR_SRST_EN_1",  .decode.addr = A_ERROR_SRST_EN_1,
        .rsvd = 0xcd00,
        .pre_write = error_srst_en_1_prew,
    },{ .name = "ERROR_SRST_DIS_1",  .decode.addr = A_ERROR_SRST_DIS_1,
        .rsvd = 0xcd00,
        .pre_write = error_srst_dis_1_prew,
    },{ .name = "ERROR_SRST_MASK_2",  .decode.addr = A_ERROR_SRST_MASK_2,
        .reset = 0x13f1f3f,
        .rsvd = 0xf8c0e0c0,
        .ro = 0xffffffff,
    },{ .name = "ERROR_SRST_EN_2",  .decode.addr = A_ERROR_SRST_EN_2,
        .rsvd = 0xf8c0e0c0,
        .pre_write = error_srst_en_2_prew,
    },{ .name = "ERROR_SRST_DIS_2",  .decode.addr = A_ERROR_SRST_DIS_2,
        .rsvd = 0xf8c0e0c0,
        .pre_write = error_srst_dis_2_prew,
    },{ .name = "ERROR_SIG_MASK_1",  .decode.addr = A_ERROR_SIG_MASK_1,
        .rsvd = 0xcd00,
        .ro = 0x3ffffff,
    },{ .name = "ERROR_SIG_EN_1",  .decode.addr = A_ERROR_SIG_EN_1,
        .rsvd = 0xcd00,
        .pre_write = error_sig_en_1_prew,
    },{ .name = "ERROR_SIG_DIS_1",  .decode.addr = A_ERROR_SIG_DIS_1,
        .rsvd = 0xcd00,
        .pre_write = error_sig_dis_1_prew,
    },{ .name = "ERROR_SIG_MASK_2",  .decode.addr = A_ERROR_SIG_MASK_2,
        .rsvd = 0xf8c0e0c0,
        .ro = 0xffffffff,
    },{ .name = "ERROR_SIG_EN_2",  .decode.addr = A_ERROR_SIG_EN_2,
        .rsvd = 0xf8c0e0c0,
        .pre_write = error_sig_en_2_prew,
    },{ .name = "ERROR_SIG_DIS_2",  .decode.addr = A_ERROR_SIG_DIS_2,
        .rsvd = 0xf8c0e0c0,
        .pre_write = error_sig_dis_2_prew,
    },{ .name = "ERROR_EN_1",  .decode.addr = A_ERROR_EN_1,
        .post_write = error_en_1_postw,
    },{ .name = "ERROR_EN_2",  .decode.addr = A_ERROR_EN_2,
        .post_write = error_en_2_postw,
    },{ .name = "AIB_CNTRL",  .decode.addr = A_AIB_CNTRL,
        .rsvd = 0xfffffff0,
    },{ .name = "AIB_STATUS",  .decode.addr = A_AIB_STATUS,
        .rsvd = 0xfffffff0,
        .ro = 0xffffffff,
    },{ .name = "GLOBAL_RESET",  .decode.addr = A_GLOBAL_RESET,
        .rsvd = 0xfffff8ff,
        .ro = 0xfffff8ff,
        .gpios = (DepRegisterGPIOMapping[]) {
            { .name = "FPD_RST", .bit_pos = 9, .width = 1 },
            { .name = "PS_ONLY_RST", .bit_pos = 10, .width = 1 },
            {},
        }
    },{ .name = "ROM_VALIDATION_STATUS",  .decode.addr = A_ROM_VALIDATION_STATUS,
        .rsvd = 0xfffffffc,
        .ro = 0xffffffff,
    },{ .name = "ROM_VALIDATION_DIGEST_0",  .decode.addr = A_ROM_VALIDATION_DIGEST_0,
        .ro = 0xffffffff,
    },{ .name = "ROM_VALIDATION_DIGEST_1",  .decode.addr = A_ROM_VALIDATION_DIGEST_1,
        .ro = 0xffffffff,
    },{ .name = "ROM_VALIDATION_DIGEST_2",  .decode.addr = A_ROM_VALIDATION_DIGEST_2,
        .ro = 0xffffffff,
    },{ .name = "ROM_VALIDATION_DIGEST_3",  .decode.addr = A_ROM_VALIDATION_DIGEST_3,
        .ro = 0xffffffff,
    },{ .name = "ROM_VALIDATION_DIGEST_4",  .decode.addr = A_ROM_VALIDATION_DIGEST_4,
        .ro = 0xffffffff,
    },{ .name = "ROM_VALIDATION_DIGEST_5",  .decode.addr = A_ROM_VALIDATION_DIGEST_5,
        .ro = 0xffffffff,
    },{ .name = "ROM_VALIDATION_DIGEST_6",  .decode.addr = A_ROM_VALIDATION_DIGEST_6,
        .ro = 0xffffffff,
    },{ .name = "ROM_VALIDATION_DIGEST_7",  .decode.addr = A_ROM_VALIDATION_DIGEST_7,
        .ro = 0xffffffff,
    },{ .name = "ROM_VALIDATION_DIGEST_8",  .decode.addr = A_ROM_VALIDATION_DIGEST_8,
        .ro = 0xffffffff,
    },{ .name = "ROM_VALIDATION_DIGEST_9",  .decode.addr = A_ROM_VALIDATION_DIGEST_9,
        .ro = 0xffffffff,
    },{ .name = "ROM_VALIDATION_DIGEST_10",  .decode.addr = A_ROM_VALIDATION_DIGEST_10,
        .ro = 0xffffffff,
    },{ .name = "ROM_VALIDATION_DIGEST_11",  .decode.addr = A_ROM_VALIDATION_DIGEST_11,
        .ro = 0xffffffff,
    },{ .name = "SAFETY_GATE",  .decode.addr = A_SAFETY_GATE,
    },{ .name = "MBIST_RST",  .decode.addr = A_MBIST_RST,
        .post_write = mbist_rst_postw,
    },{ .name = "MBIST_PG_EN",  .decode.addr = A_MBIST_PG_EN,
        .post_write = mbist_pg_en_postw,
    },{ .name = "MBIST_SETUP",  .decode.addr = A_MBIST_SETUP,
    },{ .name = "MBIST_DONE",  .decode.addr = A_MBIST_DONE, .ro = 0xffffffff,
    },{ .name = "MBIST_GOOD",  .decode.addr = A_MBIST_GOOD, .ro = 0xffffffff,
    },{ .name = "SAFETY_CHK",  .decode.addr = A_SAFETY_CHK,
    }
};

static void pmu_global_reset(DeviceState *dev)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(dev);
    unsigned int i;

    for (i = 0; i < ARRAY_SIZE(s->regs_info); ++i) {
        dep_register_reset(&s->regs_info[i]);
    }

    s->error_1 = 0;
    s->error_2 = 0;

    req_pwrdwn_int_update_irq(s);
    req_swrst_int_update_irq(s);
    req_aux_int_update_irq(s);
    req_pwrup_int_update_irq(s);
    addr_error_int_update_irq(s);
    error_int_2_update_irq(s);
    error_int_1_update_irq(s);
    req_iso_int_update_irq(s);

    DEP_AF_DP32(s->regs, GLOBAL_CNTRL, FW_IS_PRESENT, s->fw_is_present);
}

static void pwr_state_handler(void *opaque, int n, int level)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(opaque);

    s->regs[R_PWR_STATE] = deposit32(s->regs[R_PWR_STATE], n, 1, level);
}

static void error_handler(void *opaque, int n, int level)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(opaque);

    /* First 32 gpios are for ERROR_STATUS_1 */
    if (n < 32) {
        s->error_1 = deposit32(s->error_1, n, 1, level);
        set_error_1(s);
    } else {
        s->error_2 = deposit32(s->error_2, n, 1, level);
        set_error_2(s);
    }
}

static uint64_t pmu_global_read(void *opaque, hwaddr addr, unsigned size,
                                MemTxAttrs attr)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(opaque);
    DepRegisterInfo *r = &s->regs_info[addr / 4];

    if (!r->data) {
        qemu_log("%s: Decode error: read from %" HWADDR_PRIx "\n",
                 object_get_canonical_path(OBJECT(s)),
                 addr);
        s->regs[R_ADDR_ERROR_STATUS] |= R_ADDR_ERROR_STATUS_STATUS_MASK;
        addr_error_int_update_irq(s);
        return 0;
    }
    return dep_register_read(r);
}

static void pmu_global_write(void *opaque, hwaddr addr, uint64_t value,
                      unsigned size, MemTxAttrs attr)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(opaque);
    DepRegisterInfo *r = &s->regs_info[addr / 4];

    if (!r->data) {
        qemu_log("%s: Decode error: write to %" HWADDR_PRIx "=%" PRIx64 "\n",
                 object_get_canonical_path(OBJECT(s)),
                 addr, value);
        s->regs[R_ADDR_ERROR_STATUS] |= R_ADDR_ERROR_STATUS_STATUS_MASK;
        addr_error_int_update_irq(s);
        return;
    }
    dep_register_write(r, value, ~0);
}

static void pmu_global_access(MemoryTransaction *tr)
{
    MemTxAttrs attr = tr->attr;
    void *opaque = tr->opaque;
    hwaddr addr = tr->addr;
    unsigned size = tr->size;
    uint64_t value = tr->data.u64;;
    bool is_write = tr->rw;

    if (!attr.secure) {
        /* Ignore NS accesses.  */
        if (!is_write) {
            tr->data.u64 = 0;
        }
        qemu_log_mask(LOG_GUEST_ERROR,
                      "Non secure accesses to PMU global are invalid\n");
        return;
    }

    if (is_write) {
        pmu_global_write(opaque, addr, value, size, attr);
    } else {
        tr->data.u64 = pmu_global_read(opaque, addr, size, attr);
    }
}

static const MemoryRegionOps pmu_global_ops = {
    .access = pmu_global_access,
    .endianness = DEVICE_LITTLE_ENDIAN,
    .valid = {
        .min_access_size = 4,
        .max_access_size = 4,
    },
};

static void gpio_mb_sleep_h(void *opaque, int n, int level)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(opaque);
    DEP_AF_DP32(s->regs, GLOBAL_CNTRL, MB_SLEEP, !!level);
}

static void pmu_global_realize(DeviceState *dev, Error **errp)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(dev);
    const char *prefix = object_get_canonical_path(OBJECT(dev));
    unsigned int i;

    for (i = 0; i < ARRAY_SIZE(pmu_global_regs_info); ++i) {
        DepRegisterInfo *r = &s->regs_info[pmu_global_regs_info[i].decode.addr/4];

        *r = (DepRegisterInfo) {
            .data = (uint8_t *)&s->regs[
                    pmu_global_regs_info[i].decode.addr/4],
            .data_size = sizeof(uint32_t),
            .access = &pmu_global_regs_info[i],
            .debug = XILINX_PMU_GLOBAL_ERR_DEBUG,
            .prefix = prefix,
            .opaque = s,
        };
        dep_register_init(r);
        qdev_pass_all_gpios(DEVICE(r), dev);
    }
}

static void pmu_global_init(Object *obj)
{
    PMU_GLOBAL *s = XILINX_PMU_GLOBAL(obj);
    SysBusDevice *sbd = SYS_BUS_DEVICE(obj);

    memory_region_init_io(&s->iomem, obj, &pmu_global_ops, s,
                          TYPE_XILINX_PMU_GLOBAL, R_MAX * 4);
    sysbus_init_mmio(sbd, &s->iomem);
    sysbus_init_irq(sbd, &s->irq_req_logclr_int); /* 23 */
    sysbus_init_irq(sbd, &s->irq_req_iso_int);    /* 24 */
    sysbus_init_irq(sbd, &s->irq_req_swrst_int);  /* 26 */
    sysbus_init_irq(sbd, &s->irq_req_pwrup_int);  /* 27 */
    sysbus_init_irq(sbd, &s->irq_req_pwrdwn_int); /* 28 */
    sysbus_init_irq(sbd, &s->irq_addr_error_int); /* 29 */

    qdev_init_gpio_in_named(DEVICE(obj), gpio_mb_sleep_h, "mb_sleep", 1);
    qdev_init_gpio_in_named(DEVICE(obj), pwr_state_handler, "pwr_state", 24);
    qdev_init_gpio_out_named(DEVICE(obj), &s->irq_error_int_1,
                             "error_1_out", 1);
    qdev_init_gpio_out_named(DEVICE(obj), &s->irq_error_int_2,
                             "error_2_out", 1);

    /* GPIOs that can be used from qtest */
    qdev_init_gpio_in(DEVICE(obj), error_handler, 64);
}

static const VMStateDescription vmstate_pmu_global = {
    .name = TYPE_XILINX_PMU_GLOBAL,
    .version_id = 1,
    .minimum_version_id = 1,
    .minimum_version_id_old = 1,
    .fields = (VMStateField[]) {
        VMSTATE_UINT32_ARRAY(regs, PMU_GLOBAL, R_MAX),
        VMSTATE_END_OF_LIST(),
    }
};

static const FDTGenericGPIOSet pmu_gpios[] = {
    {
      .names = &fdt_generic_gpio_name_set_gpio,
      .gpios = (FDTGenericGPIOConnection[]) {
        { .name = "pmu_wake", .fdt_index = 0 },
        { .name = "FPD_RST", .fdt_index = 2 },
        { .name = "PS_ONLY_RST", .fdt_index = 3 },
        { },
      },
    },
    { },
};

static const FDTGenericGPIONameSet pwr_state_gpios_names = {
    .propname = "pwr-state-gpios",
    .cells_propname = "#gpio-cells",
    .names_propname = "pwr-state-gpio-names",
};

static const FDTGenericGPIONameSet error_out_gpios_names = {
    .propname = "error-out-gpios",
    .cells_propname = "#gpio-cells",
    .names_propname = "error-out-names",
};

static const FDTGenericGPIOSet pmu_global_client_gpios[] = {
    {
      .names = &pwr_state_gpios_names,
      .gpios = (FDTGenericGPIOConnection[]) {
        { .name = "pwr_state", .fdt_index = 0, .range = 24 },
        { },
      },
    },
    {
      .names = &fdt_generic_gpio_name_set_gpio,
      .gpios = (FDTGenericGPIOConnection[]) {
        { .name = "mb_sleep", .fdt_index = 1 },
        { },
      },
    },
    {
      .names = &error_out_gpios_names,
      .gpios = (FDTGenericGPIOConnection[]) {
        { .name = "error_1_out", .fdt_index = 0 },
        { .name = "error_2_out", .fdt_index = 1 },
        { },
      },
    },
    { },
};

static Property pmu_global_properties[] = {
    DEFINE_PROP_BOOL("fw-is-present", PMU_GLOBAL, fw_is_present, false),
    DEFINE_PROP_BOOL("ignore-pwr-req", PMU_GLOBAL, ignore_pwr_req, false),
    DEFINE_PROP_END_OF_LIST(),
};

static void pmu_global_class_init(ObjectClass *klass, void *data)
{
    DeviceClass *dc = DEVICE_CLASS(klass);
    FDTGenericGPIOClass *fggc = FDT_GENERIC_GPIO_CLASS(klass);

    dc->reset = pmu_global_reset;
    dc->realize = pmu_global_realize;
    dc->vmsd = &vmstate_pmu_global;
    dc->props = pmu_global_properties;
    fggc->controller_gpios = pmu_gpios;
    fggc->client_gpios = pmu_global_client_gpios;
}

static const TypeInfo pmu_global_info = {
    .name          = TYPE_XILINX_PMU_GLOBAL,
    .parent        = TYPE_SYS_BUS_DEVICE,
    .instance_size = sizeof(PMU_GLOBAL),
    .class_init    = pmu_global_class_init,
    .instance_init = pmu_global_init,
    .interfaces    = (InterfaceInfo[]) {
        { TYPE_FDT_GENERIC_GPIO },
        { }
    },
};

static void pmu_global_register_types(void)
{
    type_register_static(&pmu_global_info);
}

type_init(pmu_global_register_types)
